/***********************************************************************************************************************
* Copyright (C) All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* @file    lin.h
* @brief   This file implements device driver for LIN module.
* @version 1.0.0 
* @date    2022/2/25
***********************************************************************************************************************/
#include <stdint.h>

void LIN_Master_Init(void);     /* init Master LIN*/
void LIN_Master_HeaderTransmit(uint8_t ID);
void LIN_Master_Receive(uint8_t Data_length);
void LIN_Master_Transmit(uint8_t * databuf,uint8_t Data_length);
void LIN_Master_GetData(void);

void LIN_Slave_Init(void);      /* init Slave LIN*/
void LIN_Slave_HeaderReceive(void);
void LIN_Slave_Transmit(uint8_t* databuf,uint8_t Data_length);
void LIN_Slave_Receive(uint8_t Data_length);
void LIN_Slave_NoResponse(void);

void Clear_DataBuffer(void);
uint8_t Get_response_RxData(uint8_t * RxData);
void LIN_unInit(void);
