/***********************************************************************************************************************
* Copyright (C) All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* @file    intp_user.c
* @brief   This file implements device driver for INTP module.
* @version 1.0.0
* @date    2022/2/25
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "userdefine.h"
#include "BAT32G113.h"
#include "intp.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/

/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
volatile uint32_t g_intp0Taken;  	/* INTP0 taken */
volatile uint32_t g_intp1Taken;  	/* INTP1 taken */
volatile uint32_t g_intp2Taken;  	/* INTP2 taken */
volatile uint32_t g_intp3Taken;  	/* INTP3 taken */
volatile uint32_t g_intp4Taken;  	/* INTP4 taken */
volatile uint32_t g_intp5Taken;  	/* INTP5 taken */
volatile uint32_t g_intp6Taken;  	/* INTP6 taken */
volatile uint32_t g_intp7Taken;  	/* INTP7 taken */
volatile uint32_t g_intp8Taken;  	/* INTP8 taken */
volatile uint32_t g_intp9Taken;  	/* INTP9 taken */
volatile uint32_t g_intp10Taken;  	/* INTP10 taken */
volatile uint32_t g_intp11Taken;  	/* INTP11 taken */

/***********************************************************************************************************************
* Function Name: intp0_interrupt
* @brief  INTP0 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp0_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP0_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp0Taken++;
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: intp6_interrupt
* @brief  INTP6 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp6_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP6_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp6Taken++;
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: intp1_interrupt
* @brief  INTP1 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp1_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP1_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp1Taken++;
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: intp7_interrupt
* @brief  INTP7 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp7_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP7_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp7Taken++;
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: intp2_interrupt
* @brief  INTP2 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp2_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP2_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp2Taken++;
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: intp8_interrupt
* @brief  INTP8 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp8_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP8_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp8Taken++;
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: intp3_interrupt
* @brief  INTP3 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp3_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP3_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp3Taken++;
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: intp9_interrupt
* @brief  INTP9 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp9_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP9_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp9Taken++;
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: intp4_interrupt
* @brief  INTP4 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp4_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP4_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp4Taken++;
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: intp10_interrupt
* @brief  INTP10 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp10_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP10_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp10Taken++;
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: intp5_interrupt
* @brief  INTP5 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp5_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP5_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp5Taken++;
    /* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: intp11_interrupt
* @brief  INTP11 interrupt entry
* @param  None
* @return None
***********************************************************************************************************************/
void intp11_interrupt(void)
{
    
        INTC_ClearPendingIRQ(INTP11_IRQn);
    
    /* Start user code. Do not edit comment generated here */
    g_intp11Taken++;
    /* End user code. Do not edit comment generated here */
}

void IRQ01_Handler(void)
{
		if(INTC_GetPendingIRQ(INTP0_IRQn))
		{
			intp0_interrupt();
		}
		
		if(INTC_GetPendingIRQ(INTP6_IRQn))
		{
			intp6_interrupt();
		}
		
}

void IRQ02_Handler(void)
{
		if(INTC_GetPendingIRQ(INTP1_IRQn))
		{
			intp1_interrupt();
		}
		
		if(INTC_GetPendingIRQ(INTP7_IRQn))
		{
			intp7_interrupt();
		}
		
}

void IRQ03_Handler(void)
{
		if(INTC_GetPendingIRQ(INTP2_IRQn))
		{
			intp2_interrupt();
		}
		
		if(INTC_GetPendingIRQ(INTP8_IRQn))
		{
			intp8_interrupt();
		}
		
}

void IRQ04_Handler(void)
{
		if(INTC_GetPendingIRQ(INTP3_IRQn))
		{
			intp3_interrupt();
		}
		
		if(INTC_GetPendingIRQ(INTP9_IRQn))
		{
			intp9_interrupt();
		}
		
}

void IRQ05_Handler(void)
{
		if(INTC_GetPendingIRQ(INTP4_IRQn))
		{
			intp4_interrupt();
		}
		
		if(INTC_GetPendingIRQ(INTP10_IRQn))
		{
			intp10_interrupt();
		}
		
}

void IRQ06_Handler(void)
{
		if(INTC_GetPendingIRQ(INTP5_IRQn))
		{
			intp5_interrupt();
		}
		
		if(INTC_GetPendingIRQ(INTP11_IRQn))
		{
			intp11_interrupt();
		}
		
}
/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
