/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32G113
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/2/25
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "BAT32G113.h"
#include "userdefine.h"
#include "flash.h"
#include "sci.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
volatile uint32_t g_ticks;

uint32_t buf[128];

void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks);
}

int main()
 {
	MD_STATUS status;
	uint32_t i, dat, err;
	uint32_t exp_value[17] = {0xFFFFFF00, 0xFFFF1100, 0xFF221100, 0x33221100,
	                          0xFFFF00FF, 0xFF1100FF, 0x221100FF, 0x221100FF, 
	                          0xFF00FF33, 0x1100FFFF, 0x1100FFFF, 0x1100FF22, 
	                          0x00FF3322, 0x00FFFFFF, 0x00FFFF11, 0x00FF2211, 
	                          0xFF332211
                           };
	uint32_t *w_ptr;
	uint32_t *r_ptr;
	uint8_t  *b_ptr;
	uint8_t tmp[] = "Use flash_write function is recommented!!";
	
//-----------------------------------------------------------------------
// Init UART0 for retarget printf/scanf etc. 
//----------------------------------------------------------------------- 
	SystemCoreClockUpdate();
	status = UART0_Init(SystemCoreClock, 19200);
	if(status == MD_ERROR)
	{
		while(1); // The baud rate cannot get at the current system clock frequency.
	}

	printf("Hello, UART\n");
	
//-----------------------------------------------------------------------
// use the flash_write function write blank area
//-----------------------------------------------------------------------	
	tmp[0] = 0x00;
	tmp[1] = 0x11;
	tmp[2] = 0x22;
	tmp[3] = 0x33;
	tmp[4] = 0x44;
	tmp[5] = 0x55;
	tmp[6] = 0x66;
	tmp[7] = 0x88;
	EraseSector(0x4000);	
	flash_write(0x4000, 1, (uint8_t *)tmp);
	flash_write(0x4004, 2, (uint8_t *)tmp);
	flash_write(0x4008, 3, (uint8_t *)tmp);
	flash_write(0x400C, 4, (uint8_t *)tmp);
	flash_write(0x4011, 1, (uint8_t *)tmp);
	flash_write(0x4015, 2, (uint8_t *)tmp);
	flash_write(0x4019, 3, (uint8_t *)tmp);
	flash_write(0x401D, 4, (uint8_t *)tmp);
	flash_write(0x4022, 1, (uint8_t *)tmp);
	flash_write(0x4026, 2, (uint8_t *)tmp);
	flash_write(0x402A, 3, (uint8_t *)tmp);
	flash_write(0x402E, 4, (uint8_t *)tmp);
	flash_write(0x4033, 1, (uint8_t *)tmp);
	flash_write(0x4037, 2, (uint8_t *)tmp);
	flash_write(0x403B, 3, (uint8_t *)tmp);
	flash_write(0x403F, 4, (uint8_t *)tmp);
	
	r_ptr = (uint32_t *)0x4000;
	err = 0;
	for(i=0; i<sizeof(exp_value)/sizeof(exp_value[0]); i++)
	{
		if(*r_ptr++ != exp_value[i]) 
		{
			err++;
		}
	}
	if(err)
	{
		printf("Byte Write is ERROR!\n");
	}
	else
	{
		printf("Byte Write is DONE!\n");
	}

    while(1){
    }
}

/***********************************************************************************************************************
* Function Name: SysTick Handler
* Description  : Decreament the g_ticks value
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void SysTick_Handler(void)
{
	g_ticks--;
}

