/*
 * ARM Limited (ARM) is supplying this software for use with Cortex-M
 * processor based microcontroller, but can be equally used for other
 * suitable processor architectures. This file can be freely distributed.
 * Modifications to this file shall be clearly marked.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * ARM SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * @file     BAT32G113.h
 * @brief    CMSIS HeaderFile
 * @version  1.2
 * @date     03. April 2023
 * @note     Generated by SVDConv V3.3.18 on Monday, 03.04.2023 11:45:49
 *           from File 'Files/SVD/BAT32G113.svd',
 *           last modified on Monday, 03.04.2023 03:39:26
 */



/** @addtogroup CMS
  * @{
  */


/** @addtogroup BAT32G113
  * @{
  */


#ifndef BAT32G113_H
#define BAT32G113_H

#ifdef __cplusplus
extern "C" {
#endif


/** @addtogroup Configuration_of_CMSIS
  * @{
  */



/* =========================================================================================================================== */
/* ================                                Interrupt Number Definition                                ================ */
/* =========================================================================================================================== */

typedef enum {
/* =======================================  ARM Cortex-M0+ Specific Interrupt Numbers  ======================================= */
  Reset_IRQn                = -15,              /*!< -15  Reset Vector, invoked on Power up and warm reset                     */
  NonMaskableInt_IRQn       = -14,              /*!< -14  Non maskable Interrupt, cannot be stopped or preempted               */
  HardFault_IRQn            = -13,              /*!< -13  Hard Fault, all classes of Fault                                     */
  SVCall_IRQn               =  -5,              /*!< -5 System Service Call via SVC instruction                                */
  PendSV_IRQn               =  -2,              /*!< -2 Pendable request for system service                                    */
  SysTick_IRQn              =  -1,              /*!< -1 System Tick Timer                                                      */
/* =========================================  BAT32G113 Specific Interrupt Numbers  ========================================== */
  LVI_IRQn                  =   0,              /*!< 0  Low Voltage detection interrupt                                        */
  INTP0_IRQn                =   1,              /*!< 1  INTP0 External interrupt request input is valid                        */
  INTP1_IRQn                =   2,              /*!< 2  INTP1 External interrupt request input is valid                        */
  INTP2_IRQn                =   3,              /*!< 3  INTP2 External interrupt request input is valid                        */
  INTP3_IRQn                =   4,              /*!< 4  INTP3 External interrupt request input is valid                        */
  INTP4_IRQn                =   5,              /*!< 5  INTP4 External interrupt request input is valid                        */
  INTP5_IRQn                =   6,              /*!< 6  INTP5 External interrupt request input is valid                        */
  ST2_IRQn                  =   7,              /*!< 7  UART2 transmission transfer end or buffer empty                        */
  SPI20_IRQn                =   7,              /*!< 7  SPI20 transfer end or buffer empty                                     */
  IIC20_IRQn                =   7,              /*!< 7  IIC20 transfer end                                                     */
  SR2_IRQn                  =   8,              /*!< 8  UART2 rerception transfer                                              */
  SRE2_IRQn                 =   9,              /*!< 9  UART2 rerception communication error occurrence                        */
  ST0_IRQn                  =  10,              /*!< 10 UART0 transmission transfer end or buffer empty                        */
  SPI00_IRQn                =  10,              /*!< 10 SPI00 transfer end or buffer empty                                     */
  IIC00_IRQn                =  10,              /*!< 10 IIC00 transfer end                                                     */
  SR0_IRQn                  =  11,              /*!< 11 UART0 rerception transfer                                              */
  SRE0_IRQn                 =  12,              /*!< 12 UART0 rerception communication error occurrence                        */
  LINT_IRQn                 =  13,              /*!< 13 LIN transmission                                                       */
  LINR_IRQn                 =  14,              /*!< 14 LIN reception end                                                      */
  LINS_IRQn                 =  15,              /*!< 15 LIN status                                                             */
  IICA_IRQn                 =  16,              /*!< 16 IICA interrupt request                                                 */
  TM00_IRQn                 =  17,              /*!< 17 TM4 channel 0 interrupt request                                        */
  TM01_IRQn                 =  18,              /*!< 18 TM4 channel 1 interrupt request                                        */
  TM02_IRQn                 =  19,              /*!< 19 TM4 channel 2 interrupt request                                        */
  TM03_IRQn                 =  20,              /*!< 20 TM4 channel 3 interrupt request                                        */
  ADC_IRQn                  =  21,              /*!< 21 ADC interrupt request                                                  */
  CMP0_IRQn                 =  24,              /*!< 24 CMP0 interrupt request                                                 */
  CMP1_IRQn                 =  25,              /*!< 25 CMP1 interrupt request                                                 */
  TMA_IRQn                  =  26,              /*!< 26 TMA interrupt request                                                  */
  TMM0_IRQn                 =  27,              /*!< 27 TMM channel 0 interrupt request                                        */
  TMM1_IRQn                 =  28,              /*!< 28 TMM channel 1 interrupt request                                        */
  TMB_IRQn                  =  29,              /*!< 29 TMB interrupt request                                                  */
  TMC_IRQn                  =  30,              /*!< 30 TMC interrupt request                                                  */
  FMC_IRQn                  =  31,              /*!< 31 Flash erase or write finish                                            */
  INTP6_IRQn                =  33,              /*!< 33 INTP6 External interrupt request input is valid                        */
  INTP7_IRQn                =  34,              /*!< 34 INTP7 External interrupt request input is valid                        */
  INTP8_IRQn                =  35,              /*!< 35 INTP8 External interrupt request input is valid                        */
  INTP9_IRQn                =  36,              /*!< 36 INTP9 External interrupt request input is valid                        */
  INTP10_IRQn               =  37,              /*!< 37 INTP10 External interrupt request input is valid                       */
  INTP11_IRQn               =  38,              /*!< 38 INTP11 External interrupt request input is valid                       */
  SPIHS0_IRQn               =  41,              /*!< 41 SPIHS0 interrupt request                                               */
  TM01H_IRQn                =  44,              /*!< 44 TM4 channel 0 (8bit) interrupt request                                 */
  LINM_IRQn                 =  46,              /*!< 46 LIN mix interrupt request                                              */
  TM03H_IRQn                =  47,              /*!< 47 TM4 channel 3 (8bit) interrupt request                                 */
  DIV_IRQn                  =  48               /*!< 48 Hardware divider interrupt                                             */
} IRQn_Type;



/* =========================================================================================================================== */
/* ================                           Processor and Core Peripheral Section                           ================ */
/* =========================================================================================================================== */

/* ==========================  Configuration of the ARM Cortex-M0+ Processor and Core Peripherals  =========================== */
#define __CM0PLUS_REV                 0x0001U   /*!< CM0PLUS Core Revision                                                     */
#define __MPU_PRESENT             	   1        /*!< Set to 1 if MPU is present                                                */
#define __VTOR_PRESENT                 1        /*!< Set to 1 if CPU supports Vector Table Offset Register                     */
#define __NVIC_PRIO_BITS               2        /*!< Number of Bits used for Priority Levels                                   */
#define __Vendor_SysTickConfig         0        /*!< Set to 1 if different SysTick Config is used                              */
#define __FPU_PRESENT             	   0        /*!< Set to 1 if FPU is present                                                */


/** @} */ /* End of group Configuration_of_CMSIS */

#include "core_cm0plus.h"                       /*!< ARM Cortex-M0+ processor and core peripherals                             */
#include "system_BAT32G113.h"                   /*!< BAT32G113 System                                                          */

#ifndef __IM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __IM   __I
#endif
#ifndef __OM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __OM   __O
#endif
#ifndef __IOM                                   /*!< Fallback for older CMSIS versions                                         */
  #define __IOM  __IO
#endif


/* ========================================  Start of section using anonymous unions  ======================================== */
#if defined (__CC_ARM)
  #pragma push
  #pragma anon_unions
#elif defined (__ICCARM__)
  #pragma language=extended
#elif defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
  #pragma clang diagnostic push
  #pragma clang diagnostic ignored "-Wc11-extensions"
  #pragma clang diagnostic ignored "-Wreserved-id-macro"
  #pragma clang diagnostic ignored "-Wgnu-anonymous-struct"
  #pragma clang diagnostic ignored "-Wnested-anon-types"
#elif defined (__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined (__TMS470__)
  /* anonymous unions are enabled by default */
#elif defined (__TASKING__)
  #pragma warning 586
#elif defined (__CSMC__)
  /* anonymous unions are enabled by default */
#else
  #warning Not supported compiler type
#endif


/* =========================================================================================================================== */
/* ================                              Device Specific Cluster Section                              ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_clusters
  * @{
  */


/**
  * @brief DMAVEC_CTRL [CTRL] (DMA control data area)
  */
typedef struct {
  __IOM uint16_t  DMACR;                        /*!< (@ 0x00000000) DMA Control register                                       */
  __IOM uint16_t  DMBLS;                        /*!< (@ 0x00000002) DMA Block Size register                                    */
  __IOM uint16_t  DMACT;                        /*!< (@ 0x00000004) DMA Transfer Count register                                */
  __IOM uint16_t  DMRLD;                        /*!< (@ 0x00000006) DMA Transfer Count Reload register                         */
  __IOM uint32_t  DMSAR;                        /*!< (@ 0x00000008) DMA Source Address register                                */
  __IOM uint32_t  DMDAR;                        /*!< (@ 0x0000000C) DMA Destination Address register                           */
} DMAVEC_CTRL_Type;                             /*!< Size = 16 (0x10)                                                          */


/**
  * @brief INT_IF [IF] (Interrupt flag register)
  */
typedef struct {
  __IOM uint8_t   IFL;                          /*!< (@ 0x00000000) Interrupt flag register                                    */
  __IOM uint8_t   IFH;                          /*!< (@ 0x00000001) Interrupt flag register                                    */
  __IM  uint8_t   RESERVED[2];
} INT_IF_Type;                                  /*!< Size = 4 (0x4)                                                            */


/**
  * @brief INT_MK [MK] (Interrupt mask register)
  */
typedef struct {
  __IOM uint8_t   MKL;                          /*!< (@ 0x00000000) Interrupt mask register                                    */
  __IOM uint8_t   MKH;                          /*!< (@ 0x00000001) Interrupt mask register                                    */
  __IM  uint8_t   RESERVED[2];
} INT_MK_Type;                                  /*!< Size = 4 (0x4)                                                            */


/** @} */ /* End of group Device_Peripheral_clusters */


/* =========================================================================================================================== */
/* ================                            Device Specific Peripheral Section                             ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                            CGC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Clock Generate Control (CGC)
  */

typedef struct {                                /*!< (@ 0x40020400) CGC Structure                                              */
  __IOM uint8_t   CMC;                          /*!< (@ 0x00000000) Clock operaton Mode Control Register                       */
  __IOM uint8_t   CSC;                          /*!< (@ 0x00000001) Clock operation Status Register                            */
  __IM  uint8_t   OSTC;                         /*!< (@ 0x00000002) Oscillation stabilization time counter status              */
  __IOM uint8_t   OSTS;                         /*!< (@ 0x00000003) Oscillation stabilization time select register             */
  __IOM uint8_t   CKC;                          /*!< (@ 0x00000004) System clock control register                              */
  __IOM uint8_t   LOCKCTL;                      /*!< (@ 0x00000005) Lockup Watchdog timer enable register                      */
  __IOM uint8_t   PRCR;                         /*!< (@ 0x00000006) Lockup Watchdog timer enable protect register              */
  __IOM uint8_t   SUBCKSEL;                     /*!< (@ 0x00000007) Sub-system clock selection register                        */
  __IOM uint8_t   WDTCFG0;                      /*!< (@ 0x00000008) WDT Configeration 0 register                               */
  __IOM uint8_t   WDTCFG1;                      /*!< (@ 0x00000009) WDT Configeration 1 register                               */
  __IOM uint8_t   WDTCFG2;                      /*!< (@ 0x0000000A) WDT Configeration 2 register                               */
  __IOM uint8_t   WDTCFG3;                      /*!< (@ 0x0000000B) WDT Configeration 3 register                               */
  __IM  uint8_t   RESERVED[20];
  __IOM uint8_t   PER0;                         /*!< (@ 0x00000020) Peripheral enable register 0                               */
  __IM  uint8_t   RESERVED1[2];
  __IOM uint8_t   OSMC;                         /*!< (@ 0x00000023) Subsystem clock supply mode control register               */
  __IM  uint8_t   RESERVED2[1014];
  __IOM uint8_t   PER1;                         /*!< (@ 0x0000041A) Peripheral enable register 1                               */
  __IOM uint8_t   PER2;                         /*!< (@ 0x0000041B) Peripheral enable register 2                               */
  __IOM uint8_t   LINCKSEL;                     /*!< (@ 0x0000041C) LIN Clock select register                                  */
  __IM  uint8_t   RESERVED3[5091];
  __IOM uint8_t   HIOTRM;                       /*!< (@ 0x00001800) High-speed on-chip oscillator trimming register            */
  __IM  uint8_t   RESERVED4[31];
  __IOM uint8_t   HOCODIV;                      /*!< (@ 0x00001820) High-speed on-chip oscillator frequency select
                                                                    register                                                   */
} CGC_Type;                                     /*!< Size = 6177 (0x1821)                                                      */



/* =========================================================================================================================== */
/* ================                                            RST                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Reset Function (RST)
  */

typedef struct {                                /*!< (@ 0x40020420) RST Structure                                              */
  __IM  uint8_t   RESERVED[32];
  __IM  uint8_t   RESF;                         /*!< (@ 0x00000020) Reset flag register                                        */
} RST_Type;                                     /*!< Size = 33 (0x21)                                                          */



/* =========================================================================================================================== */
/* ================                                            LVD                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Voltage detector (LVD)
  */

typedef struct {                                /*!< (@ 0x40020440) LVD Structure                                              */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   LVIM;                         /*!< (@ 0x00000001) Voltage detection register                                 */
  __IOM uint8_t   LVIS;                         /*!< (@ 0x00000002) Voltage detection level register                           */
} LVD_Type;                                     /*!< Size = 3 (0x3)                                                            */



/* =========================================================================================================================== */
/* ================                                           PORT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Port functions (PORT)
  */

typedef struct {                                /*!< (@ 0x40040030) PORT Structure                                             */
  __IOM uint8_t   PU0;                          /*!< (@ 0x00000000) Pull-up resistor option register 0                         */
  __IOM uint8_t   PU1;                          /*!< (@ 0x00000001) Pull-up resistor option register 1                         */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   PU3;                          /*!< (@ 0x00000003) Pull-up resistor option register 3                         */
  __IOM uint8_t   PU4;                          /*!< (@ 0x00000004) Pull-up resistor option register 4                         */
  __IOM uint8_t   PU5;                          /*!< (@ 0x00000005) Pull-up resistor option register 5                         */
  __IM  uint8_t   RESERVED1;
  __IOM uint8_t   PU7;                          /*!< (@ 0x00000007) Pull-up resistor option register 7                         */
  __IM  uint8_t   RESERVED2[4];
  __IOM uint8_t   PU12;                         /*!< (@ 0x0000000C) Pull-up resistor option register 12                        */
  __IOM uint8_t   PU13;                         /*!< (@ 0x0000000D) Pull-up resistor option register 13                        */
  __IOM uint8_t   PU14;                         /*!< (@ 0x0000000E) Pull-up resistor option register 14                        */
  __IM  uint8_t   RESERVED3;
  __IOM uint8_t   PIM0;                         /*!< (@ 0x00000010) Port input mode register 0                                 */
  __IOM uint8_t   PIM1;                         /*!< (@ 0x00000011) Port input mode register 1                                 */
  __IM  uint8_t   RESERVED4;
  __IOM uint8_t   PIM3;                         /*!< (@ 0x00000013) Port input mode register 3                                 */
  __IM  uint8_t   RESERVED5;
  __IOM uint8_t   PIM5;                         /*!< (@ 0x00000015) Port input mode register 5                                 */
  __IM  uint8_t   RESERVED6;
  __IOM uint8_t   PIM7;                         /*!< (@ 0x00000017) Port input mode register 7                                 */
  __IM  uint8_t   RESERVED7[8];
  __IOM uint8_t   POM0;                         /*!< (@ 0x00000020) Port output mode register 0                                */
  __IOM uint8_t   POM1;                         /*!< (@ 0x00000021) Port output mode register 1                                */
  __IM  uint8_t   RESERVED8;
  __IOM uint8_t   POM3;                         /*!< (@ 0x00000023) Port output mode register 3                                */
  __IM  uint8_t   RESERVED9;
  __IOM uint8_t   POM5;                         /*!< (@ 0x00000025) Port output mode register 5                                */
  __IM  uint8_t   RESERVED10;
  __IOM uint8_t   POM7;                         /*!< (@ 0x00000027) Port output mode register 7                                */
  __IM  uint8_t   RESERVED11[8];
  __IOM uint8_t   PMC0;                         /*!< (@ 0x00000030) Port mode control register 0                               */
  __IOM uint8_t   PMC1;                         /*!< (@ 0x00000031) Port mode control register 1                               */
  __IOM uint8_t   PMC2;                         /*!< (@ 0x00000032) Port mode control register 2                               */
  __IM  uint8_t   RESERVED12[9];
  __IOM uint8_t   PMC12;                        /*!< (@ 0x0000003C) Port mode control register 12                              */
  __IM  uint8_t   RESERVED13;
  __IOM uint8_t   PMC14;                        /*!< (@ 0x0000003E) Port mode control register 14                              */
  __IM  uint8_t   RESERVED14[17];
  __IOM uint8_t   PSET0;                        /*!< (@ 0x00000050) Port set register 0                                        */
  __IOM uint8_t   PSET1;                        /*!< (@ 0x00000051) Port set register 1                                        */
  __IOM uint8_t   PSET2;                        /*!< (@ 0x00000052) Port set register 2                                        */
  __IOM uint8_t   PSET3;                        /*!< (@ 0x00000053) Port set register 3                                        */
  __IOM uint8_t   PSET4;                        /*!< (@ 0x00000054) Port set register 4                                        */
  __IOM uint8_t   PSET5;                        /*!< (@ 0x00000055) Port set register 5                                        */
  __IM  uint8_t   RESERVED15;
  __IOM uint8_t   PSET7;                        /*!< (@ 0x00000057) Port set register 7                                        */
  __IM  uint8_t   RESERVED16[4];
  __IOM uint8_t   PSET12;                       /*!< (@ 0x0000005C) Port set register 12                                       */
  __IOM uint8_t   PSET13;                       /*!< (@ 0x0000005D) Port set register 13                                       */
  __IOM uint8_t   PSET14;                       /*!< (@ 0x0000005E) Port set register 14                                       */
  __IM  uint8_t   RESERVED17;
  __IOM uint8_t   PCLR0;                        /*!< (@ 0x00000060) Port clear register 0                                      */
  __IOM uint8_t   PCLR1;                        /*!< (@ 0x00000061) Port clear register 1                                      */
  __IOM uint8_t   PCLR2;                        /*!< (@ 0x00000062) Port clear register 2                                      */
  __IOM uint8_t   PCLR3;                        /*!< (@ 0x00000063) Port clear register 3                                      */
  __IOM uint8_t   PCLR4;                        /*!< (@ 0x00000064) Port clear register 4                                      */
  __IOM uint8_t   PCLR5;                        /*!< (@ 0x00000065) Port clear register 5                                      */
  __IM  uint8_t   RESERVED18;
  __IOM uint8_t   PCLR7;                        /*!< (@ 0x00000067) Port clear register 7                                      */
  __IM  uint8_t   RESERVED19[4];
  __IOM uint8_t   PCLR12;                       /*!< (@ 0x0000006C) Port clear register 12                                     */
  __IOM uint8_t   PCLR13;                       /*!< (@ 0x0000006D) Port clear register 13                                     */
  __IOM uint8_t   PCLR14;                       /*!< (@ 0x0000006E) Port clear register 14                                     */
  __IM  uint8_t   RESERVED20;
  __IOM uint8_t   PREAD0;                       /*!< (@ 0x00000070) Port read register 0                                       */
  __IOM uint8_t   PREAD1;                       /*!< (@ 0x00000071) Port read register 1                                       */
  __IOM uint8_t   PREAD2;                       /*!< (@ 0x00000072) Port read register 2                                       */
  __IOM uint8_t   PREAD3;                       /*!< (@ 0x00000073) Port read register 3                                       */
  __IOM uint8_t   PREAD4;                       /*!< (@ 0x00000074) Port read register 4                                       */
  __IOM uint8_t   PREAD5;                       /*!< (@ 0x00000075) Port read register 5                                       */
  __IM  uint8_t   RESERVED21;
  __IOM uint8_t   PREAD7;                       /*!< (@ 0x00000077) Port read register 7                                       */
  __IM  uint8_t   RESERVED22[4];
  __IOM uint8_t   PREAD12;                      /*!< (@ 0x0000007C) Port read register 12                                      */
  __IOM uint8_t   PREAD13;                      /*!< (@ 0x0000007D) Port read register 13                                      */
  __IOM uint8_t   PREAD14;                      /*!< (@ 0x0000007E) Port read register 14                                      */
  __IM  uint8_t   RESERVED23[593];
  __IOM uint8_t   P0;                           /*!< (@ 0x000002D0) Port register 0                                            */
  __IOM uint8_t   P1;                           /*!< (@ 0x000002D1) Port register 1                                            */
  __IOM uint8_t   P2;                           /*!< (@ 0x000002D2) Port register 2                                            */
  __IOM uint8_t   P3;                           /*!< (@ 0x000002D3) Port register 3                                            */
  __IOM uint8_t   P4;                           /*!< (@ 0x000002D4) Port register 4                                            */
  __IOM uint8_t   P5;                           /*!< (@ 0x000002D5) Port register 5                                            */
  __IM  uint8_t   RESERVED24;
  __IOM uint8_t   P7;                           /*!< (@ 0x000002D7) Port register 7                                            */
  __IM  uint8_t   RESERVED25[4];
  __IOM uint8_t   P12;                          /*!< (@ 0x000002DC) Port register 12                                           */
  __IOM uint8_t   P13;                          /*!< (@ 0x000002DD) Port register 13                                           */
  __IOM uint8_t   P14;                          /*!< (@ 0x000002DE) Port register 14                                           */
  __IM  uint8_t   RESERVED26[17];
  __IOM uint8_t   PM0;                          /*!< (@ 0x000002F0) Port mode register 0                                       */
  __IOM uint8_t   PM1;                          /*!< (@ 0x000002F1) Port mode register 1                                       */
  __IOM uint8_t   PM2;                          /*!< (@ 0x000002F2) Port mode register 2                                       */
  __IOM uint8_t   PM3;                          /*!< (@ 0x000002F3) Port mode register 3                                       */
  __IOM uint8_t   PM4;                          /*!< (@ 0x000002F4) Port mode register 4                                       */
  __IOM uint8_t   PM5;                          /*!< (@ 0x000002F5) Port mode register 5                                       */
  __IM  uint8_t   RESERVED27;
  __IOM uint8_t   PM7;                          /*!< (@ 0x000002F7) Port mode register 7                                       */
  __IM  uint8_t   RESERVED28[4];
  __IOM uint8_t   PM12;                         /*!< (@ 0x000002FC) Port mode register 12                                      */
  __IOM uint8_t   PM13;                         /*!< (@ 0x000002FD) Port mode register 13                                      */
//  __IOM uint8_t   PM14;                         /*!< (@ 0x000002FE) Port mode register 14                                      */
  __IM  uint8_t   RESERVED29[1351];
  __IOM uint8_t   PIOR2;                        /*!< (@ 0x00000845) Peripheral I/O redirection register 2                      */
  __IM  uint8_t   RESERVED30;
  __IOM uint8_t   PIOR0;                        /*!< (@ 0x00000847) Peripheral I/O redirection register 0                      */
  __IM  uint8_t   RESERVED31;
  __IOM uint8_t   PIOR1;                        /*!< (@ 0x00000849) Peripheral I/O redirection register 1                      */
  __IM  uint8_t   RESERVED32;
  __IOM uint8_t   PMS;                          /*!< (@ 0x0000084B) Port mode select register                                  */
  __IOM uint8_t   PIOR3;                        /*!< (@ 0x0000084C) Peripheral I/O redirection register 3                      */
  __IOM uint8_t   GDIDIS;                       /*!< (@ 0x0000084D) Global digital input disable register                      */
} PORT_Type;                                    /*!< Size = 2126 (0x84e)                                                       */



/* =========================================================================================================================== */
/* ================                                            DIV                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Hardware divider (DIV)
  */

typedef struct {                                /*!< (@ 0x4001A000) DIV Structure                                              */
  __IOM uint32_t  DIVIDEND;                     /*!< (@ 0x00000000) Dividend register                                          */
  __IOM uint32_t  DIVISOR;                      /*!< (@ 0x00000004) Divisor register                                           */
  __IM  uint32_t  QUOTIENT;                     /*!< (@ 0x00000008) Quotient register                                          */
  __IM  uint32_t  REMAINDER;                    /*!< (@ 0x0000000C) Remainder register                                         */
  __IM  uint32_t  STATUS;                       /*!< (@ 0x00000010) Status register                                            */
} DIV_Type;                                     /*!< Size = 20 (0x14)                                                          */



/* =========================================================================================================================== */
/* ================                                           TM40                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief General Purpose Timer 4 (TM40)
  */

typedef struct {                                /*!< (@ 0x40041D80) TM40 Structure                                             */
  __IM  uint16_t  TCR00;                        /*!< (@ 0x00000000) Timer count register 00                                    */
  __IM  uint16_t  TCR01;                        /*!< (@ 0x00000002) Timer count register 01                                    */
  __IM  uint16_t  TCR02;                        /*!< (@ 0x00000004) Timer count register 02                                    */
  __IM  uint16_t  TCR03;                        /*!< (@ 0x00000006) Timer count register 03                                    */
  __IM  uint16_t  RESERVED[4];
  __IOM uint16_t  TMR00;                        /*!< (@ 0x00000010) Timer mode register mn                                     */
  __IOM uint16_t  TMR01;                        /*!< (@ 0x00000012) Timer mode register mn                                     */
  __IOM uint16_t  TMR02;                        /*!< (@ 0x00000014) Timer mode register mn                                     */
  __IOM uint16_t  TMR03;                        /*!< (@ 0x00000016) Timer mode register mn                                     */
  __IM  uint16_t  RESERVED1[4];
  __IM  uint16_t  TSR00;                        /*!< (@ 0x00000020) Timer status register mn                                   */
  __IM  uint16_t  TSR01;                        /*!< (@ 0x00000022) Timer status register mn                                   */
  __IM  uint16_t  TSR02;                        /*!< (@ 0x00000024) Timer status register mn                                   */
  __IM  uint16_t  TSR03;                        /*!< (@ 0x00000026) Timer status register mn                                   */
  __IM  uint16_t  RESERVED2[4];
  __IM  uint16_t  TE0;                          /*!< (@ 0x00000030) Timer channel enable status register m                     */
  __IOM uint16_t  TS0;                          /*!< (@ 0x00000032) Timer channel start register 0                             */
  __IOM uint16_t  TT0;                          /*!< (@ 0x00000034) Timer channel stop register 0                              */
  __IOM uint16_t  TPS0;                         /*!< (@ 0x00000036) Timer clock select register 0                              */
  __IOM uint16_t  TO0;                          /*!< (@ 0x00000038) Timer output register 0                                    */
  __IOM uint16_t  TOE0;                         /*!< (@ 0x0000003A) Timer output enable register 0                             */
  __IOM uint16_t  TOL0;                         /*!< (@ 0x0000003C) Timer output level register 0                              */
  __IOM uint16_t  TOM0;                         /*!< (@ 0x0000003E) Timer output mode register 0                               */
  __IM  uint16_t  RESERVED3[168];
  __IOM uint16_t  TDR00;                        /*!< (@ 0x00000190) Timer data register 00                                     */
  
  union {
    __IOM uint16_t TDR01;                       /*!< (@ 0x00000192) Timer data register 01                                     */
    
    struct {
      __IOM uint8_t TDR01L;                     /*!< (@ 0x00000192) Timer data lower register 01                               */
      __IOM uint8_t TDR01H;                     /*!< (@ 0x00000193) Timer data higher register 01                              */
    };
  };
  __IOM uint16_t  TDR02;                        /*!< (@ 0x00000194) Timer data register 02                                     */
  
  union {
    __IOM uint16_t TDR03;                       /*!< (@ 0x00000196) Timer data register 03                                     */
    
    struct {
      __IOM uint8_t TDR03L;                     /*!< (@ 0x00000196) Timer data lower register 03                               */
      __IOM uint8_t TDR03H;                     /*!< (@ 0x00000197) Timer data higher register 03                              */
    };
  };
} TM40_Type;                                    /*!< Size = 408 (0x198)                                                        */



/* =========================================================================================================================== */
/* ================                                            TMA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief General Purpose Timer A (TMA)
  */

typedef struct {                                /*!< (@ 0x40042240) TMA Structure                                              */
  __IOM uint8_t   TACR0;                        /*!< (@ 0x00000000) Timer control register 0                                   */
  __IOM uint8_t   TAIOC0;                       /*!< (@ 0x00000001) Timer I/O control register 0                               */
  __IOM uint8_t   TAMR0;                        /*!< (@ 0x00000002) Timer mode register 0                                      */
  __IOM uint8_t   TAISR0;                       /*!< (@ 0x00000003) Timer event pin select register 0                          */
  __IM  uint16_t  RESERVED[94];
  __IOM uint16_t  TA0;                          /*!< (@ 0x000000C0) Timer counter register 0                                   */
} TMA_Type;                                     /*!< Size = 194 (0xc2)                                                         */



/* =========================================================================================================================== */
/* ================                                            TMB                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief General Purpose Timer B (TMB)
  */

typedef struct {                                /*!< (@ 0x40042650) TMB Structure                                              */
  __IOM uint8_t   TBMR;                         /*!< (@ 0x00000000) Timer mode register                                        */
  __IOM uint8_t   TBCNTC;                       /*!< (@ 0x00000001) Timer count control register                               */
  __IOM uint8_t   TBCR;                         /*!< (@ 0x00000002) Timer control register                                     */
  __IOM uint8_t   TBIER;                        /*!< (@ 0x00000003) Timer interrupt enable register                            */
  __IOM uint8_t   TBSR;                         /*!< (@ 0x00000004) Timer status enable register                               */
  __IOM uint8_t   TBIOR;                        /*!< (@ 0x00000005) Timer I/O control register                                 */
  __IOM uint16_t  TB;                           /*!< (@ 0x00000006) Timer counter register                                     */
  __IOM uint16_t  TBGRA;                        /*!< (@ 0x00000008) Timer general register A                                   */
  __IOM uint16_t  TBGRB;                        /*!< (@ 0x0000000A) Timer general register B                                   */
  __IOM uint16_t  TBGRCM;                       /*!< (@ 0x0000000C) Timer general register CM                                  */
  __IOM uint16_t  TBGRDM;                       /*!< (@ 0x0000000E) Timer general register DM                                  */
  __IM  uint16_t  RESERVED[128];
  __IOM uint16_t  TBGRC;                        /*!< (@ 0x00000110) Timer general register C                                   */
  __IOM uint16_t  TBGRD;                        /*!< (@ 0x00000112) Timer general register D                                   */
} TMB_Type;                                     /*!< Size = 276 (0x114)                                                        */



/* =========================================================================================================================== */
/* ================                                            TMC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief General Purpose Timer C (TMC)
  */

typedef struct {                                /*!< (@ 0x40042C50) TMC Structure                                              */
  __IOM uint16_t  TC;                           /*!< (@ 0x00000000) Timer counter register                                     */
  __IOM uint16_t  TCBUF;                        /*!< (@ 0x00000002) Timer count buffer register                                */
  __IOM uint8_t   TCCR1;                        /*!< (@ 0x00000004) Timer control register 1                                   */
  __IOM uint8_t   TCCR2;                        /*!< (@ 0x00000005) Timer control register 2                                   */
  __IOM uint8_t   TCSR;                         /*!< (@ 0x00000006) Timer status register                                      */
  __IM  uint8_t   RESERVED;
  __IM  uint16_t  RESERVED1;
} TMC_Type;                                     /*!< Size = 10 (0xa)                                                           */



/* =========================================================================================================================== */
/* ================                                            TMM                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief BLDC Motor control Timer M (TMM)
  */

typedef struct {                                /*!< (@ 0x40042A60) TMM Structure                                              */
  __IOM uint8_t   TMELC;                        /*!< (@ 0x00000000) Timer ELC register                                         */
  __IM  uint8_t   RESERVED[2];
  __IOM uint8_t   TMSTR;                        /*!< (@ 0x00000003) Timer start register                                       */
  __IOM uint8_t   TMMR;                         /*!< (@ 0x00000004) Timer mode register                                        */
  __IOM uint8_t   TMPMR;                        /*!< (@ 0x00000005) PWM function select register                               */
  __IOM uint8_t   TMFCR;                        /*!< (@ 0x00000006) Timer function control register                            */
  __IOM uint8_t   TMOER1;                       /*!< (@ 0x00000007) Timer output master enable register 1                      */
  __IOM uint8_t   TMOER2;                       /*!< (@ 0x00000008) Timer output master enable register 2                      */
  __IOM uint8_t   TMOCR;                        /*!< (@ 0x00000009) Timer output control register                              */
  __IOM uint8_t   TMDF0;                        /*!< (@ 0x0000000A) Digital filter function select register 0                  */
  __IOM uint8_t   TMDF1;                        /*!< (@ 0x0000000B) Digital filter function select register 1                  */
  __IOM uint16_t  TMDR;                         /*!< (@ 0x0000000C) Delay control register                                     */
  __IM  uint16_t  RESERVED1;
  __IOM uint8_t   TMCR0;                        /*!< (@ 0x00000010) Timer control register 0                                   */
  __IOM uint8_t   TMIORA0;                      /*!< (@ 0x00000011) Timer I/O control register A0                              */
  __IOM uint8_t   TMIORC0;                      /*!< (@ 0x00000012) Timer I/O control register C0                              */
  __IOM uint8_t   TMSR0;                        /*!< (@ 0x00000013) Timer status register 0                                    */
  __IOM uint8_t   TMIER0;                       /*!< (@ 0x00000014) Timer interrupt enable register 0                          */
  __IOM uint8_t   TMPOCR0;                      /*!< (@ 0x00000015) PWM output level control register 0                        */
  __IOM uint16_t  TM0;                          /*!< (@ 0x00000016) Timer M counter 0                                          */
  __IOM uint16_t  TMGRA0;                       /*!< (@ 0x00000018) Timer M general register A0                                */
  __IOM uint16_t  TMGRB0;                       /*!< (@ 0x0000001A) Timer M general register B0                                */
  __IOM uint16_t  TMGRC0M;                      /*!< (@ 0x0000001C) Timer M general mirror register C0                         */
  __IOM uint16_t  TMGRD0M;                      /*!< (@ 0x0000001E) Timer M general mirror register D0                         */
  __IOM uint8_t   TMCR1;                        /*!< (@ 0x00000020) Timer control register 1                                   */
  __IOM uint8_t   TMIORA1;                      /*!< (@ 0x00000021) Timer I/O control register A1                              */
  __IOM uint8_t   TMIORC1;                      /*!< (@ 0x00000022) Timer I/O control register C1                              */
  __IOM uint8_t   TMSR1;                        /*!< (@ 0x00000023) Timer status register 1                                    */
  __IOM uint8_t   TMIER1;                       /*!< (@ 0x00000024) Timer interrupt enable register 1                          */
  __IOM uint8_t   TMPOCR1;                      /*!< (@ 0x00000025) PWM output level control register 1                        */
  __IOM uint16_t  TM1;                          /*!< (@ 0x00000026) Timer M counter 1                                          */
  __IOM uint16_t  TMGRA1;                       /*!< (@ 0x00000028) Timer M general register A1                                */
  __IOM uint16_t  TMGRB1;                       /*!< (@ 0x0000002A) Timer M general register B1                                */
  __IOM uint16_t  TMGRC1M;                      /*!< (@ 0x0000002C) Timer M general mirror register C1                         */
  __IOM uint16_t  TMGRD1M;                      /*!< (@ 0x0000002E) Timer M general mirror register D1                         */
  __IM  uint16_t  RESERVED2[100];
  __IOM uint16_t  TMGRC0;                       /*!< (@ 0x000000F8) Timer M general register C0                                */
  __IOM uint16_t  TMGRD0;                       /*!< (@ 0x000000FA) Timer M general register D0                                */
  __IOM uint16_t  TMGRC1;                       /*!< (@ 0x000000FC) Timer M general register C1                                */
  __IOM uint16_t  TMGRD1;                       /*!< (@ 0x000000FE) Timer M general register D1                                */
  __IM  uint16_t  RESERVED3[2172];
  __IOM uint8_t   OPCTL0;                       /*!< (@ 0x000011F8) PWMOPA control register 0                                  */
  __IOM uint8_t   OPDF0;                        /*!< (@ 0x000011F9) PWMOPA cutoff control register 0                           */
  __IOM uint8_t   OPDF1;                        /*!< (@ 0x000011FA) PWMOPA cutoff control register 1                           */
  __IOM uint8_t   OPEDGE;                       /*!< (@ 0x000011FB) PWMOPA edge selection register                             */
  __IM  uint8_t   OPSR;                         /*!< (@ 0x000011FC) PWMOPA status register                                     */
  __IM  uint8_t   RESERVED4;
  __IM  uint16_t  RESERVED5;
} TMM_Type;                                     /*!< Size = 4608 (0x1200)                                                      */



/* =========================================================================================================================== */
/* ================                                           PCBZ                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Clock/Buzzer output controller (PCBZ)
  */

typedef struct {                                /*!< (@ 0x40040FA0) PCBZ Structure                                             */
  __IM  uint8_t   RESERVED[5];
  __IOM uint8_t   CKS0;                         /*!< (@ 0x00000005) Clock output select registers 0                            */
  __IOM uint8_t   CKS1;                         /*!< (@ 0x00000006) Clock output select registers 1                            */
} PCBZ_Type;                                    /*!< Size = 7 (0x7)                                                            */



/* =========================================================================================================================== */
/* ================                                            LIN                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Local Interconnect Network (LIN)
  */

typedef struct {                                /*!< (@ 0x40045C00) LIN Structure                                              */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   LWBR;                         /*!< (@ 0x00000001) LIN Wake-up Baud Rate Select Register                      */
  __IOM uint8_t   LBRP0;                        /*!< (@ 0x00000002) LIN/UART Baud Rate Prescaler 0 Register                    */
  __IOM uint8_t   LBRP1;                        /*!< (@ 0x00000003) LIN/UART Baud Rate Prescaler 1 Register                    */
  __IOM uint8_t   LSTC;                         /*!< (@ 0x00000004) LIN Self-Test Control Register                             */
  __IOM uint8_t   LUSC;                         /*!< (@ 0x00000005) UART Standby Control Register                              */
  __IM  uint16_t  RESERVED1;
  __IOM uint8_t   LMD;                          /*!< (@ 0x00000008) LIN/UART Mode Register                                     */
  __IOM uint8_t   LBFC;                         /*!< (@ 0x00000009) LIN Break Field Configuration Register/UART Configuration
                                                                    Register                                                   */
  __IOM uint8_t   LSC;                          /*!< (@ 0x0000000A) LIN/UART Space Configuration Register                      */
  __IOM uint8_t   LWUP;                         /*!< (@ 0x0000000B) LIN Wake-up Configuration Register                         */
  __IOM uint8_t   LIE;                          /*!< (@ 0x0000000C) LIN Interrupt Enable Register                              */
  __IOM uint8_t   LEDE;                         /*!< (@ 0x0000000D) LIN/UART Error Detection Enable Register                   */
  __IOM uint8_t   LCUC;                         /*!< (@ 0x0000000E) LIN/UART Control Register                                  */
  __IM  uint8_t   RESERVED2;
  __IOM uint8_t   LTRC;                         /*!< (@ 0x00000010) LIN/UART Transmission Control Register                     */
  __IOM uint8_t   LMST;                         /*!< (@ 0x00000011) LIN/UART Mode Status Register                              */
  __IOM uint8_t   LST;                          /*!< (@ 0x00000012) LIN/UART Status Register                                   */
  __IOM uint8_t   LEST;                         /*!< (@ 0x00000013) LIN/UART Error Status Register                             */
  __IOM uint8_t   LDFC;                         /*!< (@ 0x00000014) LIN/UART Data Field Configuration Register                 */
  __IOM uint8_t   LIDB;                         /*!< (@ 0x00000015) LIN/UART ID Buffer Register                                */
  __IOM uint8_t   LCBR;                         /*!< (@ 0x00000016) LIN Checksum Buffer Register                               */
  __IOM uint8_t   LUDB0;                        /*!< (@ 0x00000017) UART Data Buffer 0 Register                                */
  __IOM uint8_t   LDB1;                         /*!< (@ 0x00000018) LIN/UART Data Buffer 1 Register                            */
  __IOM uint8_t   LDB2;                         /*!< (@ 0x00000019) LIN/UART Data Buffer 2 Register                            */
  __IOM uint8_t   LDB3;                         /*!< (@ 0x0000001A) LIN/UART Data Buffer 3 Register                            */
  __IOM uint8_t   LDB4;                         /*!< (@ 0x0000001B) LIN/UART Data Buffer 4 Register                            */
  __IOM uint8_t   LDB5;                         /*!< (@ 0x0000001C) LIN/UART Data Buffer 5 Register                            */
  __IOM uint8_t   LDB6;                         /*!< (@ 0x0000001D) LIN/UART Data Buffer 6 Register                            */
  __IOM uint8_t   LDB7;                         /*!< (@ 0x0000001E) LIN/UART Data Buffer 7 Register                            */
  __IOM uint8_t   LDB8;                         /*!< (@ 0x0000001F) LIN/UART Data Buffer 8 Register                            */
  __IOM uint8_t   LUOER;                        /*!< (@ 0x00000020) UART Operation Enable Register                             */
  __IOM uint8_t   LUOR1;                        /*!< (@ 0x00000021) UART Option Register 1                                     */
  __IM  uint16_t  RESERVED3;
  __IOM uint16_t  LUTDR;                        /*!< (@ 0x00000024) UART Transmission Data Register                            */
  __IM  uint16_t  LURDR;                        /*!< (@ 0x00000026) UART Reception Data Register                               */
  __IOM uint16_t  LUWTDR;                       /*!< (@ 0x00000028) UART Wait Transmission Data Register                       */
} LIN_Type;                                     /*!< Size = 42 (0x2a)                                                          */



/* =========================================================================================================================== */
/* ================                                            WDT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Watchdog Timer with window (WDT)
  */

typedef struct {                                /*!< (@ 0x40021000) WDT Structure                                              */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   WDTE;                         /*!< (@ 0x00000001) Watchdog timer enable register                             */
} WDT_Type;                                     /*!< Size = 2 (0x2)                                                            */



/* =========================================================================================================================== */
/* ================                                            ADC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief A/D Converter (ADC)
  */

typedef struct {                                /*!< (@ 0x40045000) ADC Structure                                              */
  __IOM uint8_t   ADM0;                         /*!< (@ 0x00000000) A/D mode register 0                                        */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   ADM1;                         /*!< (@ 0x00000002) A/D mode register 1                                        */
  __IM  uint8_t   RESERVED1;
  __IOM uint8_t   ADM2;                         /*!< (@ 0x00000004) A/D mode register 2                                        */
  __IM  uint8_t   RESERVED2;
  __IOM uint8_t   ADTRG;                        /*!< (@ 0x00000006) A/D mode register 2                                        */
  __IM  uint8_t   RESERVED3;
  __IOM uint8_t   ADS;                          /*!< (@ 0x00000008) Analog input channel specification register                */
  __IM  uint8_t   RESERVED4;
  __IOM uint8_t   ADLL;                         /*!< (@ 0x0000000A) Conversion result comparison lower limit setting
                                                                    register                                                   */
  __IOM uint8_t   ADUL;                         /*!< (@ 0x0000000B) Conversion result comparison upper limit setting
                                                                    register                                                   */
  __IOM uint8_t   ADNSMP;                       /*!< (@ 0x0000000C) A/D sampling time control register                         */
  __IM  uint8_t   RESERVED5;
  
  union {
    __IOM uint16_t ADCR;                        /*!< (@ 0x0000000E) 12-bit A/D conversion result register                      */
    
    struct {
      __IM  uint8_t RESERVED6;
      __IOM uint8_t ADCRH;                      /*!< (@ 0x0000000F) Higher 8-bit A/D conversion result register                */
    };
  };
  __IOM uint8_t   ADTES;                        /*!< (@ 0x00000010) A/D test register                                          */
  __IOM uint8_t   ADNDIS;                       /*!< (@ 0x00000011) A/D charge/discharge control register                      */
  __IM  uint16_t  RESERVED7;
  __IM  uint8_t   RESERVED8;
  __IOM uint8_t   ADSMPWAIT;                    /*!< (@ 0x00000015) A/D sampling wait control register                         */
  __IOM uint8_t   ADFLG;                        /*!< (@ 0x00000016) A/D flag register                                          */
  __IM  uint8_t   RESERVED9;
  __IM  uint16_t  RESERVED10;
} ADC_Type;                                     /*!< Size = 26 (0x1a)                                                          */



/* =========================================================================================================================== */
/* ================                                            DAC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief D/A Converter (DAC)
  */

typedef struct {                                /*!< (@ 0x40044734) DAC Structure                                              */
  __IOM uint16_t  DACS0;                        /*!< (@ 0x00000000) D/A conversion value setting register 0                    */
  __IOM uint16_t  DACS1;                        /*!< (@ 0x00000002) D/A conversion value setting register 1                    */
  __IOM uint16_t  DAM;                          /*!< (@ 0x00000004) D/A conversion mode register                               */
} DAC_Type;                                     /*!< Size = 6 (0x6)                                                            */



/* =========================================================================================================================== */
/* ================                                            CMP                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Comparator (CMP)
  */

typedef struct {                                /*!< (@ 0x40043840) CMP Structure                                              */
  __IOM uint8_t   COMPMDR;                      /*!< (@ 0x00000000) Comparator mode setting register                           */
  __IOM uint8_t   COMPFIR;                      /*!< (@ 0x00000001) Comparator filter control register                         */
  __IOM uint8_t   COMPOCR;                      /*!< (@ 0x00000002) Comparator output control register                         */
  __IOM uint8_t   CVRCTL;                       /*!< (@ 0x00000003) Comparator internal reference voltage control
                                                                    register                                                   */
  __IM  uint8_t   RESERVED[6];
  __IOM uint8_t   CMPSEL0;                      /*!< (@ 0x0000000A) Comparator 0 input signal selection control register       */
  __IOM uint8_t   CMPSEL1;                      /*!< (@ 0x0000000B) Comparator 1 input signal selection control register       */
  __IM  uint8_t   RESERVED1[2];
  __IOM uint8_t   CMP0HY;                       /*!< (@ 0x0000000E) Hysteresis control register                                */
  __IOM uint8_t   CMP1HY;                       /*!< (@ 0x0000000F) Hysteresis control register                                */
} CMP_Type;                                     /*!< Size = 16 (0x10)                                                          */



/* =========================================================================================================================== */
/* ================                                            PGA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Programmable Gain Amplifier (PGA)
  */

typedef struct {                                /*!< (@ 0x40043840) PGA Structure                                              */
  __IM  uint8_t   RESERVED[6];
  __IOM uint8_t   PGA0CTL;                      /*!< (@ 0x00000006) PGA 0 control register                                     */
} PGA_Type;                                     /*!< Size = 7 (0x7)                                                            */



/* =========================================================================================================================== */
/* ================                                           SCI0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 0 with UART, SPI and simplified I2C supported (SCI0)
  */

typedef struct {                                /*!< (@ 0x40041100) SCI0 Structure                                             */
  __IM  uint16_t  SSR00;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR01;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR00;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR01;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR00;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR01;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR00;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR01;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE0;                          /*!< (@ 0x00000010) Serial channel enable status register m                    */
  __IOM uint16_t  SS0;                          /*!< (@ 0x00000012) Serial channel start register 0                            */
  __IOM uint16_t  ST0;                          /*!< (@ 0x00000014) Serial channel stop register 0                             */
  __IOM uint16_t  SPS0;                         /*!< (@ 0x00000016) Serial clock select register 0                             */
  __IOM uint16_t  SO0;                          /*!< (@ 0x00000018) Serial output register 0                                   */
  __IOM uint16_t  SOE0;                         /*!< (@ 0x0000001A) Serial output enable register 0                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL0;                         /*!< (@ 0x00000020) Serial output level register 0                             */
  __IOM uint16_t  SSE0;                         /*!< (@ 0x00000022) Slave selcect enable register 0                            */
  __IOM uint16_t  SSC0;                         /*!< (@ 0x00000024) SAU Standby Control Register 0                             */
  __IM  uint16_t  RESERVED1[13];
  
  union {
    __IOM uint16_t SDR00;                       /*!< (@ 0x00000040) Serial data register 00                                    */
    __IOM uint16_t SIO00;                       /*!< (@ 0x00000040) SPI data register                                          */
    __IOM uint16_t TXD0;                        /*!< (@ 0x00000040) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR01;                       /*!< (@ 0x00000042) Serial data register 01                                    */
    __IOM uint16_t SIO01;                       /*!< (@ 0x00000042) SPI data register                                          */
    __IOM uint16_t RXD0;                        /*!< (@ 0x00000042) UART receive data register                                 */
  };
} SCI0_Type;                                    /*!< Size = 68 (0x44)                                                          */



/* =========================================================================================================================== */
/* ================                                           SCI1                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 1 with UART, SPI and simplified I2C supported (SCI1)
  */

typedef struct {                                /*!< (@ 0x40041300) SCI1 Structure                                             */
  __IM  uint16_t  SSR10;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR11;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR10;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR11;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR10;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR11;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR10;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR11;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE1;                          /*!< (@ 0x00000010) Serial channel enable status register 1                    */
  __IOM uint16_t  SS1;                          /*!< (@ 0x00000012) Serial channel start register 1                            */
  __IOM uint16_t  ST1;                          /*!< (@ 0x00000014) Serial channel stop register 1                             */
  __IOM uint16_t  SPS1;                         /*!< (@ 0x00000016) Serial clock select register 1                             */
  __IOM uint16_t  SO1;                          /*!< (@ 0x00000018) Serial output register 1                                   */
  __IOM uint16_t  SOE1;                         /*!< (@ 0x0000001A) Serial output enable register 1                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL1;                         /*!< (@ 0x00000020) Serial output level register 1                             */
  __IM  uint16_t  RESERVED1;
  __IOM uint16_t  SSC1;                         /*!< (@ 0x00000024) SAU Standby Control Register 1                             */
  __IM  uint16_t  RESERVED2[13];
  
  union {
    __IOM uint16_t SDR10;                       /*!< (@ 0x00000040) Serial data register 10                                    */
    __IOM uint16_t SIO20;                       /*!< (@ 0x00000040) SPI data register                                          */
    __IOM uint16_t TXD2;                        /*!< (@ 0x00000040) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR11;                       /*!< (@ 0x00000042) Serial data register 11                                    */
    __IOM uint16_t SIO21;                       /*!< (@ 0x00000042) SPI data register                                          */
    __IOM uint16_t RXD2;                        /*!< (@ 0x00000042) UART receive data register                                 */
  };
} SCI1_Type;                                    /*!< Size = 68 (0x44)                                                          */



/* =========================================================================================================================== */
/* ================                                          SPIHS0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Interface SPI0 (SPIHS0)
  */

typedef struct {                                /*!< (@ 0x40045D00) SPIHS0 Structure                                           */
  __IOM uint32_t  SPIM;                         /*!< (@ 0x00000000) SPI mode control register                                  */
  __IOM uint32_t  SPIC;                         /*!< (@ 0x00000004) SPI control register                                       */
  __IOM uint32_t  SDRO;                         /*!< (@ 0x00000008) Data buffer of transmission                                */
  __IOM uint32_t  SDRI;                         /*!< (@ 0x0000000C) Data buffer of reception                                   */
  __IOM uint32_t  SPIS;                         /*!< (@ 0x00000010) SPI status register                                        */
} SPIHS0_Type;                                  /*!< Size = 20 (0x14)                                                          */



/* =========================================================================================================================== */
/* ================                                           IICA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Interface I2C with multimaster and wakeup supported (IICA)
  */

typedef struct {                                /*!< (@ 0x40041A30) IICA Structure                                             */
  __IOM uint8_t   IICCTL00;                     /*!< (@ 0x00000000) IICA control register 0                                    */
  __IOM uint8_t   IICCTL01;                     /*!< (@ 0x00000001) IICA control register 0                                    */
  __IOM uint8_t   IICWL0;                       /*!< (@ 0x00000002) IICA low-level width setting register 0                    */
  __IOM uint8_t   IICWH0;                       /*!< (@ 0x00000003) IICA high-level width setting register 0                   */
  __IOM uint8_t   SVA0;                         /*!< (@ 0x00000004) Slave address register 0                                   */
  __IOM uint8_t   SVA1;                         /*!< (@ 0x00000005) Slave address register 1                                   */
  __IOM uint8_t   IICSE0;                       /*!< (@ 0x00000006) IICA shift enable register 0                               */
  __IM  uint8_t   RESERVED[281];
  __IOM uint8_t   IICA0;                        /*!< (@ 0x00000120) IICA shift register 0                                      */
  __IM  uint8_t   IICS0;                        /*!< (@ 0x00000121) IICA status register 0                                     */
  __IOM uint8_t   IICF0;                        /*!< (@ 0x00000122) IICA flag register 0                                       */
} IICA_Type;                                    /*!< Size = 291 (0x123)                                                        */



/* =========================================================================================================================== */
/* ================                                           IRDA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief IrDA communication module based on Infrared Data Association stardard 1.0 (IRDA)
  */

typedef struct {                                /*!< (@ 0x400440A0) IRDA Structure                                             */
  __IOM uint8_t   IRCR;                         /*!< (@ 0x00000000) IrDA control register                                      */
} IRDA_Type;                                    /*!< Size = 1 (0x1)                                                            */



/* =========================================================================================================================== */
/* ================                                            DMA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Enhanced DMA Controller (DMA)
  */

typedef struct {                                /*!< (@ 0x40005000) DMA Structure                                              */
  __IOM uint8_t   DMAEN0;                       /*!< (@ 0x00000000) DMA activation enable register 0                           */
  __IOM uint8_t   DMAEN1;                       /*!< (@ 0x00000001) DMA activation enable register 1                           */
  __IOM uint8_t   DMAEN2;                       /*!< (@ 0x00000002) DMA activation enable register 2                           */
  __IOM uint8_t   DMAEN3;                       /*!< (@ 0x00000003) DMA activation enable register 3                           */
  __IOM uint8_t   DMAEN4;                       /*!< (@ 0x00000004) DMA activation enable register 4                           */
  __IM  uint8_t   RESERVED;
  __IM  uint16_t  RESERVED1;
  __IOM uint32_t  DMABAR;                       /*!< (@ 0x00000008) DMA base address register                                  */
  __IOM uint32_t  IFPRCR;                       /*!< (@ 0x0000000C) DMA Trigger Protect register                               */
  __IOM uint8_t   DMAIF0;                       /*!< (@ 0x00000010) DMA Trigger enable register 0                              */
  __IOM uint8_t   DMAIF1;                       /*!< (@ 0x00000011) DMA Trigger enable register 1                              */
  __IOM uint8_t   DMAIF2;                       /*!< (@ 0x00000012) DMA Trigger enable register 2                              */
  __IOM uint8_t   DMAIF3;                       /*!< (@ 0x00000013) DMA Trigger enable register 3                              */
  __IOM uint8_t   DMAIF4;                       /*!< (@ 0x00000014) DMA Trigger enable register 4                              */
  __IM  uint8_t   RESERVED2;
  __IM  uint16_t  RESERVED3;
  __IOM uint8_t   DMASET0;                      /*!< (@ 0x00000018) DMA activation enable set register 0                       */
  __IOM uint8_t   DMASET1;                      /*!< (@ 0x00000019) DMA activation enable set register 1                       */
  __IOM uint8_t   DMASET2;                      /*!< (@ 0x0000001A) DMA activation enable set register 2                       */
  __IOM uint8_t   DMASET3;                      /*!< (@ 0x0000001B) DMA activation enable set register 3                       */
  __IOM uint8_t   DMASET4;                      /*!< (@ 0x0000001C) DMA activation enable set register 4                       */
  __IM  uint8_t   RESERVED4;
  __IM  uint16_t  RESERVED5;
  __IOM uint8_t   DMACLR0;                      /*!< (@ 0x00000020) DMA activation enable clear register 0                     */
  __IOM uint8_t   DMACLR1;                      /*!< (@ 0x00000021) DMA activation enable clear register 1                     */
  __IOM uint8_t   DMACLR2;                      /*!< (@ 0x00000022) DMA activation enable clear register 2                     */
  __IOM uint8_t   DMACLR3;                      /*!< (@ 0x00000023) DMA activation enable clear register 3                     */
  __IOM uint8_t   DMACLR4;                      /*!< (@ 0x00000024) DMA activation enable clear register 4                     */
  __IM  uint8_t   RESERVED6;
  __IM  uint16_t  RESERVED7;
} DMA_Type;                                     /*!< Size = 40 (0x28)                                                          */



/* =========================================================================================================================== */
/* ================                                          DMAVEC                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief DMA Vector and Control Data Area (DMAVEC)
  */

typedef struct {                                /*!< (@ 0x20000000) DMAVEC Structure                                           */
  __IOM uint8_t   VEC[64];                      /*!< (@ 0x00000000) DMA vector area                                            */
  __IOM DMAVEC_CTRL_Type CTRL[40];              /*!< (@ 0x00000040) DMA control data area                                      */
} DMAVEC_Type;                                  /*!< Size = 704 (0x2c0)                                                        */



/* =========================================================================================================================== */
/* ================                                            ELC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Event Link Controller (ELC)
  */

typedef struct {                                /*!< (@ 0x40043400) ELC Structure                                              */
  __IOM uint8_t   ELSELR00;                     /*!< (@ 0x00000000) Event output destination select register 00                */
  __IOM uint8_t   ELSELR01;                     /*!< (@ 0x00000001) Event output destination select register 01                */
  __IOM uint8_t   ELSELR02;                     /*!< (@ 0x00000002) Event output destination select register 02                */
  __IOM uint8_t   ELSELR03;                     /*!< (@ 0x00000003) Event output destination select register 03                */
  __IOM uint8_t   ELSELR04;                     /*!< (@ 0x00000004) Event output destination select register 04                */
  __IOM uint8_t   ELSELR05;                     /*!< (@ 0x00000005) Event output destination select register 05                */
  __IOM uint8_t   ELSELR06;                     /*!< (@ 0x00000006) Event output destination select register 06                */
  __IOM uint8_t   ELSELR07;                     /*!< (@ 0x00000007) Event output destination select register 07                */
  __IOM uint8_t   ELSELR08;                     /*!< (@ 0x00000008) Event output destination select register 08                */
  __IOM uint8_t   ELSELR09;                     /*!< (@ 0x00000009) Event output destination select register 09                */
  __IOM uint8_t   ELSELR10;                     /*!< (@ 0x0000000A) Event output destination select register 10                */
  __IOM uint8_t   ELSELR11;                     /*!< (@ 0x0000000B) Event output destination select register 11                */
  __IOM uint8_t   ELSELR12;                     /*!< (@ 0x0000000C) Event output destination select register 12                */
  __IOM uint8_t   ELSELR13;                     /*!< (@ 0x0000000D) Event output destination select register 13                */
  __IOM uint8_t   ELSELR14;                     /*!< (@ 0x0000000E) Event output destination select register 14                */
  __IOM uint8_t   ELSELR15;                     /*!< (@ 0x0000000F) Event output destination select register 15                */
  __IOM uint8_t   ELSELR16;                     /*!< (@ 0x00000010) Event output destination select register 16                */
  __IOM uint8_t   ELSELR17;                     /*!< (@ 0x00000011) Event output destination select register 17                */
  __IOM uint8_t   ELSELR18;                     /*!< (@ 0x00000012) Event output destination select register 18                */
  __IOM uint8_t   ELSELR19;                     /*!< (@ 0x00000013) Event output destination select register 19                */
  __IOM uint8_t   ELSELR20;                     /*!< (@ 0x00000014) Event output destination select register 20                */
  __IOM uint8_t   ELSELR21;                     /*!< (@ 0x00000015) Event output destination select register 21                */
} ELC_Type;                                     /*!< Size = 22 (0x16)                                                          */



/* =========================================================================================================================== */
/* ================                                            INT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Interrupt Controller (INT)
  */

typedef struct {                                /*!< (@ 0x40006000) INT Structure                                              */
  __IOM INT_IF_Type IF[32];                     /*!< (@ 0x00000000) Interrupt flag register                                    */
  __IM  uint8_t   RESERVED[128];
  __IOM INT_MK_Type MK[32];                     /*!< (@ 0x00000100) Interrupt mask register                                    */
} INT_Type;                                     /*!< Size = 384 (0x180)                                                        */



/* =========================================================================================================================== */
/* ================                                           INTM                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Pin input edge detection (INTM)
  */

typedef struct {                                /*!< (@ 0x40045B38) INTM Structure                                             */
  __IOM uint8_t   EGP0;                         /*!< (@ 0x00000000) External interrupt rising edge enable register             */
  __IOM uint8_t   EGN0;                         /*!< (@ 0x00000001) External interrupt falling edge enable register            */
  __IOM uint8_t   EGP1;                         /*!< (@ 0x00000002) External interrupt rising edge enable register             */
  __IOM uint8_t   EGN1;                         /*!< (@ 0x00000003) External interrupt falling edge enable register            */
} INTM_Type;                                    /*!< Size = 4 (0x4)                                                            */



/* =========================================================================================================================== */
/* ================                                           MISC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Miscellaneous function (MISC)
  */

typedef struct {                                /*!< (@ 0x40040470) MISC Structure                                             */
  __IOM uint8_t   NFEN0;                        /*!< (@ 0x00000000) Noise filter enable register 0                             */
  __IOM uint8_t   NFEN1;                        /*!< (@ 0x00000001) Noise filter enable register 1                             */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   ISC;                          /*!< (@ 0x00000003) Input switch control register                              */
  __IOM uint8_t   TIOS0;                        /*!< (@ 0x00000004) Timer I/O select register 0                                */
  __IOM uint8_t   TIOS1;                        /*!< (@ 0x00000005) Timer I/O select register 1                                */
  __IM  uint8_t   RESERVED1[4];
  __IOM uint8_t   VREFCTL;                      /*!< (@ 0x0000000A) VREF control register                                      */
} MISC_Type;                                    /*!< Size = 11 (0xb)                                                           */



/* =========================================================================================================================== */
/* ================                                            FMC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Flash Memory Controller (FMC)
  */

typedef struct {                                /*!< (@ 0x40020000) FMC Structure                                              */
  __IOM uint32_t  FLSTS;                        /*!< (@ 0x00000000) Flash status register                                      */
  __IOM uint32_t  FLOPMD1;                      /*!< (@ 0x00000004) Flash operation mode register 1                            */
  __IOM uint32_t  FLOPMD2;                      /*!< (@ 0x00000008) Flash operation mode register 2                            */
  __IOM uint32_t  FLERMD;                       /*!< (@ 0x0000000C) Flash erase mode register                                  */
  __IOM uint32_t  FLCERCNT;                     /*!< (@ 0x00000010) Flash chip erase control register                          */
  __IOM uint32_t  FLSERCNT;                     /*!< (@ 0x00000014) Flash sector erase control register                        */
  __IM  uint32_t  RESERVED;
  __IOM uint32_t  FLPROCNT;                     /*!< (@ 0x0000001C) Flash program (write) control register                     */
  __IOM uint32_t  FLPROT;                       /*!< (@ 0x00000020) Flash protect control register                             */
} FMC_Type;                                     /*!< Size = 36 (0x24)                                                          */



/* =========================================================================================================================== */
/* ================                                            SAF                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Flash memory CRC operation function (High-Speed CRC) (SAF)
  */

typedef struct {                                /*!< (@ 0x40020100) SAF Structure                                              */
  __IM  uint16_t  RESERVED[402];
  __IM  uint8_t   RESERVED1;
  __IOM uint8_t   RPECTL;                       /*!< (@ 0x00000325) RAM parity error control register                          */
  __IM  uint16_t  RESERVED2[2549];
  __IOM uint8_t   CRC0CTL;                      /*!< (@ 0x00001710) Flash memory CRC control register                          */
  __IM  uint8_t   RESERVED3;
  __IOM uint16_t  PGCRCL;                       /*!< (@ 0x00001712) Flash memory CRC operation result register                 */
  __IM  uint16_t  RESERVED4[63026];
  __IOM uint16_t  SFRGD;                        /*!< (@ 0x00020378) SFR guard control register                                 */
  __IM  uint16_t  RESERVED5[5952];
  __IOM uint16_t  CRCD;                         /*!< (@ 0x000231FA) CRC data register                                          */
  __IM  uint16_t  RESERVED6[88];
  __IOM uint8_t   CRCIN;                        /*!< (@ 0x000232AC) CRC input register                                         */
  __IM  uint8_t   RESERVED7;
  __IM  uint16_t  RESERVED8;
} SAF_Type;                                     /*!< Size = 144048 (0x232b0)                                                   */



/* =========================================================================================================================== */
/* ================                                            CRC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief General Purpose CRC (CRC)
  */

typedef struct {                                /*!< (@ 0x400432F0) CRC Structure                                              */
  __IM  uint16_t  RESERVED[5];
  __IOM uint16_t  CRCD;                         /*!< (@ 0x0000000A) CRC data register                                          */
  __IM  uint16_t  RESERVED1[88];
  __IOM uint8_t   CRCIN;                        /*!< (@ 0x000000BC) CRC input register                                         */
  __IM  uint8_t   RESERVED2;
  __IM  uint16_t  RESERVED3;
} CRC_Type;                                     /*!< Size = 192 (0xc0)                                                         */



/* =========================================================================================================================== */
/* ================                                            DBG                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief DBG Controller (DBG)
  */

typedef struct {                                /*!< (@ 0x4001B000) DBG Structure                                              */
  __IM  uint32_t  DBGSTR;                       /*!< (@ 0x00000000) Debug status register                                      */
  __IOM uint32_t  DBGSTOPCR;                    /*!< (@ 0x00000004) Debug Stop Control register                                */
} DBG_Type;                                     /*!< Size = 8 (0x8)                                                            */



/* =========================================================================================================================== */
/* ================                                            BGR                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Temperature Sensor calibration data (BGR)
  */

typedef struct {                                /*!< (@ 0x00500160) BGR Structure                                              */
  __IM  uint16_t  VBG85;                        /*!< (@ 0x00000000) The A/D conversion value of VBGR at 85 degrees
                                                                    and 3.0V reference voltage                                 */
  __IM  uint16_t  RESERVED;
  __IM  uint16_t  VBG25;                        /*!< (@ 0x00000004) The A/D conversion value of VBGR at 25 degrees
                                                                    and 3.0V reference voltage                                 */
} BGR_Type;                                     /*!< Size = 6 (0x6)                                                            */



/* =========================================================================================================================== */
/* ================                                            TSN                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Temperature Sensor calibration data (TSN)
  */

typedef struct {                                /*!< (@ 0x00500168) TSN Structure                                              */
  __IM  int16_t   TSN85;                        /*!< (@ 0x00000000) The A/D conversion value of Temperature Sensor
                                                                    at 85 degrees and 3.0V reference voltage                   */
  __IM  uint16_t  RESERVED;
  __IM  int16_t   TSN25;                        /*!< (@ 0x00000004) The A/D conversion value of Temperature Sensor
                                                                    at 25 degrees and 3.0V reference voltage                   */
} TSN_Type;                                     /*!< Size = 6 (0x6)                                                            */



/* =========================================================================================================================== */
/* ================                                            UID                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief 128-bit Unique ID (UID)
  */

typedef struct {                                /*!< (@ 0x0050084C) UID Structure                                              */
  __IM  uint32_t  UID0;                         /*!< (@ 0x00000000) UID word 0                                                 */
  __IM  uint32_t  UID1;                         /*!< (@ 0x00000004) UID word 1                                                 */
  __IM  uint32_t  UID2;                         /*!< (@ 0x00000008) UID word 2                                                 */
  __IM  uint32_t  UID3;                         /*!< (@ 0x0000000C) UID word 3                                                 */
} UID_Type;                                     /*!< Size = 16 (0x10)                                                          */


/** @} */ /* End of group Device_Peripheral_peripherals */


/* =========================================================================================================================== */
/* ================                          Device Specific Peripheral Address Map                           ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripheralAddr
  * @{
  */

#define CGC_BASE                    0x40020400UL
#define RST_BASE                    0x40020420UL
#define LVD_BASE                    0x40020440UL
#define PORT_BASE                   0x40040030UL
#define DIV_BASE                    0x4001A000UL
#define TM40_BASE                   0x40041D80UL
#define TMA_BASE                    0x40042240UL
#define TMB_BASE                    0x40042650UL
#define TMC_BASE                    0x40042C50UL
#define TMM_BASE                    0x40042A60UL
#define PCBZ_BASE                   0x40040FA0UL
#define LIN_BASE                    0x40045C00UL
#define WDT_BASE                    0x40021000UL
#define ADC_BASE                    0x40045000UL
#define DAC_BASE                    0x40044734UL
#define CMP_BASE                    0x40043840UL
#define PGA_BASE                    0x40043840UL
#define SCI0_BASE                   0x40041100UL
#define SCI1_BASE                   0x40041300UL
#define SPIHS0_BASE                 0x40045D00UL
#define IICA_BASE                   0x40041A30UL
#define IRDA_BASE                   0x400440A0UL
#define DMA_BASE                    0x40005000UL
#define DMAVEC_BASE                 0x20000000UL
#define ELC_BASE                    0x40043400UL
#define INT_BASE                    0x40006000UL
#define INTM_BASE                   0x40045B38UL
#define MISC_BASE                   0x40040470UL
#define FMC_BASE                    0x40020000UL
#define SAF_BASE                    0x40020100UL
#define CRC_BASE                    0x400432F0UL
#define DBG_BASE                    0x4001B000UL
#define BGR_BASE                    0x00500160UL
#define TSN_BASE                    0x00500168UL
#define UID_BASE                    0x0050084CUL

/** @} */ /* End of group Device_Peripheral_peripheralAddr */


/* =========================================================================================================================== */
/* ================                                  Peripheral declaration                                   ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_declaration
  * @{
  */

#define CGC                         ((CGC_Type*)               CGC_BASE)
#define RST                         ((RST_Type*)               RST_BASE)
#define LVD                         ((LVD_Type*)               LVD_BASE)
#define PORT                        ((PORT_Type*)              PORT_BASE)
#define DIV                         ((DIV_Type*)               DIV_BASE)
#define TM40                        ((TM40_Type*)              TM40_BASE)
#define TMA                         ((TMA_Type*)               TMA_BASE)
#define TMB                         ((TMB_Type*)               TMB_BASE)
#define TMC                         ((TMC_Type*)               TMC_BASE)
#define TMM                         ((TMM_Type*)               TMM_BASE)
#define PCBZ                        ((PCBZ_Type*)              PCBZ_BASE)
#define LIN                         ((LIN_Type*)               LIN_BASE)
#define WDT                         ((WDT_Type*)               WDT_BASE)
#define ADC                         ((ADC_Type*)               ADC_BASE)
#define DAC                         ((DAC_Type*)               DAC_BASE)
#define CMP                         ((CMP_Type*)               CMP_BASE)
#define PGA                         ((PGA_Type*)               PGA_BASE)
#define SCI0                        ((SCI0_Type*)              SCI0_BASE)
#define SCI1                        ((SCI1_Type*)              SCI1_BASE)
#define SPIHS0                      ((SPIHS0_Type*)            SPIHS0_BASE)
#define IICA                        ((IICA_Type*)              IICA_BASE)
#define IRDA                        ((IRDA_Type*)              IRDA_BASE)
#define DMA                         ((DMA_Type*)               DMA_BASE)
#define DMAVEC                      ((DMAVEC_Type*)            DMAVEC_BASE)
#define ELC                         ((ELC_Type*)               ELC_BASE)
#define INT                         ((INT_Type*)               INT_BASE)
#define INTM                        ((INTM_Type*)              INTM_BASE)
#define MISC                        ((MISC_Type*)              MISC_BASE)
#define FMC                         ((FMC_Type*)               FMC_BASE)
#define SAF                         ((SAF_Type*)               SAF_BASE)
#define CRC                         ((CRC_Type*)               CRC_BASE)
#define DBG                         ((DBG_Type*)               DBG_BASE)
#define BGR                         ((BGR_Type*)               BGR_BASE)
#define TSN                         ((TSN_Type*)               TSN_BASE)
#define UID                         ((UID_Type*)               UID_BASE)

/** @} */ /* End of group Device_Peripheral_declaration */


/* =========================================  End of section using anonymous unions  ========================================= */
#if defined (__CC_ARM)
  #pragma pop
#elif defined (__ICCARM__)
  /* leave anonymous unions enabled */
#elif defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
  #pragma clang diagnostic pop
#elif defined (__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined (__TMS470__)
  /* anonymous unions are enabled by default */
#elif defined (__TASKING__)
  #pragma warning restore
#elif defined (__CSMC__)
  /* anonymous unions are enabled by default */
#endif


/* =========================================================================================================================== */
/* ================                                 Pos/Mask Cluster Section                                  ================ */
/* =========================================================================================================================== */


/** @addtogroup PosMask_clusters
  * @{
  */



/* =========================================================================================================================== */
/* ================                                           CTRL                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  DMACR  ========================================================= */
#define CTRL_DMACR_SZ_Pos          (6UL)                     /*!< SZ (Bit 6)                                            */
#define CTRL_DMACR_SZ_Msk          (0xc0UL)                  /*!< SZ (Bitfield-Mask: 0x03)                              */
#define CTRL_DMACR_RPTINT_Pos      (5UL)                     /*!< RPTINT (Bit 5)                                        */
#define CTRL_DMACR_RPTINT_Msk      (0x20UL)                  /*!< RPTINT (Bitfield-Mask: 0x01)                          */
#define CTRL_DMACR_CHNE_Pos        (4UL)                     /*!< CHNE (Bit 4)                                          */
#define CTRL_DMACR_CHNE_Msk        (0x10UL)                  /*!< CHNE (Bitfield-Mask: 0x01)                            */
#define CTRL_DMACR_DAMOD_Pos       (3UL)                     /*!< DAMOD (Bit 3)                                         */
#define CTRL_DMACR_DAMOD_Msk       (0x8UL)                   /*!< DAMOD (Bitfield-Mask: 0x01)                           */
#define CTRL_DMACR_SAMOD_Pos       (2UL)                     /*!< SAMOD (Bit 2)                                         */
#define CTRL_DMACR_SAMOD_Msk       (0x4UL)                   /*!< SAMOD (Bitfield-Mask: 0x01)                           */
#define CTRL_DMACR_RPTSEL_Pos      (1UL)                     /*!< RPTSEL (Bit 1)                                        */
#define CTRL_DMACR_RPTSEL_Msk      (0x2UL)                   /*!< RPTSEL (Bitfield-Mask: 0x01)                          */
#define CTRL_DMACR_MODE_Pos        (0UL)                     /*!< MODE (Bit 0)                                          */
#define CTRL_DMACR_MODE_Msk        (0x1UL)                   /*!< MODE (Bitfield-Mask: 0x01)                            */
/* =========================================================  DMBLS  ========================================================= */
/* =========================================================  DMACT  ========================================================= */
/* =========================================================  DMRLD  ========================================================= */
/* =========================================================  DMSAR  ========================================================= */
/* =========================================================  DMDAR  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            IF                                             ================ */
/* =========================================================================================================================== */

/* ==========================================================  IFL  ========================================================== */
/* ==========================================================  IFH  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            MK                                             ================ */
/* =========================================================================================================================== */

/* ==========================================================  MKL  ========================================================== */
/* ==========================================================  MKH  ========================================================== */

/** @} */ /* End of group PosMask_clusters */


/* =========================================================================================================================== */
/* ================                                Pos/Mask Peripheral Section                                ================ */
/* =========================================================================================================================== */


/** @addtogroup PosMask_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                            CGC                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  CMC  ========================================================== */
#define CGC_CMC_AMPH_Pos                  (0UL)                     /*!< AMPH (Bit 0)                                          */
#define CGC_CMC_AMPH_Msk                  (0x1UL)                   /*!< AMPH (Bitfield-Mask: 0x01)                            */
#define CGC_CMC_OSCSEL_Pos                (6UL)                     /*!< OSCSEL (Bit 6)                                        */
#define CGC_CMC_OSCSEL_Msk                (0x40UL)                  /*!< OSCSEL (Bitfield-Mask: 0x01)                          */
#define CGC_CMC_EXCLK_Pos                 (7UL)                     /*!< EXCLK (Bit 7)                                         */
#define CGC_CMC_EXCLK_Msk                 (0x80UL)                  /*!< EXCLK (Bitfield-Mask: 0x01)                           */
/* ==========================================================  CSC  ========================================================== */
#define CGC_CSC_HIOSTOP_Pos               (0UL)                     /*!< HIOSTOP (Bit 0)                                       */
#define CGC_CSC_HIOSTOP_Msk               (0x1UL)                   /*!< HIOSTOP (Bitfield-Mask: 0x01)                         */
#define CGC_CSC_MSTOP_Pos                 (7UL)                     /*!< MSTOP (Bit 7)                                         */
#define CGC_CSC_MSTOP_Msk                 (0x80UL)                  /*!< MSTOP (Bitfield-Mask: 0x01)                           */
/* =========================================================  OSTC  ========================================================== */
/* =========================================================  OSTS  ========================================================== */
/* ==========================================================  CKC  ========================================================== */
#define CGC_CKC_MCM0_Pos                  (4UL)                     /*!< MCM0 (Bit 4)                                          */
#define CGC_CKC_MCM0_Msk                  (0x10UL)                  /*!< MCM0 (Bitfield-Mask: 0x01)                            */
#define CGC_CKC_MCS_Pos                   (5UL)                     /*!< MCS (Bit 5)                                           */
#define CGC_CKC_MCS_Msk                   (0x20UL)                  /*!< MCS (Bitfield-Mask: 0x01)                             */
/* ========================================================  LOCKCTL  ======================================================== */
/* =========================================================  PRCR  ========================================================== */
/* =======================================================  SUBCKSEL  ======================================================== */
#define CGC_SUBCKSEL_SELLOSC_Pos          (0UL)                     /*!< SELLOSC (Bit 0)                                       */
#define CGC_SUBCKSEL_SELLOSC_Msk          (0x1UL)                   /*!< SELLOSC (Bitfield-Mask: 0x01)                         */
#define CGC_SUBCKSEL_LOSCTEST_Pos         (1UL)                     /*!< LOSCTEST (Bit 1)                                      */
#define CGC_SUBCKSEL_LOSCTEST_Msk         (0x2UL)                   /*!< LOSCTEST (Bitfield-Mask: 0x01)                        */
#define CGC_SUBCKSEL_SCLS_Pos             (2UL)                     /*!< SCLS (Bit 2)                                          */
#define CGC_SUBCKSEL_SCLS_Msk             (0x4UL)                   /*!< SCLS (Bitfield-Mask: 0x01)                            */
/* ========================================================  WDTCFG0  ======================================================== */
/* ========================================================  WDTCFG1  ======================================================== */
/* ========================================================  WDTCFG2  ======================================================== */
/* ========================================================  WDTCFG3  ======================================================== */
/* =========================================================  PER0  ========================================================== */
#define CGC_PER0_TM40EN_Pos               (0UL)                     /*!< TM40EN (Bit 0)                                        */
#define CGC_PER0_TM40EN_Msk               (0x1UL)                   /*!< TM40EN (Bitfield-Mask: 0x01)                          */
#define CGC_PER0_SCI0EN_Pos               (2UL)                     /*!< SCI0EN (Bit 2)                                        */
#define CGC_PER0_SCI0EN_Msk               (0x4UL)                   /*!< SCI0EN (Bitfield-Mask: 0x01)                          */
#define CGC_PER0_SCI1EN_Pos               (3UL)                     /*!< SCI1EN (Bit 3)                                        */
#define CGC_PER0_SCI1EN_Msk               (0x8UL)                   /*!< SCI1EN (Bitfield-Mask: 0x01)                          */
#define CGC_PER0_IICA0EN_Pos              (4UL)                     /*!< IICA0EN (Bit 4)                                       */
#define CGC_PER0_IICA0EN_Msk              (0x10UL)                  /*!< IICA0EN (Bitfield-Mask: 0x01)                         */
#define CGC_PER0_ADCEN_Pos                (5UL)                     /*!< ADCEN (Bit 5)                                         */
#define CGC_PER0_ADCEN_Msk                (0x20UL)                  /*!< ADCEN (Bitfield-Mask: 0x01)                           */
#define CGC_PER0_IRDAEN_Pos               (6UL)                     /*!< IRDAEN (Bit 6)                                        */
#define CGC_PER0_IRDAEN_Msk               (0x40UL)                  /*!< IRDAEN (Bitfield-Mask: 0x01)                          */
/* =========================================================  OSMC  ========================================================== */
#define CGC_OSMC_WUTMMCK0_Pos             (4UL)                     /*!< WUTMMCK0 (Bit 4)                                      */
#define CGC_OSMC_WUTMMCK0_Msk             (0x10UL)                  /*!< WUTMMCK0 (Bitfield-Mask: 0x01)                        */
/* ========================================================  HOCODIV  ======================================================== */
/* ========================================================  HIOTRM  ========================================================= */
/* =========================================================  PER1  ========================================================== */
#define CGC_PER1_TMAEN_Pos                (0UL)                     /*!< TMAEN (Bit 0)                                         */
#define CGC_PER1_TMAEN_Msk                (0x1UL)                   /*!< TMAEN (Bitfield-Mask: 0x01)                           */
#define CGC_PER1_TMCEN_Pos                (1UL)                     /*!< TMCEN (Bit 1)                                         */
#define CGC_PER1_TMCEN_Msk                (0x2UL)                   /*!< TMCEN (Bitfield-Mask: 0x01)                           */
#define CGC_PER1_PWMOPEN_Pos              (2UL)                     /*!< PWMOPEN (Bit 2)                                       */
#define CGC_PER1_PWMOPEN_Msk              (0x4UL)                   /*!< PWMOPEN (Bitfield-Mask: 0x01)                         */
#define CGC_PER1_DMAEN_Pos                (3UL)                     /*!< DMAEN (Bit 3)                                         */
#define CGC_PER1_DMAEN_Msk                (0x8UL)                   /*!< DMAEN (Bitfield-Mask: 0x01)                           */
#define CGC_PER1_TMMEN_Pos                (4UL)                     /*!< TMMEN (Bit 4)                                         */
#define CGC_PER1_TMMEN_Msk                (0x10UL)                  /*!< TMMEN (Bitfield-Mask: 0x01)                           */
#define CGC_PER1_PGACMPEN_Pos             (5UL)                     /*!< PGACMPEN (Bit 5)                                      */
#define CGC_PER1_PGACMPEN_Msk             (0x20UL)                  /*!< PGACMPEN (Bitfield-Mask: 0x01)                        */
#define CGC_PER1_TMBEN_Pos                (6UL)                     /*!< TMBEN (Bit 6)                                         */
#define CGC_PER1_TMBEN_Msk                (0x40UL)                  /*!< TMBEN (Bitfield-Mask: 0x01)                           */
#define CGC_PER1_DACEN_Pos                (7UL)                     /*!< DACEN (Bit 7)                                         */
#define CGC_PER1_DACEN_Msk                (0x80UL)                  /*!< DACEN (Bitfield-Mask: 0x01)                           */
/* =========================================================  PER2  ========================================================== */
#define CGC_PER2_LINEN_Pos                (0UL)                     /*!< LINEN (Bit 0)                                         */
#define CGC_PER2_LINEN_Msk                (0x1UL)                   /*!< LINEN (Bitfield-Mask: 0x01)                           */
#define CGC_PER2_SPIHSEN_Pos              (1UL)                     /*!< SPIHSEN (Bit 1)                                       */
#define CGC_PER2_SPIHSEN_Msk              (0x2UL)                   /*!< SPIHSEN (Bitfield-Mask: 0x01)                         */
/* =======================================================  LINCKSEL  ======================================================== */
#define CGC_LINCKSEL_LIN0MCK_Pos          (0UL)                     /*!< LIN0MCK (Bit 0)                                       */
#define CGC_LINCKSEL_LIN0MCK_Msk          (0x1UL)                   /*!< LIN0MCK (Bitfield-Mask: 0x01)                         */
#define CGC_LINCKSEL_LIN0MCKE_Pos         (4UL)                     /*!< LIN0MCKE (Bit 4)                                      */
#define CGC_LINCKSEL_LIN0MCKE_Msk         (0x10UL)                  /*!< LIN0MCKE (Bitfield-Mask: 0x01)                        */


/* =========================================================================================================================== */
/* ================                                            RST                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  RESF  ========================================================== */
#define RST_RESF_LVIRF_Pos                (0UL)                     /*!< LVIRF (Bit 0)                                         */
#define RST_RESF_LVIRF_Msk                (0x1UL)                   /*!< LVIRF (Bitfield-Mask: 0x01)                           */
#define RST_RESF_IAWRF_Pos                (1UL)                     /*!< IAWRF (Bit 1)                                         */
#define RST_RESF_IAWRF_Msk                (0x2UL)                   /*!< IAWRF (Bitfield-Mask: 0x01)                           */
#define RST_RESF_RPERF_Pos                (2UL)                     /*!< RPERF (Bit 2)                                         */
#define RST_RESF_RPERF_Msk                (0x4UL)                   /*!< RPERF (Bitfield-Mask: 0x01)                           */
#define RST_RESF_WDTRF_Pos                (4UL)                     /*!< WDTRF (Bit 4)                                         */
#define RST_RESF_WDTRF_Msk                (0x10UL)                  /*!< WDTRF (Bitfield-Mask: 0x01)                           */
#define RST_RESF_SYSRF_Pos                (7UL)                     /*!< SYSRF (Bit 7)                                         */
#define RST_RESF_SYSRF_Msk                (0x80UL)                  /*!< SYSRF (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                            LVD                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  LVIM  ========================================================== */
#define LVD_LVIM_LVIF_Pos                 (0UL)                     /*!< LVIF (Bit 0)                                          */
#define LVD_LVIM_LVIF_Msk                 (0x1UL)                   /*!< LVIF (Bitfield-Mask: 0x01)                            */
#define LVD_LVIM_LVIOMSK_Pos              (1UL)                     /*!< LVIOMSK (Bit 1)                                       */
#define LVD_LVIM_LVIOMSK_Msk              (0x2UL)                   /*!< LVIOMSK (Bitfield-Mask: 0x01)                         */
#define LVD_LVIM_LVISEN_Pos               (7UL)                     /*!< LVISEN (Bit 7)                                        */
#define LVD_LVIM_LVISEN_Msk               (0x80UL)                  /*!< LVISEN (Bitfield-Mask: 0x01)                          */
/* =========================================================  LVIS  ========================================================== */
#define LVD_LVIS_LVILV_Pos                (0UL)                     /*!< LVILV (Bit 0)                                         */
#define LVD_LVIS_LVILV_Msk                (0x1UL)                   /*!< LVILV (Bitfield-Mask: 0x01)                           */
#define LVD_LVIS_LVIMD_Pos                (7UL)                     /*!< LVIMD (Bit 7)                                         */
#define LVD_LVIS_LVIMD_Msk                (0x80UL)                  /*!< LVIMD (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                           PORT                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  PM0  ========================================================== */
/* ==========================================================  PM1  ========================================================== */
/* ==========================================================  PM2  ========================================================== */
/* ==========================================================  PM3  ========================================================== */
/* ==========================================================  PM4  ========================================================== */
/* ==========================================================  PM5  ========================================================== */
/* ==========================================================  PM7  ========================================================== */
/* =========================================================  PM12  ========================================================== */
/* =========================================================  PM13  ========================================================== */
/* =========================================================  PM14  ========================================================== */
/* ==========================================================  P0  =========================================================== */
/* ==========================================================  P1  =========================================================== */
/* ==========================================================  P2  =========================================================== */
/* ==========================================================  P3  =========================================================== */
/* ==========================================================  P4  =========================================================== */
/* ==========================================================  P5  =========================================================== */
/* ==========================================================  P7  =========================================================== */
/* ==========================================================  P12  ========================================================== */
/* ==========================================================  P13  ========================================================== */
/* ==========================================================  P14  ========================================================== */
/* ==========================================================  PU0  ========================================================== */
/* ==========================================================  PU1  ========================================================== */
/* ==========================================================  PU3  ========================================================== */
/* ==========================================================  PU4  ========================================================== */
/* ==========================================================  PU5  ========================================================== */
/* ==========================================================  PU7  ========================================================== */
/* =========================================================  PU12  ========================================================== */
/* =========================================================  PU13  ========================================================== */
/* =========================================================  PU14  ========================================================== */
/* =========================================================  PIM0  ========================================================== */
/* =========================================================  PIM1  ========================================================== */
/* =========================================================  PIM3  ========================================================== */
/* =========================================================  PIM5  ========================================================== */
/* =========================================================  PIM7  ========================================================== */
/* =========================================================  POM0  ========================================================== */
/* =========================================================  POM1  ========================================================== */
/* =========================================================  POM3  ========================================================== */
/* =========================================================  POM5  ========================================================== */
/* =========================================================  POM7  ========================================================== */
/* =========================================================  PMC0  ========================================================== */
/* =========================================================  PMC1  ========================================================== */
/* =========================================================  PMC2  ========================================================== */
/* =========================================================  PMC12  ========================================================= */
/* =========================================================  PMC14  ========================================================= */
/* =========================================================  PSET0  ========================================================= */
/* =========================================================  PSET1  ========================================================= */
/* =========================================================  PSET2  ========================================================= */
/* =========================================================  PSET3  ========================================================= */
/* =========================================================  PSET4  ========================================================= */
/* =========================================================  PSET5  ========================================================= */
/* =========================================================  PSET7  ========================================================= */
/* ========================================================  PSET12  ========================================================= */
/* ========================================================  PSET13  ========================================================= */
/* ========================================================  PSET14  ========================================================= */
/* =========================================================  PCLR0  ========================================================= */
/* =========================================================  PCLR1  ========================================================= */
/* =========================================================  PCLR2  ========================================================= */
/* =========================================================  PCLR3  ========================================================= */
/* =========================================================  PCLR4  ========================================================= */
/* =========================================================  PCLR5  ========================================================= */
/* =========================================================  PCLR7  ========================================================= */
/* ========================================================  PCLR12  ========================================================= */
/* ========================================================  PCLR13  ========================================================= */
/* ========================================================  PCLR14  ========================================================= */
/* ========================================================  PREAD0  ========================================================= */
/* ========================================================  PREAD1  ========================================================= */
/* ========================================================  PREAD2  ========================================================= */
/* ========================================================  PREAD3  ========================================================= */
/* ========================================================  PREAD4  ========================================================= */
/* ========================================================  PREAD5  ========================================================= */
/* ========================================================  PREAD7  ========================================================= */
/* ========================================================  PREAD12  ======================================================== */
/* ========================================================  PREAD13  ======================================================== */
/* ========================================================  PREAD14  ======================================================== */
/* =========================================================  PIOR0  ========================================================= */
/* =========================================================  PIOR1  ========================================================= */
/* =========================================================  PIOR2  ========================================================= */
/* =========================================================  PIOR3  ========================================================= */
/* ==========================================================  PMS  ========================================================== */
/* ========================================================  GDIDIS  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            DIV                                            ================ */
/* =========================================================================================================================== */

/* =======================================================  DIVIDEND  ======================================================== */
/* ========================================================  DIVISOR  ======================================================== */
/* =======================================================  QUOTIENT  ======================================================== */
/* =======================================================  REMAINDER  ======================================================= */
/* ========================================================  STATUS  ========================================================= */
#define DIV_STATUS_BUSY_Pos               (8UL)                     /*!< BUSY (Bit 8)                                          */
#define DIV_STATUS_BUSY_Msk               (0x100UL)                 /*!< BUSY (Bitfield-Mask: 0x01)                            */
#define DIV_STATUS_DIVBYZERO_Pos          (9UL)                     /*!< DIVBYZERO (Bit 9)                                     */
#define DIV_STATUS_DIVBYZERO_Msk          (0x200UL)                 /*!< DIVBYZERO (Bitfield-Mask: 0x01)                       */


/* =========================================================================================================================== */
/* ================                                           TM40                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  TCR00  ========================================================= */
/* =========================================================  TCR01  ========================================================= */
/* =========================================================  TCR02  ========================================================= */
/* =========================================================  TCR03  ========================================================= */
/* =========================================================  TMR00  ========================================================= */
#define TM40_TMR00_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM40_TMR00_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM40_TMR00_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM40_TMR00_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM40_TMR00_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM40_TMR00_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM40_TMR00_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM40_TMR00_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM40_TMR00_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM40_TMR00_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR01  ========================================================= */
#define TM40_TMR01_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM40_TMR01_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM40_TMR01_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM40_TMR01_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM40_TMR01_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM40_TMR01_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM40_TMR01_SPLIT_Pos              (11UL)                    /*!< SPLIT (Bit 11)                                        */
#define TM40_TMR01_SPLIT_Msk              (0x800UL)                 /*!< SPLIT (Bitfield-Mask: 0x01)                           */
#define TM40_TMR01_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM40_TMR01_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM40_TMR01_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM40_TMR01_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR02  ========================================================= */
#define TM40_TMR02_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM40_TMR02_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM40_TMR02_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM40_TMR02_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM40_TMR02_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM40_TMR02_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM40_TMR02_MASTER_Pos             (11UL)                    /*!< MASTER (Bit 11)                                       */
#define TM40_TMR02_MASTER_Msk             (0x800UL)                 /*!< MASTER (Bitfield-Mask: 0x01)                          */
#define TM40_TMR02_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM40_TMR02_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM40_TMR02_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM40_TMR02_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TMR03  ========================================================= */
#define TM40_TMR03_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define TM40_TMR03_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define TM40_TMR03_CIS_Pos                (6UL)                     /*!< CIS (Bit 6)                                           */
#define TM40_TMR03_CIS_Msk                (0xc0UL)                  /*!< CIS (Bitfield-Mask: 0x03)                             */
#define TM40_TMR03_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define TM40_TMR03_STS_Msk                (0x700UL)                 /*!< STS (Bitfield-Mask: 0x07)                             */
#define TM40_TMR03_SPLIT_Pos              (11UL)                    /*!< SPLIT (Bit 11)                                        */
#define TM40_TMR03_SPLIT_Msk              (0x800UL)                 /*!< SPLIT (Bitfield-Mask: 0x01)                           */
#define TM40_TMR03_CCS_Pos                (12UL)                    /*!< CCS (Bit 12)                                          */
#define TM40_TMR03_CCS_Msk                (0x1000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define TM40_TMR03_CKS_Pos                (14UL)                    /*!< CKS (Bit 14)                                          */
#define TM40_TMR03_CKS_Msk                (0xc000UL)                /*!< CKS (Bitfield-Mask: 0x03)                             */
/* =========================================================  TSR00  ========================================================= */
#define TM40_TSR00_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM40_TSR00_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR01  ========================================================= */
#define TM40_TSR01_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM40_TSR01_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR02  ========================================================= */
#define TM40_TSR02_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM40_TSR02_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TSR03  ========================================================= */
#define TM40_TSR03_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define TM40_TSR03_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
/* ==========================================================  TE0  ========================================================== */
#define TM40_TE0_TE00_Pos                 (0UL)                     /*!< TE00 (Bit 0)                                          */
#define TM40_TE0_TE00_Msk                 (0x1UL)                   /*!< TE00 (Bitfield-Mask: 0x01)                            */
#define TM40_TE0_TE01_Pos                 (1UL)                     /*!< TE01 (Bit 1)                                          */
#define TM40_TE0_TE01_Msk                 (0x2UL)                   /*!< TE01 (Bitfield-Mask: 0x01)                            */
#define TM40_TE0_TE02_Pos                 (2UL)                     /*!< TE02 (Bit 2)                                          */
#define TM40_TE0_TE02_Msk                 (0x4UL)                   /*!< TE02 (Bitfield-Mask: 0x01)                            */
#define TM40_TE0_TE03_Pos                 (3UL)                     /*!< TE03 (Bit 3)                                          */
#define TM40_TE0_TE03_Msk                 (0x8UL)                   /*!< TE03 (Bitfield-Mask: 0x01)                            */
#define TM40_TE0_TEH01_Pos                (9UL)                     /*!< TEH01 (Bit 9)                                         */
#define TM40_TE0_TEH01_Msk                (0x200UL)                 /*!< TEH01 (Bitfield-Mask: 0x01)                           */
#define TM40_TE0_TEH03_Pos                (11UL)                    /*!< TEH03 (Bit 11)                                        */
#define TM40_TE0_TEH03_Msk                (0x800UL)                 /*!< TEH03 (Bitfield-Mask: 0x01)                           */
/* ==========================================================  TS0  ========================================================== */
#define TM40_TS0_TS00_Pos                 (0UL)                     /*!< TS00 (Bit 0)                                          */
#define TM40_TS0_TS00_Msk                 (0x1UL)                   /*!< TS00 (Bitfield-Mask: 0x01)                            */
#define TM40_TS0_TS01_Pos                 (1UL)                     /*!< TS01 (Bit 1)                                          */
#define TM40_TS0_TS01_Msk                 (0x2UL)                   /*!< TS01 (Bitfield-Mask: 0x01)                            */
#define TM40_TS0_TS02_Pos                 (2UL)                     /*!< TS02 (Bit 2)                                          */
#define TM40_TS0_TS02_Msk                 (0x4UL)                   /*!< TS02 (Bitfield-Mask: 0x01)                            */
#define TM40_TS0_TS03_Pos                 (3UL)                     /*!< TS03 (Bit 3)                                          */
#define TM40_TS0_TS03_Msk                 (0x8UL)                   /*!< TS03 (Bitfield-Mask: 0x01)                            */
#define TM40_TS0_TSH01_Pos                (9UL)                     /*!< TSH01 (Bit 9)                                         */
#define TM40_TS0_TSH01_Msk                (0x200UL)                 /*!< TSH01 (Bitfield-Mask: 0x01)                           */
#define TM40_TS0_TSH03_Pos                (11UL)                    /*!< TSH03 (Bit 11)                                        */
#define TM40_TS0_TSH03_Msk                (0x800UL)                 /*!< TSH03 (Bitfield-Mask: 0x01)                           */
/* ==========================================================  TT0  ========================================================== */
#define TM40_TT0_TT00_Pos                 (0UL)                     /*!< TT00 (Bit 0)                                          */
#define TM40_TT0_TT00_Msk                 (0x1UL)                   /*!< TT00 (Bitfield-Mask: 0x01)                            */
#define TM40_TT0_TT01_Pos                 (1UL)                     /*!< TT01 (Bit 1)                                          */
#define TM40_TT0_TT01_Msk                 (0x2UL)                   /*!< TT01 (Bitfield-Mask: 0x01)                            */
#define TM40_TT0_TT02_Pos                 (2UL)                     /*!< TT02 (Bit 2)                                          */
#define TM40_TT0_TT02_Msk                 (0x4UL)                   /*!< TT02 (Bitfield-Mask: 0x01)                            */
#define TM40_TT0_TT03_Pos                 (3UL)                     /*!< TT03 (Bit 3)                                          */
#define TM40_TT0_TT03_Msk                 (0x8UL)                   /*!< TT03 (Bitfield-Mask: 0x01)                            */
#define TM40_TT0_TTH01_Pos                (9UL)                     /*!< TTH01 (Bit 9)                                         */
#define TM40_TT0_TTH01_Msk                (0x200UL)                 /*!< TTH01 (Bitfield-Mask: 0x01)                           */
#define TM40_TT0_TTH03_Pos                (11UL)                    /*!< TTH03 (Bit 11)                                        */
#define TM40_TT0_TTH03_Msk                (0x800UL)                 /*!< TTH03 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TPS0  ========================================================== */
#define TM40_TPS0_PRS00_Pos               (0UL)                     /*!< PRS00 (Bit 0)                                         */
#define TM40_TPS0_PRS00_Msk               (0xfUL)                   /*!< PRS00 (Bitfield-Mask: 0x0f)                           */
#define TM40_TPS0_PRS01_Pos               (4UL)                     /*!< PRS01 (Bit 4)                                         */
#define TM40_TPS0_PRS01_Msk               (0xf0UL)                  /*!< PRS01 (Bitfield-Mask: 0x0f)                           */
#define TM40_TPS0_PRS02_Pos               (8UL)                     /*!< PRS02 (Bit 8)                                         */
#define TM40_TPS0_PRS02_Msk               (0x300UL)                 /*!< PRS02 (Bitfield-Mask: 0x03)                           */
#define TM40_TPS0_PRS03_Pos               (12UL)                    /*!< PRS03 (Bit 12)                                        */
#define TM40_TPS0_PRS03_Msk               (0x3000UL)                /*!< PRS03 (Bitfield-Mask: 0x03)                           */
/* ==========================================================  TO0  ========================================================== */
#define TM40_TO0_TO00_Pos                 (0UL)                     /*!< TO00 (Bit 0)                                          */
#define TM40_TO0_TO00_Msk                 (0x1UL)                   /*!< TO00 (Bitfield-Mask: 0x01)                            */
#define TM40_TO0_TO01_Pos                 (1UL)                     /*!< TO01 (Bit 1)                                          */
#define TM40_TO0_TO01_Msk                 (0x2UL)                   /*!< TO01 (Bitfield-Mask: 0x01)                            */
#define TM40_TO0_TO02_Pos                 (2UL)                     /*!< TO02 (Bit 2)                                          */
#define TM40_TO0_TO02_Msk                 (0x4UL)                   /*!< TO02 (Bitfield-Mask: 0x01)                            */
#define TM40_TO0_TO03_Pos                 (3UL)                     /*!< TO03 (Bit 3)                                          */
#define TM40_TO0_TO03_Msk                 (0x8UL)                   /*!< TO03 (Bitfield-Mask: 0x01)                            */
/* =========================================================  TOE0  ========================================================== */
#define TM40_TOE0_TOE00_Pos               (0UL)                     /*!< TOE00 (Bit 0)                                         */
#define TM40_TOE0_TOE00_Msk               (0x1UL)                   /*!< TOE00 (Bitfield-Mask: 0x01)                           */
#define TM40_TOE0_TOE01_Pos               (1UL)                     /*!< TOE01 (Bit 1)                                         */
#define TM40_TOE0_TOE01_Msk               (0x2UL)                   /*!< TOE01 (Bitfield-Mask: 0x01)                           */
#define TM40_TOE0_TOE02_Pos               (2UL)                     /*!< TOE02 (Bit 2)                                         */
#define TM40_TOE0_TOE02_Msk               (0x4UL)                   /*!< TOE02 (Bitfield-Mask: 0x01)                           */
#define TM40_TOE0_TOE03_Pos               (3UL)                     /*!< TOE03 (Bit 3)                                         */
#define TM40_TOE0_TOE03_Msk               (0x8UL)                   /*!< TOE03 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TOL0  ========================================================== */
#define TM40_TOL0_TOL01_Pos               (1UL)                     /*!< TOL01 (Bit 1)                                         */
#define TM40_TOL0_TOL01_Msk               (0x2UL)                   /*!< TOL01 (Bitfield-Mask: 0x01)                           */
#define TM40_TOL0_TOL02_Pos               (2UL)                     /*!< TOL02 (Bit 2)                                         */
#define TM40_TOL0_TOL02_Msk               (0x4UL)                   /*!< TOL02 (Bitfield-Mask: 0x01)                           */
#define TM40_TOL0_TOL03_Pos               (3UL)                     /*!< TOL03 (Bit 3)                                         */
#define TM40_TOL0_TOL03_Msk               (0x8UL)                   /*!< TOL03 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TOM0  ========================================================== */
#define TM40_TOM0_TOM01_Pos               (1UL)                     /*!< TOM01 (Bit 1)                                         */
#define TM40_TOM0_TOM01_Msk               (0x2UL)                   /*!< TOM01 (Bitfield-Mask: 0x01)                           */
#define TM40_TOM0_TOM02_Pos               (2UL)                     /*!< TOM02 (Bit 2)                                         */
#define TM40_TOM0_TOM02_Msk               (0x4UL)                   /*!< TOM02 (Bitfield-Mask: 0x01)                           */
#define TM40_TOM0_TOM03_Pos               (3UL)                     /*!< TOM03 (Bit 3)                                         */
#define TM40_TOM0_TOM03_Msk               (0x8UL)                   /*!< TOM03 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TDR00  ========================================================= */
/* =========================================================  TDR01  ========================================================= */
/* =========================================================  TDR02  ========================================================= */
/* =========================================================  TDR03  ========================================================= */
/* ========================================================  TDR01L  ========================================================= */
/* ========================================================  TDR01H  ========================================================= */
/* ========================================================  TDR03L  ========================================================= */
/* ========================================================  TDR03H  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            TMA                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  TACR0  ========================================================= */
#define TMA_TACR0_TSTART_Pos              (0UL)                     /*!< TSTART (Bit 0)                                        */
#define TMA_TACR0_TSTART_Msk              (0x1UL)                   /*!< TSTART (Bitfield-Mask: 0x01)                          */
#define TMA_TACR0_TCSTF_Pos               (1UL)                     /*!< TCSTF (Bit 1)                                         */
#define TMA_TACR0_TCSTF_Msk               (0x2UL)                   /*!< TCSTF (Bitfield-Mask: 0x01)                           */
#define TMA_TACR0_TSTOP_Pos               (2UL)                     /*!< TSTOP (Bit 2)                                         */
#define TMA_TACR0_TSTOP_Msk               (0x4UL)                   /*!< TSTOP (Bitfield-Mask: 0x01)                           */
#define TMA_TACR0_TEDGF_Pos               (4UL)                     /*!< TEDGF (Bit 4)                                         */
#define TMA_TACR0_TEDGF_Msk               (0x10UL)                  /*!< TEDGF (Bitfield-Mask: 0x01)                           */
#define TMA_TACR0_TUNDF_Pos               (5UL)                     /*!< TUNDF (Bit 5)                                         */
#define TMA_TACR0_TUNDF_Msk               (0x20UL)                  /*!< TUNDF (Bitfield-Mask: 0x01)                           */
/* ========================================================  TAIOC0  ========================================================= */
#define TMA_TAIOC0_TEDGSEL_Pos            (0UL)                     /*!< TEDGSEL (Bit 0)                                       */
#define TMA_TAIOC0_TEDGSEL_Msk            (0x1UL)                   /*!< TEDGSEL (Bitfield-Mask: 0x01)                         */
#define TMA_TAIOC0_TOENA_Pos              (2UL)                     /*!< TOENA (Bit 2)                                         */
#define TMA_TAIOC0_TOENA_Msk              (0x4UL)                   /*!< TOENA (Bitfield-Mask: 0x01)                           */
#define TMA_TAIOC0_TIPF_Pos               (4UL)                     /*!< TIPF (Bit 4)                                          */
#define TMA_TAIOC0_TIPF_Msk               (0x30UL)                  /*!< TIPF (Bitfield-Mask: 0x03)                            */
#define TMA_TAIOC0_TIOGT_Pos              (6UL)                     /*!< TIOGT (Bit 6)                                         */
#define TMA_TAIOC0_TIOGT_Msk              (0xc0UL)                  /*!< TIOGT (Bitfield-Mask: 0x03)                           */
/* =========================================================  TAMR0  ========================================================= */
#define TMA_TAMR0_TMOD_Pos                (0UL)                     /*!< TMOD (Bit 0)                                          */
#define TMA_TAMR0_TMOD_Msk                (0x7UL)                   /*!< TMOD (Bitfield-Mask: 0x07)                            */
#define TMA_TAMR0_TEDGPL_Pos              (3UL)                     /*!< TEDGPL (Bit 3)                                        */
#define TMA_TAMR0_TEDGPL_Msk              (0x8UL)                   /*!< TEDGPL (Bitfield-Mask: 0x01)                          */
#define TMA_TAMR0_TCK_Pos                 (4UL)                     /*!< TCK (Bit 4)                                           */
#define TMA_TAMR0_TCK_Msk                 (0x70UL)                  /*!< TCK (Bitfield-Mask: 0x07)                             */
/* ========================================================  TAISR0  ========================================================= */
#define TMA_TAISR0_RCCPSEL_Pos            (0UL)                     /*!< RCCPSEL (Bit 0)                                       */
#define TMA_TAISR0_RCCPSEL_Msk            (0x7UL)                   /*!< RCCPSEL (Bitfield-Mask: 0x07)                         */
/* ==========================================================  TA0  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            TMB                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  TBMR  ========================================================== */
#define TMB_TBMR_TBPWM_Pos                (0UL)                     /*!< TBPWM (Bit 0)                                         */
#define TMB_TBMR_TBPWM_Msk                (0x1UL)                   /*!< TBPWM (Bitfield-Mask: 0x01)                           */
#define TMB_TBMR_TBMDF_Pos                (1UL)                     /*!< TBMDF (Bit 1)                                         */
#define TMB_TBMR_TBMDF_Msk                (0x2UL)                   /*!< TBMDF (Bitfield-Mask: 0x01)                           */
#define TMB_TBMR_TBDFA_Pos                (2UL)                     /*!< TBDFA (Bit 2)                                         */
#define TMB_TBMR_TBDFA_Msk                (0x4UL)                   /*!< TBDFA (Bitfield-Mask: 0x01)                           */
#define TMB_TBMR_TBDFB_Pos                (3UL)                     /*!< TBDFB (Bit 3)                                         */
#define TMB_TBMR_TBDFB_Msk                (0x8UL)                   /*!< TBDFB (Bitfield-Mask: 0x01)                           */
#define TMB_TBMR_TBDFCK_Pos               (4UL)                     /*!< TBDFCK (Bit 4)                                        */
#define TMB_TBMR_TBDFCK_Msk               (0x30UL)                  /*!< TBDFCK (Bitfield-Mask: 0x03)                          */
#define TMB_TBMR_TBELCICE_Pos             (6UL)                     /*!< TBELCICE (Bit 6)                                      */
#define TMB_TBMR_TBELCICE_Msk             (0x40UL)                  /*!< TBELCICE (Bitfield-Mask: 0x01)                        */
#define TMB_TBMR_TBSTART_Pos              (7UL)                     /*!< TBSTART (Bit 7)                                       */
#define TMB_TBMR_TBSTART_Msk              (0x80UL)                  /*!< TBSTART (Bitfield-Mask: 0x01)                         */
/* ========================================================  TBCNTC  ========================================================= */
#define TMB_TBCNTC_CNTEN0_Pos             (0UL)                     /*!< CNTEN0 (Bit 0)                                        */
#define TMB_TBCNTC_CNTEN0_Msk             (0x1UL)                   /*!< CNTEN0 (Bitfield-Mask: 0x01)                          */
#define TMB_TBCNTC_CNTEN1_Pos             (1UL)                     /*!< CNTEN1 (Bit 1)                                        */
#define TMB_TBCNTC_CNTEN1_Msk             (0x2UL)                   /*!< CNTEN1 (Bitfield-Mask: 0x01)                          */
#define TMB_TBCNTC_CNTEN2_Pos             (2UL)                     /*!< CNTEN2 (Bit 2)                                        */
#define TMB_TBCNTC_CNTEN2_Msk             (0x4UL)                   /*!< CNTEN2 (Bitfield-Mask: 0x01)                          */
#define TMB_TBCNTC_CNTEN3_Pos             (3UL)                     /*!< CNTEN3 (Bit 3)                                        */
#define TMB_TBCNTC_CNTEN3_Msk             (0x8UL)                   /*!< CNTEN3 (Bitfield-Mask: 0x01)                          */
#define TMB_TBCNTC_CNTEN4_Pos             (4UL)                     /*!< CNTEN4 (Bit 4)                                        */
#define TMB_TBCNTC_CNTEN4_Msk             (0x10UL)                  /*!< CNTEN4 (Bitfield-Mask: 0x01)                          */
#define TMB_TBCNTC_CNTEN5_Pos             (5UL)                     /*!< CNTEN5 (Bit 5)                                        */
#define TMB_TBCNTC_CNTEN5_Msk             (0x20UL)                  /*!< CNTEN5 (Bitfield-Mask: 0x01)                          */
#define TMB_TBCNTC_CNTEN6_Pos             (6UL)                     /*!< CNTEN6 (Bit 6)                                        */
#define TMB_TBCNTC_CNTEN6_Msk             (0x40UL)                  /*!< CNTEN6 (Bitfield-Mask: 0x01)                          */
#define TMB_TBCNTC_CNTEN7_Pos             (7UL)                     /*!< CNTEN7 (Bit 7)                                        */
#define TMB_TBCNTC_CNTEN7_Msk             (0x80UL)                  /*!< CNTEN7 (Bitfield-Mask: 0x01)                          */
/* =========================================================  TBCR  ========================================================== */
#define TMB_TBCR_TBTCK_Pos                (0UL)                     /*!< TBTCK (Bit 0)                                         */
#define TMB_TBCR_TBTCK_Msk                (0x7UL)                   /*!< TBTCK (Bitfield-Mask: 0x07)                           */
#define TMB_TBCR_TBCKEG_Pos               (3UL)                     /*!< TBCKEG (Bit 3)                                        */
#define TMB_TBCR_TBCKEG_Msk               (0x18UL)                  /*!< TBCKEG (Bitfield-Mask: 0x03)                          */
#define TMB_TBCR_TBCCLR_Pos               (5UL)                     /*!< TBCCLR (Bit 5)                                        */
#define TMB_TBCR_TBCCLR_Msk               (0x60UL)                  /*!< TBCCLR (Bitfield-Mask: 0x03)                          */
/* =========================================================  TBIER  ========================================================= */
#define TMB_TBIER_TBIMIEA_Pos             (0UL)                     /*!< TBIMIEA (Bit 0)                                       */
#define TMB_TBIER_TBIMIEA_Msk             (0x1UL)                   /*!< TBIMIEA (Bitfield-Mask: 0x01)                         */
#define TMB_TBIER_TBIMIEB_Pos             (1UL)                     /*!< TBIMIEB (Bit 1)                                       */
#define TMB_TBIER_TBIMIEB_Msk             (0x2UL)                   /*!< TBIMIEB (Bitfield-Mask: 0x01)                         */
#define TMB_TBIER_TBUDIE_Pos              (2UL)                     /*!< TBUDIE (Bit 2)                                        */
#define TMB_TBIER_TBUDIE_Msk              (0x4UL)                   /*!< TBUDIE (Bitfield-Mask: 0x01)                          */
#define TMB_TBIER_TBOVIE_Pos              (3UL)                     /*!< TBOVIE (Bit 3)                                        */
#define TMB_TBIER_TBOVIE_Msk              (0x8UL)                   /*!< TBOVIE (Bitfield-Mask: 0x01)                          */
/* =========================================================  TBSR  ========================================================== */
#define TMB_TBSR_TBIMFA_Pos               (0UL)                     /*!< TBIMFA (Bit 0)                                        */
#define TMB_TBSR_TBIMFA_Msk               (0x1UL)                   /*!< TBIMFA (Bitfield-Mask: 0x01)                          */
#define TMB_TBSR_TBIMFB_Pos               (1UL)                     /*!< TBIMFB (Bit 1)                                        */
#define TMB_TBSR_TBIMFB_Msk               (0x2UL)                   /*!< TBIMFB (Bitfield-Mask: 0x01)                          */
#define TMB_TBSR_TBUDF_Pos                (2UL)                     /*!< TBUDF (Bit 2)                                         */
#define TMB_TBSR_TBUDF_Msk                (0x4UL)                   /*!< TBUDF (Bitfield-Mask: 0x01)                           */
#define TMB_TBSR_TBOVF_Pos                (3UL)                     /*!< TBOVF (Bit 3)                                         */
#define TMB_TBSR_TBOVF_Msk                (0x8UL)                   /*!< TBOVF (Bitfield-Mask: 0x01)                           */
#define TMB_TBSR_TBDIRF_Pos               (4UL)                     /*!< TBDIRF (Bit 4)                                        */
#define TMB_TBSR_TBDIRF_Msk               (0x10UL)                  /*!< TBDIRF (Bitfield-Mask: 0x01)                          */
/* =========================================================  TBIOR  ========================================================= */
#define TMB_TBIOR_TBIOA_Pos               (0UL)                     /*!< TBIOA (Bit 0)                                         */
#define TMB_TBIOR_TBIOA_Msk               (0x7UL)                   /*!< TBIOA (Bitfield-Mask: 0x07)                           */
#define TMB_TBIOR_TBBUFA_Pos              (3UL)                     /*!< TBBUFA (Bit 3)                                        */
#define TMB_TBIOR_TBBUFA_Msk              (0x8UL)                   /*!< TBBUFA (Bitfield-Mask: 0x01)                          */
#define TMB_TBIOR_TBIOB_Pos               (4UL)                     /*!< TBIOB (Bit 4)                                         */
#define TMB_TBIOR_TBIOB_Msk               (0x70UL)                  /*!< TBIOB (Bitfield-Mask: 0x07)                           */
#define TMB_TBIOR_TBBUFB_Pos              (7UL)                     /*!< TBBUFB (Bit 7)                                        */
#define TMB_TBIOR_TBBUFB_Msk              (0x80UL)                  /*!< TBBUFB (Bitfield-Mask: 0x01)                          */
/* ==========================================================  TB  =========================================================== */
/* =========================================================  TBGRA  ========================================================= */
/* =========================================================  TBGRB  ========================================================= */
/* ========================================================  TBGRCM  ========================================================= */
/* ========================================================  TBGRDM  ========================================================= */
/* =========================================================  TBGRC  ========================================================= */
/* =========================================================  TBGRD  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            TMC                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  TC  =========================================================== */
/* =========================================================  TCBUF  ========================================================= */
/* =========================================================  TCCR1  ========================================================= */
#define TMC_TCCR1_OVIE_Pos                (0UL)                     /*!< OVIE (Bit 0)                                          */
#define TMC_TCCR1_OVIE_Msk                (0x1UL)                   /*!< OVIE (Bitfield-Mask: 0x01)                            */
#define TMC_TCCR1_TM_TRIG_Pos             (1UL)                     /*!< TM_TRIG (Bit 1)                                       */
#define TMC_TCCR1_TM_TRIG_Msk             (0x2UL)                   /*!< TM_TRIG (Bitfield-Mask: 0x01)                         */
#define TMC_TCCR1_TRIG_MD_HW_Pos          (2UL)                     /*!< TRIG_MD_HW (Bit 2)                                    */
#define TMC_TCCR1_TRIG_MD_HW_Msk          (0x4UL)                   /*!< TRIG_MD_HW (Bitfield-Mask: 0x01)                      */
#define TMC_TCCR1_TRIG_MD_SW_Pos          (3UL)                     /*!< TRIG_MD_SW (Bit 3)                                    */
#define TMC_TCCR1_TRIG_MD_SW_Msk          (0x8UL)                   /*!< TRIG_MD_SW (Bitfield-Mask: 0x01)                      */
#define TMC_TCCR1_START_MD_Pos            (4UL)                     /*!< START_MD (Bit 4)                                      */
#define TMC_TCCR1_START_MD_Msk            (0x10UL)                  /*!< START_MD (Bitfield-Mask: 0x01)                        */
#define TMC_TCCR1_TCK_Pos                 (5UL)                     /*!< TCK (Bit 5)                                           */
#define TMC_TCCR1_TCK_Msk                 (0xe0UL)                  /*!< TCK (Bitfield-Mask: 0x07)                             */
/* =========================================================  TCCR2  ========================================================= */
#define TMC_TCCR2_TSTART_Pos              (0UL)                     /*!< TSTART (Bit 0)                                        */
#define TMC_TCCR2_TSTART_Msk              (0x1UL)                   /*!< TSTART (Bitfield-Mask: 0x01)                          */
#define TMC_TCCR2_CMP1_TCR_Pos            (1UL)                     /*!< CMP1_TCR (Bit 1)                                      */
#define TMC_TCCR2_CMP1_TCR_Msk            (0x6UL)                   /*!< CMP1_TCR (Bitfield-Mask: 0x03)                        */
/* =========================================================  TCSR  ========================================================== */
#define TMC_TCSR_TCOVF_Pos                (0UL)                     /*!< TCOVF (Bit 0)                                         */
#define TMC_TCSR_TCOVF_Msk                (0x1UL)                   /*!< TCOVF (Bitfield-Mask: 0x01)                           */
#define TMC_TCSR_TCSB_Pos                 (1UL)                     /*!< TCSB (Bit 1)                                          */
#define TMC_TCSR_TCSB_Msk                 (0x2UL)                   /*!< TCSB (Bitfield-Mask: 0x01)                            */


/* =========================================================================================================================== */
/* ================                                            TMM                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  TMELC  ========================================================= */
#define TMM_TMELC_ELCICE0_Pos             (0UL)                     /*!< ELCICE0 (Bit 0)                                       */
#define TMM_TMELC_ELCICE0_Msk             (0x1UL)                   /*!< ELCICE0 (Bitfield-Mask: 0x01)                         */
#define TMM_TMELC_ELCOBE0_Pos             (1UL)                     /*!< ELCOBE0 (Bit 1)                                       */
#define TMM_TMELC_ELCOBE0_Msk             (0x2UL)                   /*!< ELCOBE0 (Bitfield-Mask: 0x01)                         */
#define TMM_TMELC_ELCICE1_Pos             (4UL)                     /*!< ELCICE1 (Bit 4)                                       */
#define TMM_TMELC_ELCICE1_Msk             (0x10UL)                  /*!< ELCICE1 (Bitfield-Mask: 0x01)                         */
#define TMM_TMELC_ELCOBE1_Pos             (5UL)                     /*!< ELCOBE1 (Bit 5)                                       */
#define TMM_TMELC_ELCOBE1_Msk             (0x20UL)                  /*!< ELCOBE1 (Bitfield-Mask: 0x01)                         */
/* =========================================================  TMSTR  ========================================================= */
#define TMM_TMSTR_TSTART0_Pos             (0UL)                     /*!< TSTART0 (Bit 0)                                       */
#define TMM_TMSTR_TSTART0_Msk             (0x1UL)                   /*!< TSTART0 (Bitfield-Mask: 0x01)                         */
#define TMM_TMSTR_TSTART1_Pos             (1UL)                     /*!< TSTART1 (Bit 1)                                       */
#define TMM_TMSTR_TSTART1_Msk             (0x2UL)                   /*!< TSTART1 (Bitfield-Mask: 0x01)                         */
#define TMM_TMSTR_CSEL0_Pos               (2UL)                     /*!< CSEL0 (Bit 2)                                         */
#define TMM_TMSTR_CSEL0_Msk               (0x4UL)                   /*!< CSEL0 (Bitfield-Mask: 0x01)                           */
#define TMM_TMSTR_CSEL1_Pos               (3UL)                     /*!< CSEL1 (Bit 3)                                         */
#define TMM_TMSTR_CSEL1_Msk               (0x8UL)                   /*!< CSEL1 (Bitfield-Mask: 0x01)                           */
/* =========================================================  TMMR  ========================================================== */
#define TMM_TMMR_TMSYNC_Pos               (0UL)                     /*!< TMSYNC (Bit 0)                                        */
#define TMM_TMMR_TMSYNC_Msk               (0x1UL)                   /*!< TMSYNC (Bitfield-Mask: 0x01)                          */
#define TMM_TMMR_TMBFC0_Pos               (4UL)                     /*!< TMBFC0 (Bit 4)                                        */
#define TMM_TMMR_TMBFC0_Msk               (0x10UL)                  /*!< TMBFC0 (Bitfield-Mask: 0x01)                          */
#define TMM_TMMR_TMBFD0_Pos               (5UL)                     /*!< TMBFD0 (Bit 5)                                        */
#define TMM_TMMR_TMBFD0_Msk               (0x20UL)                  /*!< TMBFD0 (Bitfield-Mask: 0x01)                          */
#define TMM_TMMR_TMBFC1_Pos               (6UL)                     /*!< TMBFC1 (Bit 6)                                        */
#define TMM_TMMR_TMBFC1_Msk               (0x40UL)                  /*!< TMBFC1 (Bitfield-Mask: 0x01)                          */
#define TMM_TMMR_TMBFD1_Pos               (7UL)                     /*!< TMBFD1 (Bit 7)                                        */
#define TMM_TMMR_TMBFD1_Msk               (0x80UL)                  /*!< TMBFD1 (Bitfield-Mask: 0x01)                          */
/* =========================================================  TMPMR  ========================================================= */
#define TMM_TMPMR_TMPWMB0_Pos             (0UL)                     /*!< TMPWMB0 (Bit 0)                                       */
#define TMM_TMPMR_TMPWMB0_Msk             (0x1UL)                   /*!< TMPWMB0 (Bitfield-Mask: 0x01)                         */
#define TMM_TMPMR_TMPWMC0_Pos             (1UL)                     /*!< TMPWMC0 (Bit 1)                                       */
#define TMM_TMPMR_TMPWMC0_Msk             (0x2UL)                   /*!< TMPWMC0 (Bitfield-Mask: 0x01)                         */
#define TMM_TMPMR_TMPWMD0_Pos             (2UL)                     /*!< TMPWMD0 (Bit 2)                                       */
#define TMM_TMPMR_TMPWMD0_Msk             (0x4UL)                   /*!< TMPWMD0 (Bitfield-Mask: 0x01)                         */
#define TMM_TMPMR_TMPWMB1_Pos             (4UL)                     /*!< TMPWMB1 (Bit 4)                                       */
#define TMM_TMPMR_TMPWMB1_Msk             (0x10UL)                  /*!< TMPWMB1 (Bitfield-Mask: 0x01)                         */
#define TMM_TMPMR_TMPWMC1_Pos             (5UL)                     /*!< TMPWMC1 (Bit 5)                                       */
#define TMM_TMPMR_TMPWMC1_Msk             (0x20UL)                  /*!< TMPWMC1 (Bitfield-Mask: 0x01)                         */
#define TMM_TMPMR_TMPWMD1_Pos             (6UL)                     /*!< TMPWMD1 (Bit 6)                                       */
#define TMM_TMPMR_TMPWMD1_Msk             (0x40UL)                  /*!< TMPWMD1 (Bitfield-Mask: 0x01)                         */
/* =========================================================  TMFCR  ========================================================= */
#define TMM_TMFCR_CMD_Pos                 (0UL)                     /*!< CMD (Bit 0)                                           */
#define TMM_TMFCR_CMD_Msk                 (0x3UL)                   /*!< CMD (Bitfield-Mask: 0x03)                             */
#define TMM_TMFCR_OLS0_Pos                (2UL)                     /*!< OLS0 (Bit 2)                                          */
#define TMM_TMFCR_OLS0_Msk                (0x4UL)                   /*!< OLS0 (Bitfield-Mask: 0x01)                            */
#define TMM_TMFCR_OLS1_Pos                (3UL)                     /*!< OLS1 (Bit 3)                                          */
#define TMM_TMFCR_OLS1_Msk                (0x8UL)                   /*!< OLS1 (Bitfield-Mask: 0x01)                            */
#define TMM_TMFCR_STCLK_Pos               (6UL)                     /*!< STCLK (Bit 6)                                         */
#define TMM_TMFCR_STCLK_Msk               (0x40UL)                  /*!< STCLK (Bitfield-Mask: 0x01)                           */
#define TMM_TMFCR_PWM3_Pos                (7UL)                     /*!< PWM3 (Bit 7)                                          */
#define TMM_TMFCR_PWM3_Msk                (0x80UL)                  /*!< PWM3 (Bitfield-Mask: 0x01)                            */
/* ========================================================  TMOER1  ========================================================= */
#define TMM_TMOER1_EA0_Pos                (0UL)                     /*!< EA0 (Bit 0)                                           */
#define TMM_TMOER1_EA0_Msk                (0x1UL)                   /*!< EA0 (Bitfield-Mask: 0x01)                             */
#define TMM_TMOER1_EB0_Pos                (1UL)                     /*!< EB0 (Bit 1)                                           */
#define TMM_TMOER1_EB0_Msk                (0x2UL)                   /*!< EB0 (Bitfield-Mask: 0x01)                             */
#define TMM_TMOER1_EC0_Pos                (2UL)                     /*!< EC0 (Bit 2)                                           */
#define TMM_TMOER1_EC0_Msk                (0x4UL)                   /*!< EC0 (Bitfield-Mask: 0x01)                             */
#define TMM_TMOER1_ED0_Pos                (3UL)                     /*!< ED0 (Bit 3)                                           */
#define TMM_TMOER1_ED0_Msk                (0x8UL)                   /*!< ED0 (Bitfield-Mask: 0x01)                             */
#define TMM_TMOER1_EA1_Pos                (4UL)                     /*!< EA1 (Bit 4)                                           */
#define TMM_TMOER1_EA1_Msk                (0x10UL)                  /*!< EA1 (Bitfield-Mask: 0x01)                             */
#define TMM_TMOER1_EB1_Pos                (5UL)                     /*!< EB1 (Bit 5)                                           */
#define TMM_TMOER1_EB1_Msk                (0x20UL)                  /*!< EB1 (Bitfield-Mask: 0x01)                             */
#define TMM_TMOER1_EC1_Pos                (6UL)                     /*!< EC1 (Bit 6)                                           */
#define TMM_TMOER1_EC1_Msk                (0x40UL)                  /*!< EC1 (Bitfield-Mask: 0x01)                             */
#define TMM_TMOER1_ED1_Pos                (7UL)                     /*!< ED1 (Bit 7)                                           */
#define TMM_TMOER1_ED1_Msk                (0x80UL)                  /*!< ED1 (Bitfield-Mask: 0x01)                             */
/* ========================================================  TMOER2  ========================================================= */
#define TMM_TMOER2_TMSHUTS_Pos            (0UL)                     /*!< TMSHUTS (Bit 0)                                       */
#define TMM_TMOER2_TMSHUTS_Msk            (0x1UL)                   /*!< TMSHUTS (Bitfield-Mask: 0x01)                         */
#define TMM_TMOER2_TMPTO_Pos              (7UL)                     /*!< TMPTO (Bit 7)                                         */
#define TMM_TMOER2_TMPTO_Msk              (0x80UL)                  /*!< TMPTO (Bitfield-Mask: 0x01)                           */
/* =========================================================  TMOCR  ========================================================= */
#define TMM_TMOCR_TOA0_Pos                (0UL)                     /*!< TOA0 (Bit 0)                                          */
#define TMM_TMOCR_TOA0_Msk                (0x1UL)                   /*!< TOA0 (Bitfield-Mask: 0x01)                            */
#define TMM_TMOCR_TOB0_Pos                (1UL)                     /*!< TOB0 (Bit 1)                                          */
#define TMM_TMOCR_TOB0_Msk                (0x2UL)                   /*!< TOB0 (Bitfield-Mask: 0x01)                            */
#define TMM_TMOCR_TOC0_Pos                (2UL)                     /*!< TOC0 (Bit 2)                                          */
#define TMM_TMOCR_TOC0_Msk                (0x4UL)                   /*!< TOC0 (Bitfield-Mask: 0x01)                            */
#define TMM_TMOCR_TOD0_Pos                (3UL)                     /*!< TOD0 (Bit 3)                                          */
#define TMM_TMOCR_TOD0_Msk                (0x8UL)                   /*!< TOD0 (Bitfield-Mask: 0x01)                            */
#define TMM_TMOCR_TOA1_Pos                (4UL)                     /*!< TOA1 (Bit 4)                                          */
#define TMM_TMOCR_TOA1_Msk                (0x10UL)                  /*!< TOA1 (Bitfield-Mask: 0x01)                            */
#define TMM_TMOCR_TOB1_Pos                (5UL)                     /*!< TOB1 (Bit 5)                                          */
#define TMM_TMOCR_TOB1_Msk                (0x20UL)                  /*!< TOB1 (Bitfield-Mask: 0x01)                            */
#define TMM_TMOCR_TOC1_Pos                (6UL)                     /*!< TOC1 (Bit 6)                                          */
#define TMM_TMOCR_TOC1_Msk                (0x40UL)                  /*!< TOC1 (Bitfield-Mask: 0x01)                            */
#define TMM_TMOCR_TOD1_Pos                (7UL)                     /*!< TOD1 (Bit 7)                                          */
#define TMM_TMOCR_TOD1_Msk                (0x80UL)                  /*!< TOD1 (Bitfield-Mask: 0x01)                            */
/* =========================================================  TMDF0  ========================================================= */
#define TMM_TMDF0_DFA_Pos                 (0UL)                     /*!< DFA (Bit 0)                                           */
#define TMM_TMDF0_DFA_Msk                 (0x1UL)                   /*!< DFA (Bitfield-Mask: 0x01)                             */
#define TMM_TMDF0_DFB_Pos                 (1UL)                     /*!< DFB (Bit 1)                                           */
#define TMM_TMDF0_DFB_Msk                 (0x2UL)                   /*!< DFB (Bitfield-Mask: 0x01)                             */
#define TMM_TMDF0_DFC_Pos                 (2UL)                     /*!< DFC (Bit 2)                                           */
#define TMM_TMDF0_DFC_Msk                 (0x4UL)                   /*!< DFC (Bitfield-Mask: 0x01)                             */
#define TMM_TMDF0_DFD_Pos                 (3UL)                     /*!< DFD (Bit 3)                                           */
#define TMM_TMDF0_DFD_Msk                 (0x8UL)                   /*!< DFD (Bitfield-Mask: 0x01)                             */
#define TMM_TMDF0_PENB_Pos                (4UL)                     /*!< PENB (Bit 4)                                          */
#define TMM_TMDF0_PENB_Msk                (0x30UL)                  /*!< PENB (Bitfield-Mask: 0x03)                            */
#define TMM_TMDF0_DFCK_Pos                (6UL)                     /*!< DFCK (Bit 6)                                          */
#define TMM_TMDF0_DFCK_Msk                (0xc0UL)                  /*!< DFCK (Bitfield-Mask: 0x03)                            */
/* =========================================================  TMDF1  ========================================================= */
#define TMM_TMDF1_DFA_Pos                 (0UL)                     /*!< DFA (Bit 0)                                           */
#define TMM_TMDF1_DFA_Msk                 (0x1UL)                   /*!< DFA (Bitfield-Mask: 0x01)                             */
#define TMM_TMDF1_DFB_Pos                 (1UL)                     /*!< DFB (Bit 1)                                           */
#define TMM_TMDF1_DFB_Msk                 (0x2UL)                   /*!< DFB (Bitfield-Mask: 0x01)                             */
#define TMM_TMDF1_DFC_Pos                 (2UL)                     /*!< DFC (Bit 2)                                           */
#define TMM_TMDF1_DFC_Msk                 (0x4UL)                   /*!< DFC (Bitfield-Mask: 0x01)                             */
#define TMM_TMDF1_DFD_Pos                 (3UL)                     /*!< DFD (Bit 3)                                           */
#define TMM_TMDF1_DFD_Msk                 (0x8UL)                   /*!< DFD (Bitfield-Mask: 0x01)                             */
#define TMM_TMDF1_PENB_Pos                (4UL)                     /*!< PENB (Bit 4)                                          */
#define TMM_TMDF1_PENB_Msk                (0x30UL)                  /*!< PENB (Bitfield-Mask: 0x03)                            */
#define TMM_TMDF1_DFCK_Pos                (6UL)                     /*!< DFCK (Bit 6)                                          */
#define TMM_TMDF1_DFCK_Msk                (0xc0UL)                  /*!< DFCK (Bitfield-Mask: 0x03)                            */
/* =========================================================  TMDR  ========================================================== */
#define TMM_TMDR_DNUM_Pos                 (0UL)                     /*!< DNUM (Bit 0)                                          */
#define TMM_TMDR_DNUM_Msk                 (0x1ffUL)                 /*!< DNUM (Bitfield-Mask: 0x1ff)                           */
#define TMM_TMDR_DSIDE_Pos                (14UL)                    /*!< DSIDE (Bit 14)                                        */
#define TMM_TMDR_DSIDE_Msk                (0xc000UL)                /*!< DSIDE (Bitfield-Mask: 0x03)                           */
/* =========================================================  TMCR0  ========================================================= */
#define TMM_TMCR0_TCK_Pos                 (0UL)                     /*!< TCK (Bit 0)                                           */
#define TMM_TMCR0_TCK_Msk                 (0x7UL)                   /*!< TCK (Bitfield-Mask: 0x07)                             */
#define TMM_TMCR0_CKEG_Pos                (3UL)                     /*!< CKEG (Bit 3)                                          */
#define TMM_TMCR0_CKEG_Msk                (0x18UL)                  /*!< CKEG (Bitfield-Mask: 0x03)                            */
#define TMM_TMCR0_CCLR_Pos                (5UL)                     /*!< CCLR (Bit 5)                                          */
#define TMM_TMCR0_CCLR_Msk                (0xe0UL)                  /*!< CCLR (Bitfield-Mask: 0x07)                            */
/* =========================================================  TMCR1  ========================================================= */
#define TMM_TMCR1_TCK_Pos                 (0UL)                     /*!< TCK (Bit 0)                                           */
#define TMM_TMCR1_TCK_Msk                 (0x7UL)                   /*!< TCK (Bitfield-Mask: 0x07)                             */
#define TMM_TMCR1_CKEG_Pos                (3UL)                     /*!< CKEG (Bit 3)                                          */
#define TMM_TMCR1_CKEG_Msk                (0x18UL)                  /*!< CKEG (Bitfield-Mask: 0x03)                            */
#define TMM_TMCR1_CCLR_Pos                (5UL)                     /*!< CCLR (Bit 5)                                          */
#define TMM_TMCR1_CCLR_Msk                (0xe0UL)                  /*!< CCLR (Bitfield-Mask: 0x07)                            */
/* ========================================================  TMIORA0  ======================================================== */
#define TMM_TMIORA0_IOA_Pos               (0UL)                     /*!< IOA (Bit 0)                                           */
#define TMM_TMIORA0_IOA_Msk               (0x7UL)                   /*!< IOA (Bitfield-Mask: 0x07)                             */
#define TMM_TMIORA0_IOB_Pos               (4UL)                     /*!< IOB (Bit 4)                                           */
#define TMM_TMIORA0_IOB_Msk               (0x70UL)                  /*!< IOB (Bitfield-Mask: 0x07)                             */
/* ========================================================  TMIORA1  ======================================================== */
#define TMM_TMIORA1_IOA_Pos               (0UL)                     /*!< IOA (Bit 0)                                           */
#define TMM_TMIORA1_IOA_Msk               (0x7UL)                   /*!< IOA (Bitfield-Mask: 0x07)                             */
#define TMM_TMIORA1_IOB_Pos               (4UL)                     /*!< IOB (Bit 4)                                           */
#define TMM_TMIORA1_IOB_Msk               (0x70UL)                  /*!< IOB (Bitfield-Mask: 0x07)                             */
/* ========================================================  TMIORC0  ======================================================== */
#define TMM_TMIORC0_IOC_Pos               (0UL)                     /*!< IOC (Bit 0)                                           */
#define TMM_TMIORC0_IOC_Msk               (0xfUL)                   /*!< IOC (Bitfield-Mask: 0x0f)                             */
#define TMM_TMIORC0_IOD_Pos               (4UL)                     /*!< IOD (Bit 4)                                           */
#define TMM_TMIORC0_IOD_Msk               (0xf0UL)                  /*!< IOD (Bitfield-Mask: 0x0f)                             */
/* ========================================================  TMIORC1  ======================================================== */
#define TMM_TMIORC1_IOC_Pos               (0UL)                     /*!< IOC (Bit 0)                                           */
#define TMM_TMIORC1_IOC_Msk               (0xfUL)                   /*!< IOC (Bitfield-Mask: 0x0f)                             */
#define TMM_TMIORC1_IOD_Pos               (4UL)                     /*!< IOD (Bit 4)                                           */
#define TMM_TMIORC1_IOD_Msk               (0xf0UL)                  /*!< IOD (Bitfield-Mask: 0x0f)                             */
/* =========================================================  TMSR0  ========================================================= */
#define TMM_TMSR0_IMFA_Pos                (0UL)                     /*!< IMFA (Bit 0)                                          */
#define TMM_TMSR0_IMFA_Msk                (0x1UL)                   /*!< IMFA (Bitfield-Mask: 0x01)                            */
#define TMM_TMSR0_IMFB_Pos                (1UL)                     /*!< IMFB (Bit 1)                                          */
#define TMM_TMSR0_IMFB_Msk                (0x2UL)                   /*!< IMFB (Bitfield-Mask: 0x01)                            */
#define TMM_TMSR0_IMFC_Pos                (2UL)                     /*!< IMFC (Bit 2)                                          */
#define TMM_TMSR0_IMFC_Msk                (0x4UL)                   /*!< IMFC (Bitfield-Mask: 0x01)                            */
#define TMM_TMSR0_IMFD_Pos                (3UL)                     /*!< IMFD (Bit 3)                                          */
#define TMM_TMSR0_IMFD_Msk                (0x8UL)                   /*!< IMFD (Bitfield-Mask: 0x01)                            */
#define TMM_TMSR0_OVF_Pos                 (4UL)                     /*!< OVF (Bit 4)                                           */
#define TMM_TMSR0_OVF_Msk                 (0x10UL)                  /*!< OVF (Bitfield-Mask: 0x01)                             */
/* =========================================================  TMSR1  ========================================================= */
#define TMM_TMSR1_IMFA_Pos                (0UL)                     /*!< IMFA (Bit 0)                                          */
#define TMM_TMSR1_IMFA_Msk                (0x1UL)                   /*!< IMFA (Bitfield-Mask: 0x01)                            */
#define TMM_TMSR1_IMFB_Pos                (1UL)                     /*!< IMFB (Bit 1)                                          */
#define TMM_TMSR1_IMFB_Msk                (0x2UL)                   /*!< IMFB (Bitfield-Mask: 0x01)                            */
#define TMM_TMSR1_IMFC_Pos                (2UL)                     /*!< IMFC (Bit 2)                                          */
#define TMM_TMSR1_IMFC_Msk                (0x4UL)                   /*!< IMFC (Bitfield-Mask: 0x01)                            */
#define TMM_TMSR1_IMFD_Pos                (3UL)                     /*!< IMFD (Bit 3)                                          */
#define TMM_TMSR1_IMFD_Msk                (0x8UL)                   /*!< IMFD (Bitfield-Mask: 0x01)                            */
#define TMM_TMSR1_OVF_Pos                 (4UL)                     /*!< OVF (Bit 4)                                           */
#define TMM_TMSR1_OVF_Msk                 (0x10UL)                  /*!< OVF (Bitfield-Mask: 0x01)                             */
#define TMM_TMSR1_UDF_Pos                 (5UL)                     /*!< UDF (Bit 5)                                           */
#define TMM_TMSR1_UDF_Msk                 (0x20UL)                  /*!< UDF (Bitfield-Mask: 0x01)                             */
/* ========================================================  TMIER0  ========================================================= */
#define TMM_TMIER0_IMIEA_Pos              (0UL)                     /*!< IMIEA (Bit 0)                                         */
#define TMM_TMIER0_IMIEA_Msk              (0x1UL)                   /*!< IMIEA (Bitfield-Mask: 0x01)                           */
#define TMM_TMIER0_IMIEB_Pos              (1UL)                     /*!< IMIEB (Bit 1)                                         */
#define TMM_TMIER0_IMIEB_Msk              (0x2UL)                   /*!< IMIEB (Bitfield-Mask: 0x01)                           */
#define TMM_TMIER0_IMIEC_Pos              (2UL)                     /*!< IMIEC (Bit 2)                                         */
#define TMM_TMIER0_IMIEC_Msk              (0x4UL)                   /*!< IMIEC (Bitfield-Mask: 0x01)                           */
#define TMM_TMIER0_IMIED_Pos              (3UL)                     /*!< IMIED (Bit 3)                                         */
#define TMM_TMIER0_IMIED_Msk              (0x8UL)                   /*!< IMIED (Bitfield-Mask: 0x01)                           */
#define TMM_TMIER0_OVIE_Pos               (4UL)                     /*!< OVIE (Bit 4)                                          */
#define TMM_TMIER0_OVIE_Msk               (0x10UL)                  /*!< OVIE (Bitfield-Mask: 0x01)                            */
/* ========================================================  TMIER1  ========================================================= */
#define TMM_TMIER1_IMIEA_Pos              (0UL)                     /*!< IMIEA (Bit 0)                                         */
#define TMM_TMIER1_IMIEA_Msk              (0x1UL)                   /*!< IMIEA (Bitfield-Mask: 0x01)                           */
#define TMM_TMIER1_IMIEB_Pos              (1UL)                     /*!< IMIEB (Bit 1)                                         */
#define TMM_TMIER1_IMIEB_Msk              (0x2UL)                   /*!< IMIEB (Bitfield-Mask: 0x01)                           */
#define TMM_TMIER1_IMIEC_Pos              (2UL)                     /*!< IMIEC (Bit 2)                                         */
#define TMM_TMIER1_IMIEC_Msk              (0x4UL)                   /*!< IMIEC (Bitfield-Mask: 0x01)                           */
#define TMM_TMIER1_IMIED_Pos              (3UL)                     /*!< IMIED (Bit 3)                                         */
#define TMM_TMIER1_IMIED_Msk              (0x8UL)                   /*!< IMIED (Bitfield-Mask: 0x01)                           */
#define TMM_TMIER1_OVIE_Pos               (4UL)                     /*!< OVIE (Bit 4)                                          */
#define TMM_TMIER1_OVIE_Msk               (0x10UL)                  /*!< OVIE (Bitfield-Mask: 0x01)                            */
/* ========================================================  TMPOCR0  ======================================================== */
#define TMM_TMPOCR0_POLB_Pos              (0UL)                     /*!< POLB (Bit 0)                                          */
#define TMM_TMPOCR0_POLB_Msk              (0x1UL)                   /*!< POLB (Bitfield-Mask: 0x01)                            */
#define TMM_TMPOCR0_POLC_Pos              (1UL)                     /*!< POLC (Bit 1)                                          */
#define TMM_TMPOCR0_POLC_Msk              (0x2UL)                   /*!< POLC (Bitfield-Mask: 0x01)                            */
#define TMM_TMPOCR0_POLD_Pos              (2UL)                     /*!< POLD (Bit 2)                                          */
#define TMM_TMPOCR0_POLD_Msk              (0x4UL)                   /*!< POLD (Bitfield-Mask: 0x01)                            */
/* ========================================================  TMPOCR1  ======================================================== */
#define TMM_TMPOCR1_POLB_Pos              (0UL)                     /*!< POLB (Bit 0)                                          */
#define TMM_TMPOCR1_POLB_Msk              (0x1UL)                   /*!< POLB (Bitfield-Mask: 0x01)                            */
#define TMM_TMPOCR1_POLC_Pos              (1UL)                     /*!< POLC (Bit 1)                                          */
#define TMM_TMPOCR1_POLC_Msk              (0x2UL)                   /*!< POLC (Bitfield-Mask: 0x01)                            */
#define TMM_TMPOCR1_POLD_Pos              (2UL)                     /*!< POLD (Bit 2)                                          */
#define TMM_TMPOCR1_POLD_Msk              (0x4UL)                   /*!< POLD (Bitfield-Mask: 0x01)                            */
/* ==========================================================  TM0  ========================================================== */
/* ==========================================================  TM1  ========================================================== */
/* ========================================================  TMGRA0  ========================================================= */
/* ========================================================  TMGRA1  ========================================================= */
/* ========================================================  TMGRB0  ========================================================= */
/* ========================================================  TMGRB1  ========================================================= */
/* ========================================================  TMGRC0  ========================================================= */
/* ========================================================  TMGRC0M  ======================================================== */
/* ========================================================  TMGRC1  ========================================================= */
/* ========================================================  TMGRC1M  ======================================================== */
/* ========================================================  TMGRD0  ========================================================= */
/* ========================================================  TMGRD0M  ======================================================== */
/* ========================================================  TMGRD1  ========================================================= */
/* ========================================================  TMGRD1M  ======================================================== */
/* ========================================================  OPCTL0  ========================================================= */
#define TMM_OPCTL0_HS_SEL_Pos             (0UL)                     /*!< HS_SEL (Bit 0)                                        */
#define TMM_OPCTL0_HS_SEL_Msk             (0x1UL)                   /*!< HS_SEL (Bitfield-Mask: 0x01)                          */
#define TMM_OPCTL0_HZ_REL_Pos             (1UL)                     /*!< HZ_REL (Bit 1)                                        */
#define TMM_OPCTL0_HZ_REL_Msk             (0x2UL)                   /*!< HZ_REL (Bitfield-Mask: 0x01)                          */
#define TMM_OPCTL0_ACT_Pos                (2UL)                     /*!< ACT (Bit 2)                                           */
#define TMM_OPCTL0_ACT_Msk                (0x4UL)                   /*!< ACT (Bitfield-Mask: 0x01)                             */
#define TMM_OPCTL0_IN_SEL_Pos             (3UL)                     /*!< IN_SEL (Bit 3)                                        */
#define TMM_OPCTL0_IN_SEL_Msk             (0x18UL)                  /*!< IN_SEL (Bitfield-Mask: 0x03)                          */
#define TMM_OPCTL0_IN_EG_Pos              (5UL)                     /*!< IN_EG (Bit 5)                                         */
#define TMM_OPCTL0_IN_EG_Msk              (0x20UL)                  /*!< IN_EG (Bitfield-Mask: 0x01)                           */
#define TMM_OPCTL0_HAZAD_SET_Pos          (6UL)                     /*!< HAZAD_SET (Bit 6)                                     */
#define TMM_OPCTL0_HAZAD_SET_Msk          (0x40UL)                  /*!< HAZAD_SET (Bitfield-Mask: 0x01)                       */
/* =========================================================  OPDF0  ========================================================= */
#define TMM_OPDF0_DFA0_Pos                (0UL)                     /*!< DFA0 (Bit 0)                                          */
#define TMM_OPDF0_DFA0_Msk                (0x3UL)                   /*!< DFA0 (Bitfield-Mask: 0x03)                            */
#define TMM_OPDF0_DFB0_Pos                (2UL)                     /*!< DFB0 (Bit 2)                                          */
#define TMM_OPDF0_DFB0_Msk                (0xcUL)                   /*!< DFB0 (Bitfield-Mask: 0x03)                            */
#define TMM_OPDF0_DFC0_Pos                (4UL)                     /*!< DFC0 (Bit 4)                                          */
#define TMM_OPDF0_DFC0_Msk                (0x30UL)                  /*!< DFC0 (Bitfield-Mask: 0x03)                            */
#define TMM_OPDF0_DFD0_Pos                (6UL)                     /*!< DFD0 (Bit 6)                                          */
#define TMM_OPDF0_DFD0_Msk                (0xc0UL)                  /*!< DFD0 (Bitfield-Mask: 0x03)                            */
/* =========================================================  OPDF1  ========================================================= */
#define TMM_OPDF1_DFA1_Pos                (0UL)                     /*!< DFA1 (Bit 0)                                          */
#define TMM_OPDF1_DFA1_Msk                (0x3UL)                   /*!< DFA1 (Bitfield-Mask: 0x03)                            */
#define TMM_OPDF1_DFB1_Pos                (2UL)                     /*!< DFB1 (Bit 2)                                          */
#define TMM_OPDF1_DFB1_Msk                (0xcUL)                   /*!< DFB1 (Bitfield-Mask: 0x03)                            */
#define TMM_OPDF1_DFC1_Pos                (4UL)                     /*!< DFC1 (Bit 4)                                          */
#define TMM_OPDF1_DFC1_Msk                (0x30UL)                  /*!< DFC1 (Bitfield-Mask: 0x03)                            */
#define TMM_OPDF1_DFD1_Pos                (6UL)                     /*!< DFD1 (Bit 6)                                          */
#define TMM_OPDF1_DFD1_Msk                (0xc0UL)                  /*!< DFD1 (Bitfield-Mask: 0x03)                            */
/* ========================================================  OPEDGE  ========================================================= */
#define TMM_OPEDGE_EG_Pos                 (0UL)                     /*!< EG (Bit 0)                                            */
#define TMM_OPEDGE_EG_Msk                 (0x3UL)                   /*!< EG (Bitfield-Mask: 0x03)                              */
/* =========================================================  OPSR  ========================================================== */
#define TMM_OPSR_HZIF0_Pos                (0UL)                     /*!< HZIF0 (Bit 0)                                         */
#define TMM_OPSR_HZIF0_Msk                (0x1UL)                   /*!< HZIF0 (Bitfield-Mask: 0x01)                           */
#define TMM_OPSR_HZOF0_Pos                (1UL)                     /*!< HZOF0 (Bit 1)                                         */
#define TMM_OPSR_HZOF0_Msk                (0x2UL)                   /*!< HZOF0 (Bitfield-Mask: 0x01)                           */
#define TMM_OPSR_HZOF1_Pos                (2UL)                     /*!< HZOF1 (Bit 2)                                         */
#define TMM_OPSR_HZOF1_Msk                (0x4UL)                   /*!< HZOF1 (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                           PCBZ                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  CKS0  ========================================================== */
#define PCBZ_CKS0_CCS_Pos                 (0UL)                     /*!< CCS (Bit 0)                                           */
#define PCBZ_CKS0_CCS_Msk                 (0x7UL)                   /*!< CCS (Bitfield-Mask: 0x07)                             */
#define PCBZ_CKS0_CSEL_Pos                (3UL)                     /*!< CSEL (Bit 3)                                          */
#define PCBZ_CKS0_CSEL_Msk                (0x8UL)                   /*!< CSEL (Bitfield-Mask: 0x01)                            */
#define PCBZ_CKS0_PCLOE_Pos               (7UL)                     /*!< PCLOE (Bit 7)                                         */
#define PCBZ_CKS0_PCLOE_Msk               (0x80UL)                  /*!< PCLOE (Bitfield-Mask: 0x01)                           */
/* =========================================================  CKS1  ========================================================== */
#define PCBZ_CKS1_CCS_Pos                 (0UL)                     /*!< CCS (Bit 0)                                           */
#define PCBZ_CKS1_CCS_Msk                 (0x7UL)                   /*!< CCS (Bitfield-Mask: 0x07)                             */
#define PCBZ_CKS1_CSEL_Pos                (3UL)                     /*!< CSEL (Bit 3)                                          */
#define PCBZ_CKS1_CSEL_Msk                (0x8UL)                   /*!< CSEL (Bitfield-Mask: 0x01)                            */
#define PCBZ_CKS1_PCLOE_Pos               (7UL)                     /*!< PCLOE (Bit 7)                                         */
#define PCBZ_CKS1_PCLOE_Msk               (0x80UL)                  /*!< PCLOE (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                            LIN                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  LWBR  ========================================================== */
#define LIN_LWBR_LWBR0_Pos                (0UL)                     /*!< LWBR0 (Bit 0)                                         */
#define LIN_LWBR_LWBR0_Msk                (0x1UL)                   /*!< LWBR0 (Bitfield-Mask: 0x01)                           */
#define LIN_LWBR_LPRS_Pos                 (1UL)                     /*!< LPRS (Bit 1)                                          */
#define LIN_LWBR_LPRS_Msk                 (0xeUL)                   /*!< LPRS (Bitfield-Mask: 0x07)                            */
#define LIN_LWBR_NSPB_Pos                 (4UL)                     /*!< NSPB (Bit 4)                                          */
#define LIN_LWBR_NSPB_Msk                 (0xf0UL)                  /*!< NSPB (Bitfield-Mask: 0x0f)                            */
/* =========================================================  LBRP0  ========================================================= */
/* =========================================================  LBRP1  ========================================================= */
/* =========================================================  LSTC  ========================================================== */
#define LIN_LSTC_LSTM_Pos                 (0UL)                     /*!< LSTM (Bit 0)                                          */
#define LIN_LSTC_LSTM_Msk                 (0x1UL)                   /*!< LSTM (Bitfield-Mask: 0x01)                            */
/* =========================================================  LUSC  ========================================================== */
#define LIN_LUSC_UWC_Pos                  (0UL)                     /*!< UWC (Bit 0)                                           */
#define LIN_LUSC_UWC_Msk                  (0x1UL)                   /*!< UWC (Bitfield-Mask: 0x01)                             */
#define LIN_LUSC_USEC_Pos                 (1UL)                     /*!< USEC (Bit 1)                                          */
#define LIN_LUSC_USEC_Msk                 (0x2UL)                   /*!< USEC (Bitfield-Mask: 0x01)                            */
#define LIN_LUSC_URDCC_Pos                (2UL)                     /*!< URDCC (Bit 2)                                         */
#define LIN_LUSC_URDCC_Msk                (0x4UL)                   /*!< URDCC (Bitfield-Mask: 0x01)                           */
/* ==========================================================  LMD  ========================================================== */
#define LIN_LMD_LMD_Pos                   (0UL)                     /*!< LMD (Bit 0)                                           */
#define LIN_LMD_LMD_Msk                   (0x3UL)                   /*!< LMD (Bitfield-Mask: 0x03)                             */
#define LIN_LMD_LRDNFS_Pos                (5UL)                     /*!< LRDNFS (Bit 5)                                        */
#define LIN_LMD_LRDNFS_Msk                (0x20UL)                  /*!< LRDNFS (Bitfield-Mask: 0x01)                          */
/* =========================================================  LBFC  ========================================================== */
#define LIN_LBFC_UBLS_Pos                 (0UL)                     /*!< UBLS (Bit 0)                                          */
#define LIN_LBFC_UBLS_Msk                 (0x1UL)                   /*!< UBLS (Bitfield-Mask: 0x01)                            */
#define LIN_LBFC_UBOS_Pos                 (1UL)                     /*!< UBOS (Bit 1)                                          */
#define LIN_LBFC_UBOS_Msk                 (0x2UL)                   /*!< UBOS (Bitfield-Mask: 0x01)                            */
#define LIN_LBFC_USBLS_Pos                (2UL)                     /*!< USBLS (Bit 2)                                         */
#define LIN_LBFC_USBLS_Msk                (0x4UL)                   /*!< USBLS (Bitfield-Mask: 0x01)                           */
#define LIN_LBFC_UPS_Pos                  (3UL)                     /*!< UPS (Bit 3)                                           */
#define LIN_LBFC_UPS_Msk                  (0x18UL)                  /*!< UPS (Bitfield-Mask: 0x03)                             */
#define LIN_LBFC_URPS_Pos                 (5UL)                     /*!< URPS (Bit 5)                                          */
#define LIN_LBFC_URPS_Msk                 (0x20UL)                  /*!< URPS (Bitfield-Mask: 0x01)                            */
#define LIN_LBFC_UTPS_Pos                 (6UL)                     /*!< UTPS (Bit 6)                                          */
#define LIN_LBFC_UTPS_Msk                 (0x40UL)                  /*!< UTPS (Bitfield-Mask: 0x01)                            */
/* ==========================================================  LSC  ========================================================== */
#define LIN_LSC_IBS_Pos                   (4UL)                     /*!< IBS (Bit 4)                                           */
#define LIN_LSC_IBS_Msk                   (0x30UL)                  /*!< IBS (Bitfield-Mask: 0x03)                             */
/* =========================================================  LWUP  ========================================================== */
#define LIN_LWUP_WUTL_Pos                 (4UL)                     /*!< WUTL (Bit 4)                                          */
#define LIN_LWUP_WUTL_Msk                 (0xf0UL)                  /*!< WUTL (Bitfield-Mask: 0x0f)                            */
/* ==========================================================  LIE  ========================================================== */
#define LIN_LIE_FTCIE_Pos                 (0UL)                     /*!< FTCIE (Bit 0)                                         */
#define LIN_LIE_FTCIE_Msk                 (0x1UL)                   /*!< FTCIE (Bitfield-Mask: 0x01)                           */
#define LIN_LIE_FRCIE_Pos                 (1UL)                     /*!< FRCIE (Bit 1)                                         */
#define LIN_LIE_FRCIE_Msk                 (0x2UL)                   /*!< FRCIE (Bitfield-Mask: 0x01)                           */
#define LIN_LIE_ERRIE_Pos                 (2UL)                     /*!< ERRIE (Bit 2)                                         */
#define LIN_LIE_ERRIE_Msk                 (0x4UL)                   /*!< ERRIE (Bitfield-Mask: 0x01)                           */
#define LIN_LIE_SHIE_Pos                  (3UL)                     /*!< SHIE (Bit 3)                                          */
#define LIN_LIE_SHIE_Msk                  (0x8UL)                   /*!< SHIE (Bitfield-Mask: 0x01)                            */
/* =========================================================  LEDE  ========================================================== */
#define LIN_LEDE_BERE_Pos                 (0UL)                     /*!< BERE (Bit 0)                                          */
#define LIN_LEDE_BERE_Msk                 (0x1UL)                   /*!< BERE (Bitfield-Mask: 0x01)                            */
#define LIN_LEDE_TERE_Pos                 (2UL)                     /*!< TERE (Bit 2)                                          */
#define LIN_LEDE_TERE_Msk                 (0x4UL)                   /*!< TERE (Bitfield-Mask: 0x01)                            */
#define LIN_LEDE_FERE_Pos                 (3UL)                     /*!< FERE (Bit 3)                                          */
#define LIN_LEDE_FERE_Msk                 (0x8UL)                   /*!< FERE (Bitfield-Mask: 0x01)                            */
#define LIN_LEDE_SFERE_Pos                (4UL)                     /*!< SFERE (Bit 4)                                         */
#define LIN_LEDE_SFERE_Msk                (0x10UL)                  /*!< SFERE (Bitfield-Mask: 0x01)                           */
#define LIN_LEDE_IPERE_Pos                (6UL)                     /*!< IPERE (Bit 6)                                         */
#define LIN_LEDE_IPERE_Msk                (0x40UL)                  /*!< IPERE (Bitfield-Mask: 0x01)                           */
#define LIN_LEDE_LTES_Pos                 (7UL)                     /*!< LTES (Bit 7)                                          */
#define LIN_LEDE_LTES_Msk                 (0x80UL)                  /*!< LTES (Bitfield-Mask: 0x01)                            */
/* =========================================================  LCUC  ========================================================== */
#define LIN_LCUC_OM0_Pos                  (0UL)                     /*!< OM0 (Bit 0)                                           */
#define LIN_LCUC_OM0_Msk                  (0x1UL)                   /*!< OM0 (Bitfield-Mask: 0x01)                             */
#define LIN_LCUC_OM1_Pos                  (1UL)                     /*!< OM1 (Bit 1)                                           */
#define LIN_LCUC_OM1_Msk                  (0x2UL)                   /*!< OM1 (Bitfield-Mask: 0x01)                             */
/* =========================================================  LTRC  ========================================================== */
#define LIN_LTRC_FTS_Pos                  (0UL)                     /*!< FTS (Bit 0)                                           */
#define LIN_LTRC_FTS_Msk                  (0x1UL)                   /*!< FTS (Bitfield-Mask: 0x01)                             */
#define LIN_LTRC_RTS_Pos                  (1UL)                     /*!< RTS (Bit 1)                                           */
#define LIN_LTRC_RTS_Msk                  (0x2UL)                   /*!< RTS (Bitfield-Mask: 0x01)                             */
#define LIN_LTRC_LNRR_Pos                 (2UL)                     /*!< LNRR (Bit 2)                                          */
#define LIN_LTRC_LNRR_Msk                 (0x4UL)                   /*!< LNRR (Bitfield-Mask: 0x01)                            */
/* =========================================================  LMST  ========================================================== */
#define LIN_LMST_OMM0_Pos                 (0UL)                     /*!< OMM0 (Bit 0)                                          */
#define LIN_LMST_OMM0_Msk                 (0x1UL)                   /*!< OMM0 (Bitfield-Mask: 0x01)                            */
#define LIN_LMST_OMM1_Pos                 (1UL)                     /*!< OMM1 (Bit 1)                                          */
#define LIN_LMST_OMM1_Msk                 (0x2UL)                   /*!< OMM1 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  LST  ========================================================== */
#define LIN_LST_FTC_Pos                   (0UL)                     /*!< FTC (Bit 0)                                           */
#define LIN_LST_FTC_Msk                   (0x1UL)                   /*!< FTC (Bitfield-Mask: 0x01)                             */
#define LIN_LST_FRC_Pos                   (1UL)                     /*!< FRC (Bit 1)                                           */
#define LIN_LST_FRC_Msk                   (0x2UL)                   /*!< FRC (Bitfield-Mask: 0x01)                             */
#define LIN_LST_ERR_Pos                   (3UL)                     /*!< ERR (Bit 3)                                           */
#define LIN_LST_ERR_Msk                   (0x8UL)                   /*!< ERR (Bitfield-Mask: 0x01)                             */
#define LIN_LST_D1RC_Pos                  (6UL)                     /*!< D1RC (Bit 6)                                          */
#define LIN_LST_D1RC_Msk                  (0x40UL)                  /*!< D1RC (Bitfield-Mask: 0x01)                            */
#define LIN_LST_HTRC_Pos                  (7UL)                     /*!< HTRC (Bit 7)                                          */
#define LIN_LST_HTRC_Msk                  (0x80UL)                  /*!< HTRC (Bitfield-Mask: 0x01)                            */
/* =========================================================  LEST  ========================================================== */
#define LIN_LEST_BER_Pos                  (0UL)                     /*!< BER (Bit 0)                                           */
#define LIN_LEST_BER_Msk                  (0x1UL)                   /*!< BER (Bitfield-Mask: 0x01)                             */
#define LIN_LEST_TER_Pos                  (2UL)                     /*!< TER (Bit 2)                                           */
#define LIN_LEST_TER_Msk                  (0x4UL)                   /*!< TER (Bitfield-Mask: 0x01)                             */
#define LIN_LEST_FER_Pos                  (3UL)                     /*!< FER (Bit 3)                                           */
#define LIN_LEST_FER_Msk                  (0x8UL)                   /*!< FER (Bitfield-Mask: 0x01)                             */
#define LIN_LEST_SFER_Pos                 (4UL)                     /*!< SFER (Bit 4)                                          */
#define LIN_LEST_SFER_Msk                 (0x10UL)                  /*!< SFER (Bitfield-Mask: 0x01)                            */
#define LIN_LEST_CSER_Pos                 (5UL)                     /*!< CSER (Bit 5)                                          */
#define LIN_LEST_CSER_Msk                 (0x20UL)                  /*!< CSER (Bitfield-Mask: 0x01)                            */
#define LIN_LEST_IPER_Pos                 (6UL)                     /*!< IPER (Bit 6)                                          */
#define LIN_LEST_IPER_Msk                 (0x40UL)                  /*!< IPER (Bitfield-Mask: 0x01)                            */
#define LIN_LEST_RPER_Pos                 (7UL)                     /*!< RPER (Bit 7)                                          */
#define LIN_LEST_RPER_Msk                 (0x80UL)                  /*!< RPER (Bitfield-Mask: 0x01)                            */
/* =========================================================  LDFC  ========================================================== */
#define LIN_LDFC_RFDL_Pos                 (0UL)                     /*!< RFDL (Bit 0)                                          */
#define LIN_LDFC_RFDL_Msk                 (0xfUL)                   /*!< RFDL (Bitfield-Mask: 0x0f)                            */
#define LIN_LDFC_RCDS_Pos                 (4UL)                     /*!< RCDS (Bit 4)                                          */
#define LIN_LDFC_RCDS_Msk                 (0x10UL)                  /*!< RCDS (Bitfield-Mask: 0x01)                            */
#define LIN_LDFC_LCS_Pos                  (5UL)                     /*!< LCS (Bit 5)                                           */
#define LIN_LDFC_LCS_Msk                  (0x20UL)                  /*!< LCS (Bitfield-Mask: 0x01)                             */
#define LIN_LDFC_LSS_Pos                  (7UL)                     /*!< LSS (Bit 7)                                           */
#define LIN_LDFC_LSS_Msk                  (0x80UL)                  /*!< LSS (Bitfield-Mask: 0x01)                             */
/* =========================================================  LIDB  ========================================================== */
#define LIN_LIDB_ID_Pos                   (0UL)                     /*!< ID (Bit 0)                                            */
#define LIN_LIDB_ID_Msk                   (0x3fUL)                  /*!< ID (Bitfield-Mask: 0x3f)                              */
#define LIN_LIDB_IDP_Pos                  (6UL)                     /*!< IDP (Bit 6)                                           */
#define LIN_LIDB_IDP_Msk                  (0xc0UL)                  /*!< IDP (Bitfield-Mask: 0x03)                             */
/* =========================================================  LCBR  ========================================================== */
/* =========================================================  LUDB0  ========================================================= */
/* =========================================================  LDB1  ========================================================== */
/* =========================================================  LDB2  ========================================================== */
/* =========================================================  LDB3  ========================================================== */
/* =========================================================  LDB4  ========================================================== */
/* =========================================================  LDB5  ========================================================== */
/* =========================================================  LDB6  ========================================================== */
/* =========================================================  LDB7  ========================================================== */
/* =========================================================  LDB8  ========================================================== */
/* =========================================================  LUOER  ========================================================= */
#define LIN_LUOER_UTOE_Pos                (0UL)                     /*!< UTOE (Bit 0)                                          */
#define LIN_LUOER_UTOE_Msk                (0x1UL)                   /*!< UTOE (Bitfield-Mask: 0x01)                            */
#define LIN_LUOER_UROE_Pos                (1UL)                     /*!< UROE (Bit 1)                                          */
#define LIN_LUOER_UROE_Msk                (0x2UL)                   /*!< UROE (Bitfield-Mask: 0x01)                            */
/* =========================================================  LUOR1  ========================================================= */
#define LIN_LUOR1_UEBE_Pos                (0UL)                     /*!< UEBE (Bit 0)                                          */
#define LIN_LUOR1_UEBE_Msk                (0x1UL)                   /*!< UEBE (Bitfield-Mask: 0x01)                            */
#define LIN_LUOR1_UEBDL_Pos               (1UL)                     /*!< UEBDL (Bit 1)                                         */
#define LIN_LUOR1_UEBDL_Msk               (0x2UL)                   /*!< UEBDL (Bitfield-Mask: 0x01)                           */
#define LIN_LUOR1_UEBDCE_Pos              (2UL)                     /*!< UEBDCE (Bit 2)                                        */
#define LIN_LUOR1_UEBDCE_Msk              (0x4UL)                   /*!< UEBDCE (Bitfield-Mask: 0x01)                          */
#define LIN_LUOR1_UTIGTS_Pos              (3UL)                     /*!< UTIGTS (Bit 3)                                        */
#define LIN_LUOR1_UTIGTS_Msk              (0x8UL)                   /*!< UTIGTS (Bitfield-Mask: 0x01)                          */
#define LIN_LUOR1_UECD_Pos                (4UL)                     /*!< UECD (Bit 4)                                          */
#define LIN_LUOR1_UECD_Msk                (0x10UL)                  /*!< UECD (Bitfield-Mask: 0x01)                            */
/* =========================================================  LUTDR  ========================================================= */
#define LIN_LUTDR_LUTDR_Pos               (0UL)                     /*!< LUTDR (Bit 0)                                         */
#define LIN_LUTDR_LUTDR_Msk               (0x1ffUL)                 /*!< LUTDR (Bitfield-Mask: 0x1ff)                          */
/* =========================================================  LURDR  ========================================================= */
#define LIN_LURDR_LURDR_Pos               (0UL)                     /*!< LURDR (Bit 0)                                         */
#define LIN_LURDR_LURDR_Msk               (0x1ffUL)                 /*!< LURDR (Bitfield-Mask: 0x1ff)                          */
/* ========================================================  LUWTDR  ========================================================= */
#define LIN_LUWTDR_LUWTDR_Pos             (0UL)                     /*!< LUWTDR (Bit 0)                                        */
#define LIN_LUWTDR_LUWTDR_Msk             (0x1ffUL)                 /*!< LUWTDR (Bitfield-Mask: 0x1ff)                         */


/* =========================================================================================================================== */
/* ================                                            WDT                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  WDTE  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            ADC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  ADM0  ========================================================== */
#define ADC_ADM0_ADCE_Pos                 (0UL)                     /*!< ADCE (Bit 0)                                          */
#define ADC_ADM0_ADCE_Msk                 (0x1UL)                   /*!< ADCE (Bitfield-Mask: 0x01)                            */
#define ADC_ADM0_FR_Pos                   (3UL)                     /*!< FR (Bit 3)                                            */
#define ADC_ADM0_FR_Msk                   (0x38UL)                  /*!< FR (Bitfield-Mask: 0x07)                              */
#define ADC_ADM0_ADCS_Pos                 (7UL)                     /*!< ADCS (Bit 7)                                          */
#define ADC_ADM0_ADCS_Msk                 (0x80UL)                  /*!< ADCS (Bitfield-Mask: 0x01)                            */
/* =========================================================  ADM1  ========================================================== */
#define ADC_ADM1_ADMODE_Pos               (0UL)                     /*!< ADMODE (Bit 0)                                        */
#define ADC_ADM1_ADMODE_Msk               (0x3UL)                   /*!< ADMODE (Bitfield-Mask: 0x03)                          */
#define ADC_ADM1_ADSCM_Pos                (3UL)                     /*!< ADSCM (Bit 3)                                         */
#define ADC_ADM1_ADSCM_Msk                (0x8UL)                   /*!< ADSCM (Bitfield-Mask: 0x01)                           */
#define ADC_ADM1_ADMD_Pos                 (7UL)                     /*!< ADMD (Bit 7)                                          */
#define ADC_ADM1_ADMD_Msk                 (0x80UL)                  /*!< ADMD (Bitfield-Mask: 0x01)                            */
/* =========================================================  ADM2  ========================================================== */
#define ADC_ADM2_CHRDE_Pos                (1UL)                     /*!< CHRDE (Bit 1)                                         */
#define ADC_ADM2_CHRDE_Msk                (0x2UL)                   /*!< CHRDE (Bitfield-Mask: 0x01)                           */
#define ADC_ADM2_ADRCK_Pos                (3UL)                     /*!< ADRCK (Bit 3)                                         */
#define ADC_ADM2_ADRCK_Msk                (0x8UL)                   /*!< ADRCK (Bitfield-Mask: 0x01)                           */
#define ADC_ADM2_ADREFM_Pos               (5UL)                     /*!< ADREFM (Bit 5)                                        */
#define ADC_ADM2_ADREFM_Msk               (0x20UL)                  /*!< ADREFM (Bitfield-Mask: 0x01)                          */
#define ADC_ADM2_ADREFP_Pos               (6UL)                     /*!< ADREFP (Bit 6)                                        */
#define ADC_ADM2_ADREFP_Msk               (0xc0UL)                  /*!< ADREFP (Bitfield-Mask: 0x03)                          */
/* =========================================================  ADTRG  ========================================================= */
#define ADC_ADTRG_ADTMD_Pos               (6UL)                     /*!< ADTMD (Bit 6)                                         */
#define ADC_ADTRG_ADTMD_Msk               (0xc0UL)                  /*!< ADTMD (Bitfield-Mask: 0x03)                           */
#define ADC_ADTRG_ADTRS_Pos               (0UL)                     /*!< ADTRS (Bit 0)                                         */
#define ADC_ADTRG_ADTRS_Msk               (0x3UL)                   /*!< ADTRS (Bitfield-Mask: 0x03)                           */
/* ==========================================================  ADS  ========================================================== */
/* =========================================================  ADCR  ========================================================== */
/* =========================================================  ADCRH  ========================================================= */
/* =========================================================  ADUL  ========================================================== */
/* =========================================================  ADLL  ========================================================== */
/* =========================================================  ADTES  ========================================================= */
/* =========================================================  ADFLG  ========================================================= */
/* ========================================================  ADNSMP  ========================================================= */
/* =======================================================  ADSMPWAIT  ======================================================= */
/* ========================================================  ADNDIS  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            DAC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  DACS0  ========================================================= */
/* =========================================================  DACS1  ========================================================= */
/* ==========================================================  DAM  ========================================================== */
#define DAC_DAM_DAMD0_Pos                 (0UL)                     /*!< DAMD0 (Bit 0)                                         */
#define DAC_DAM_DAMD0_Msk                 (0x1UL)                   /*!< DAMD0 (Bitfield-Mask: 0x01)                           */
#define DAC_DAM_DAMD1_Pos                 (1UL)                     /*!< DAMD1 (Bit 1)                                         */
#define DAC_DAM_DAMD1_Msk                 (0x2UL)                   /*!< DAMD1 (Bitfield-Mask: 0x01)                           */
#define DAC_DAM_DACE0_Pos                 (2UL)                     /*!< DACE0 (Bit 2)                                         */
#define DAC_DAM_DACE0_Msk                 (0x4UL)                   /*!< DACE0 (Bitfield-Mask: 0x01)                           */
#define DAC_DAM_DACE1_Pos                 (3UL)                     /*!< DACE1 (Bit 3)                                         */
#define DAC_DAM_DACE1_Msk                 (0x8UL)                   /*!< DACE1 (Bitfield-Mask: 0x01)                           */
#define DAC_DAM_DBUF0_Pos                 (4UL)                     /*!< DBUF0 (Bit 4)                                         */
#define DAC_DAM_DBUF0_Msk                 (0x10UL)                  /*!< DBUF0 (Bitfield-Mask: 0x01)                           */
#define DAC_DAM_DBUF1_Pos                 (5UL)                     /*!< DBUF1 (Bit 5)                                         */
#define DAC_DAM_DBUF1_Msk                 (0x20UL)                  /*!< DBUF1 (Bitfield-Mask: 0x01)                           */
#define DAC_DAM_DRSTMD0_Pos               (6UL)                     /*!< DRSTMD0 (Bit 6)                                       */
#define DAC_DAM_DRSTMD0_Msk               (0x40UL)                  /*!< DRSTMD0 (Bitfield-Mask: 0x01)                         */
#define DAC_DAM_DRSTMD1_Pos               (7UL)                     /*!< DRSTMD1 (Bit 7)                                       */
#define DAC_DAM_DRSTMD1_Msk               (0x80UL)                  /*!< DRSTMD1 (Bitfield-Mask: 0x01)                         */
#define DAC_DAM_DVREF_Pos                 (8UL)                     /*!< DVREF (Bit 8)                                         */
#define DAC_DAM_DVREF_Msk                 (0x100UL)                 /*!< DVREF (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                            CMP                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  COMPMDR  ======================================================== */
#define CMP_COMPMDR_C0ENB_Pos             (0UL)                     /*!< C0ENB (Bit 0)                                         */
#define CMP_COMPMDR_C0ENB_Msk             (0x1UL)                   /*!< C0ENB (Bitfield-Mask: 0x01)                           */
#define CMP_COMPMDR_C0MON_Pos             (3UL)                     /*!< C0MON (Bit 3)                                         */
#define CMP_COMPMDR_C0MON_Msk             (0x8UL)                   /*!< C0MON (Bitfield-Mask: 0x01)                           */
#define CMP_COMPMDR_C1ENB_Pos             (4UL)                     /*!< C1ENB (Bit 4)                                         */
#define CMP_COMPMDR_C1ENB_Msk             (0x10UL)                  /*!< C1ENB (Bitfield-Mask: 0x01)                           */
#define CMP_COMPMDR_C1MON_Pos             (7UL)                     /*!< C1MON (Bit 7)                                         */
#define CMP_COMPMDR_C1MON_Msk             (0x80UL)                  /*!< C1MON (Bitfield-Mask: 0x01)                           */
/* ========================================================  COMPFIR  ======================================================== */
#define CMP_COMPFIR_C0FCK_Pos             (0UL)                     /*!< C0FCK (Bit 0)                                         */
#define CMP_COMPFIR_C0FCK_Msk             (0x3UL)                   /*!< C0FCK (Bitfield-Mask: 0x03)                           */
#define CMP_COMPFIR_C0EPO_Pos             (2UL)                     /*!< C0EPO (Bit 2)                                         */
#define CMP_COMPFIR_C0EPO_Msk             (0x4UL)                   /*!< C0EPO (Bitfield-Mask: 0x01)                           */
#define CMP_COMPFIR_C0EDG_Pos             (3UL)                     /*!< C0EDG (Bit 3)                                         */
#define CMP_COMPFIR_C0EDG_Msk             (0x8UL)                   /*!< C0EDG (Bitfield-Mask: 0x01)                           */
#define CMP_COMPFIR_C1FCK_Pos             (4UL)                     /*!< C1FCK (Bit 4)                                         */
#define CMP_COMPFIR_C1FCK_Msk             (0x30UL)                  /*!< C1FCK (Bitfield-Mask: 0x03)                           */
#define CMP_COMPFIR_C1EPO_Pos             (6UL)                     /*!< C1EPO (Bit 6)                                         */
#define CMP_COMPFIR_C1EPO_Msk             (0x40UL)                  /*!< C1EPO (Bitfield-Mask: 0x01)                           */
#define CMP_COMPFIR_C1EDG_Pos             (7UL)                     /*!< C1EDG (Bit 7)                                         */
#define CMP_COMPFIR_C1EDG_Msk             (0x80UL)                  /*!< C1EDG (Bitfield-Mask: 0x01)                           */
/* ========================================================  COMPOCR  ======================================================== */
#define CMP_COMPOCR_C0IE_Pos              (0UL)                     /*!< C0IE (Bit 0)                                          */
#define CMP_COMPOCR_C0IE_Msk              (0x1UL)                   /*!< C0IE (Bitfield-Mask: 0x01)                            */
#define CMP_COMPOCR_C0OE_Pos              (1UL)                     /*!< C0OE (Bit 1)                                          */
#define CMP_COMPOCR_C0OE_Msk              (0x2UL)                   /*!< C0OE (Bitfield-Mask: 0x01)                            */
#define CMP_COMPOCR_C0OP_Pos              (2UL)                     /*!< C0OP (Bit 2)                                          */
#define CMP_COMPOCR_C0OP_Msk              (0x4UL)                   /*!< C0OP (Bitfield-Mask: 0x01)                            */
#define CMP_COMPOCR_C1IE_Pos              (4UL)                     /*!< C1IE (Bit 4)                                          */
#define CMP_COMPOCR_C1IE_Msk              (0x10UL)                  /*!< C1IE (Bitfield-Mask: 0x01)                            */
#define CMP_COMPOCR_C1OE_Pos              (5UL)                     /*!< C1OE (Bit 5)                                          */
#define CMP_COMPOCR_C1OE_Msk              (0x20UL)                  /*!< C1OE (Bitfield-Mask: 0x01)                            */
#define CMP_COMPOCR_C1OP_Pos              (6UL)                     /*!< C1OP (Bit 6)                                          */
#define CMP_COMPOCR_C1OP_Msk              (0x40UL)                  /*!< C1OP (Bitfield-Mask: 0x01)                            */
#define CMP_COMPOCR_C1OTWMD_Pos           (7UL)                     /*!< C1OTWMD (Bit 7)                                       */
#define CMP_COMPOCR_C1OTWMD_Msk           (0x80UL)                  /*!< C1OTWMD (Bitfield-Mask: 0x01)                         */
/* ========================================================  CVRCTL  ========================================================= */
#define CMP_CVRCTL_CVRVS0_Pos             (0UL)                     /*!< CVRVS0 (Bit 0)                                        */
#define CMP_CVRCTL_CVRVS0_Msk             (0x1UL)                   /*!< CVRVS0 (Bitfield-Mask: 0x01)                          */
#define CMP_CVRCTL_CVRE0_Pos              (1UL)                     /*!< CVRE0 (Bit 1)                                         */
#define CMP_CVRCTL_CVRE0_Msk              (0x2UL)                   /*!< CVRE0 (Bitfield-Mask: 0x01)                           */
#define CMP_CVRCTL_CVRVS1_Pos             (4UL)                     /*!< CVRVS1 (Bit 4)                                        */
#define CMP_CVRCTL_CVRVS1_Msk             (0x10UL)                  /*!< CVRVS1 (Bitfield-Mask: 0x01)                          */
#define CMP_CVRCTL_CVRE1_Pos              (5UL)                     /*!< CVRE1 (Bit 5)                                         */
#define CMP_CVRCTL_CVRE1_Msk              (0x20UL)                  /*!< CVRE1 (Bitfield-Mask: 0x01)                           */
/* ========================================================  CMPSEL0  ======================================================== */
#define CMP_CMPSEL0_C0REFS_Pos            (0UL)                     /*!< C0REFS (Bit 0)                                        */
#define CMP_CMPSEL0_C0REFS_Msk            (0x3UL)                   /*!< C0REFS (Bitfield-Mask: 0x03)                          */
#define CMP_CMPSEL0_CMP0SEL_Pos           (7UL)                     /*!< CMP0SEL (Bit 7)                                       */
#define CMP_CMPSEL0_CMP0SEL_Msk           (0x80UL)                  /*!< CMP0SEL (Bitfield-Mask: 0x01)                         */
/* ========================================================  CMPSEL1  ======================================================== */
#define CMP_CMPSEL1_C1REFS_Pos            (0UL)                     /*!< C1REFS (Bit 0)                                        */
#define CMP_CMPSEL1_C1REFS_Msk            (0x7UL)                   /*!< C1REFS (Bitfield-Mask: 0x07)                          */
#define CMP_CMPSEL1_CMP1SEL_Pos           (6UL)                     /*!< CMP1SEL (Bit 6)                                       */
#define CMP_CMPSEL1_CMP1SEL_Msk           (0xc0UL)                  /*!< CMP1SEL (Bitfield-Mask: 0x03)                         */
/* ========================================================  CMP0HY  ========================================================= */
#define CMP_CMP0HY_C0HYSVS_Pos            (4UL)                     /*!< C0HYSVS (Bit 4)                                       */
#define CMP_CMP0HY_C0HYSVS_Msk            (0x30UL)                  /*!< C0HYSVS (Bitfield-Mask: 0x03)                         */
#define CMP_CMP0HY_C0HYSLS_Pos            (0UL)                     /*!< C0HYSLS (Bit 0)                                       */
#define CMP_CMP0HY_C0HYSLS_Msk            (0x3UL)                   /*!< C0HYSLS (Bitfield-Mask: 0x03)                         */
/* ========================================================  CMP1HY  ========================================================= */
#define CMP_CMP1HY_C1HYSVS_Pos            (4UL)                     /*!< C1HYSVS (Bit 4)                                       */
#define CMP_CMP1HY_C1HYSVS_Msk            (0x30UL)                  /*!< C1HYSVS (Bitfield-Mask: 0x03)                         */
#define CMP_CMP1HY_C1HYSLS_Pos            (0UL)                     /*!< C1HYSLS (Bit 0)                                       */
#define CMP_CMP1HY_C1HYSLS_Msk            (0x3UL)                   /*!< C1HYSLS (Bitfield-Mask: 0x03)                         */


/* =========================================================================================================================== */
/* ================                                            PGA                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  PGA0CTL  ======================================================== */
#define PGA_PGA0CTL_GAIN_Pos              (0UL)                     /*!< GAIN (Bit 0)                                          */
#define PGA_PGA0CTL_GAIN_Msk              (0x7UL)                   /*!< GAIN (Bitfield-Mask: 0x07)                            */
#define PGA_PGA0CTL_MODE_Pos              (3UL)                     /*!< MODE (Bit 3)                                          */
#define PGA_PGA0CTL_MODE_Msk              (0x8UL)                   /*!< MODE (Bitfield-Mask: 0x01)                            */
#define PGA_PGA0CTL_VREF_Pos              (4UL)                     /*!< VREF (Bit 4)                                          */
#define PGA_PGA0CTL_VREF_Msk              (0x10UL)                  /*!< VREF (Bitfield-Mask: 0x01)                            */
#define PGA_PGA0CTL_INS_Pos               (5UL)                     /*!< INS (Bit 5)                                           */
#define PGA_PGA0CTL_INS_Msk               (0x20UL)                  /*!< INS (Bitfield-Mask: 0x01)                             */
#define PGA_PGA0CTL_OUTEN_Pos             (6UL)                     /*!< OUTEN (Bit 6)                                         */
#define PGA_PGA0CTL_OUTEN_Msk             (0x40UL)                  /*!< OUTEN (Bitfield-Mask: 0x01)                           */
#define PGA_PGA0CTL_PGAEN_Pos             (7UL)                     /*!< PGAEN (Bit 7)                                         */
#define PGA_PGA0CTL_PGAEN_Msk             (0x80UL)                  /*!< PGAEN (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                           SCI0                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  SSR00  ========================================================= */
#define SCI0_SSR00_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI0_SSR00_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR00_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI0_SSR00_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR00_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI0_SSR00_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR00_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI0_SSR00_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR00_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI0_SSR00_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SSR01  ========================================================= */
#define SCI0_SSR01_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI0_SSR01_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR01_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI0_SSR01_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR01_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI0_SSR01_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR01_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI0_SSR01_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI0_SSR01_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI0_SSR01_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SIR00  ========================================================= */
#define SCI0_SIR00_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI0_SIR00_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI0_SIR00_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI0_SIR00_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI0_SIR00_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI0_SIR00_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SIR01  ========================================================= */
#define SCI0_SIR01_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI0_SIR01_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI0_SIR01_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI0_SIR01_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI0_SIR01_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI0_SIR01_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SMR00  ========================================================= */
#define SCI0_SMR00_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI0_SMR00_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define SCI0_SMR00_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI0_SMR00_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR00_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI0_SMR00_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR00_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI0_SMR00_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR00_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI0_SMR00_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SMR01  ========================================================= */
#define SCI0_SMR01_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI0_SMR01_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define SCI0_SMR01_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI0_SMR01_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR01_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI0_SMR01_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR01_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI0_SMR01_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI0_SMR01_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI0_SMR01_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR00  ========================================================= */
#define SCI0_SCR00_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI0_SCR00_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI0_SCR00_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI0_SCR00_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI0_SCR00_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI0_SCR00_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR00_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI0_SCR00_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI0_SCR00_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI0_SCR00_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR00_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI0_SCR00_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR00_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI0_SCR00_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR00_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI0_SCR00_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR00_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI0_SCR00_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR01  ========================================================= */
#define SCI0_SCR01_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI0_SCR01_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI0_SCR01_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI0_SCR01_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI0_SCR01_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI0_SCR01_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR01_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI0_SCR01_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI0_SCR01_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI0_SCR01_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR01_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI0_SCR01_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR01_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI0_SCR01_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR01_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI0_SCR01_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI0_SCR01_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI0_SCR01_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* ==========================================================  SE0  ========================================================== */
#define SCI0_SE0_SE00_Pos                 (0UL)                     /*!< SE00 (Bit 0)                                          */
#define SCI0_SE0_SE00_Msk                 (0x1UL)                   /*!< SE00 (Bitfield-Mask: 0x01)                            */
#define SCI0_SE0_SE01_Pos                 (1UL)                     /*!< SE01 (Bit 1)                                          */
#define SCI0_SE0_SE01_Msk                 (0x2UL)                   /*!< SE01 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  SS0  ========================================================== */
#define SCI0_SS0_SS00_Pos                 (0UL)                     /*!< SS00 (Bit 0)                                          */
#define SCI0_SS0_SS00_Msk                 (0x1UL)                   /*!< SS00 (Bitfield-Mask: 0x01)                            */
#define SCI0_SS0_SS01_Pos                 (1UL)                     /*!< SS01 (Bit 1)                                          */
#define SCI0_SS0_SS01_Msk                 (0x2UL)                   /*!< SS01 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  ST0  ========================================================== */
#define SCI0_ST0_ST00_Pos                 (0UL)                     /*!< ST00 (Bit 0)                                          */
#define SCI0_ST0_ST00_Msk                 (0x1UL)                   /*!< ST00 (Bitfield-Mask: 0x01)                            */
#define SCI0_ST0_ST01_Pos                 (1UL)                     /*!< ST01 (Bit 1)                                          */
#define SCI0_ST0_ST01_Msk                 (0x2UL)                   /*!< ST01 (Bitfield-Mask: 0x01)                            */
/* =========================================================  SPS0  ========================================================== */
#define SCI0_SPS0_PRS00_Pos               (0UL)                     /*!< PRS00 (Bit 0)                                         */
#define SCI0_SPS0_PRS00_Msk               (0xfUL)                   /*!< PRS00 (Bitfield-Mask: 0x0f)                           */
#define SCI0_SPS0_PRS01_Pos               (4UL)                     /*!< PRS01 (Bit 4)                                         */
#define SCI0_SPS0_PRS01_Msk               (0xf0UL)                  /*!< PRS01 (Bitfield-Mask: 0x0f)                           */
/* ==========================================================  SO0  ========================================================== */
#define SCI0_SO0_SO00_Pos                 (0UL)                     /*!< SO00 (Bit 0)                                          */
#define SCI0_SO0_SO00_Msk                 (0x1UL)                   /*!< SO00 (Bitfield-Mask: 0x01)                            */
#define SCI0_SO0_SO01_Pos                 (1UL)                     /*!< SO01 (Bit 1)                                          */
#define SCI0_SO0_SO01_Msk                 (0x2UL)                   /*!< SO01 (Bitfield-Mask: 0x01)                            */
#define SCI0_SO0_CKO00_Pos                (8UL)                     /*!< CKO00 (Bit 8)                                         */
#define SCI0_SO0_CKO00_Msk                (0x100UL)                 /*!< CKO00 (Bitfield-Mask: 0x01)                           */
#define SCI0_SO0_CKO01_Pos                (9UL)                     /*!< CKO01 (Bit 9)                                         */
#define SCI0_SO0_CKO01_Msk                (0x200UL)                 /*!< CKO01 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOE0  ========================================================== */
#define SCI0_SOE0_SOE00_Pos               (0UL)                     /*!< SOE00 (Bit 0)                                         */
#define SCI0_SOE0_SOE00_Msk               (0x1UL)                   /*!< SOE00 (Bitfield-Mask: 0x01)                           */
#define SCI0_SOE0_SOE01_Pos               (1UL)                     /*!< SOE01 (Bit 1)                                         */
#define SCI0_SOE0_SOE01_Msk               (0x2UL)                   /*!< SOE01 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOL0  ========================================================== */
#define SCI0_SOL0_SOL00_Pos               (0UL)                     /*!< SOL00 (Bit 0)                                         */
#define SCI0_SOL0_SOL00_Msk               (0x1UL)                   /*!< SOL00 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SSE0  ========================================================== */
#define SCI0_SSE0_SSIE00_Pos              (0UL)                     /*!< SSIE00 (Bit 0)                                        */
#define SCI0_SSE0_SSIE00_Msk              (0x1UL)                   /*!< SSIE00 (Bitfield-Mask: 0x01)                          */
/* =========================================================  SSC0  ========================================================== */
#define SCI0_SSC0_SWC_Pos                 (0UL)                     /*!< SWC (Bit 0)                                           */
#define SCI0_SSC0_SWC_Msk                 (0x1UL)                   /*!< SWC (Bitfield-Mask: 0x01)                             */
#define SCI0_SSC0_SSEC_Pos                (1UL)                     /*!< SSEC (Bit 1)                                          */
#define SCI0_SSC0_SSEC_Msk                (0x2UL)                   /*!< SSEC (Bitfield-Mask: 0x01)                            */
/* =========================================================  SDR00  ========================================================= */
/* =========================================================  SDR01  ========================================================= */
/* =========================================================  SIO00  ========================================================= */
/* =========================================================  SIO01  ========================================================= */
/* =========================================================  TXD0  ========================================================== */
/* =========================================================  RXD0  ========================================================== */


/* =========================================================================================================================== */
/* ================                                           SCI1                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  SSR10  ========================================================= */
#define SCI1_SSR10_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI1_SSR10_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR10_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI1_SSR10_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR10_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI1_SSR10_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR10_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI1_SSR10_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR10_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI1_SSR10_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SSR11  ========================================================= */
#define SCI1_SSR11_OVF_Pos                (0UL)                     /*!< OVF (Bit 0)                                           */
#define SCI1_SSR11_OVF_Msk                (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR11_PEF_Pos                (1UL)                     /*!< PEF (Bit 1)                                           */
#define SCI1_SSR11_PEF_Msk                (0x2UL)                   /*!< PEF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR11_FEF_Pos                (2UL)                     /*!< FEF (Bit 2)                                           */
#define SCI1_SSR11_FEF_Msk                (0x4UL)                   /*!< FEF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR11_BFF_Pos                (5UL)                     /*!< BFF (Bit 5)                                           */
#define SCI1_SSR11_BFF_Msk                (0x20UL)                  /*!< BFF (Bitfield-Mask: 0x01)                             */
#define SCI1_SSR11_TSF_Pos                (6UL)                     /*!< TSF (Bit 6)                                           */
#define SCI1_SSR11_TSF_Msk                (0x40UL)                  /*!< TSF (Bitfield-Mask: 0x01)                             */
/* =========================================================  SIR10  ========================================================= */
#define SCI1_SIR10_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI1_SIR10_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI1_SIR10_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI1_SIR10_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI1_SIR10_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI1_SIR10_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SIR11  ========================================================= */
#define SCI1_SIR11_OVCT_Pos               (0UL)                     /*!< OVCT (Bit 0)                                          */
#define SCI1_SIR11_OVCT_Msk               (0x1UL)                   /*!< OVCT (Bitfield-Mask: 0x01)                            */
#define SCI1_SIR11_PECT_Pos               (1UL)                     /*!< PECT (Bit 1)                                          */
#define SCI1_SIR11_PECT_Msk               (0x2UL)                   /*!< PECT (Bitfield-Mask: 0x01)                            */
#define SCI1_SIR11_FECT_Pos               (2UL)                     /*!< FECT (Bit 2)                                          */
#define SCI1_SIR11_FECT_Msk               (0x4UL)                   /*!< FECT (Bitfield-Mask: 0x01)                            */
/* =========================================================  SMR10  ========================================================= */
#define SCI1_SMR10_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI1_SMR10_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define SCI1_SMR10_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI1_SMR10_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR10_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI1_SMR10_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR10_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI1_SMR10_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR10_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI1_SMR10_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SMR11  ========================================================= */
#define SCI1_SMR11_MD_Pos                 (0UL)                     /*!< MD (Bit 0)                                            */
#define SCI1_SMR11_MD_Msk                 (0xfUL)                   /*!< MD (Bitfield-Mask: 0x0f)                              */
#define SCI1_SMR11_SIS_Pos                (6UL)                     /*!< SIS (Bit 6)                                           */
#define SCI1_SMR11_SIS_Msk                (0x40UL)                  /*!< SIS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR11_STS_Pos                (8UL)                     /*!< STS (Bit 8)                                           */
#define SCI1_SMR11_STS_Msk                (0x100UL)                 /*!< STS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR11_CCS_Pos                (14UL)                    /*!< CCS (Bit 14)                                          */
#define SCI1_SMR11_CCS_Msk                (0x4000UL)                /*!< CCS (Bitfield-Mask: 0x01)                             */
#define SCI1_SMR11_CKS_Pos                (15UL)                    /*!< CKS (Bit 15)                                          */
#define SCI1_SMR11_CKS_Msk                (0x8000UL)                /*!< CKS (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR10  ========================================================= */
#define SCI1_SCR10_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI1_SCR10_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI1_SCR10_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI1_SCR10_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI1_SCR10_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI1_SCR10_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR10_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI1_SCR10_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI1_SCR10_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI1_SCR10_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR10_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI1_SCR10_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR10_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI1_SCR10_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR10_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI1_SCR10_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR10_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI1_SCR10_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* =========================================================  SCR11  ========================================================= */
#define SCI1_SCR11_DLS_Pos                (0UL)                     /*!< DLS (Bit 0)                                           */
#define SCI1_SCR11_DLS_Msk                (0xfUL)                   /*!< DLS (Bitfield-Mask: 0x0f)                             */
#define SCI1_SCR11_SLC_Pos                (4UL)                     /*!< SLC (Bit 4)                                           */
#define SCI1_SCR11_SLC_Msk                (0x30UL)                  /*!< SLC (Bitfield-Mask: 0x03)                             */
#define SCI1_SCR11_DIR_Pos                (7UL)                     /*!< DIR (Bit 7)                                           */
#define SCI1_SCR11_DIR_Msk                (0x80UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR11_PTC_Pos                (8UL)                     /*!< PTC (Bit 8)                                           */
#define SCI1_SCR11_PTC_Msk                (0x300UL)                 /*!< PTC (Bitfield-Mask: 0x03)                             */
#define SCI1_SCR11_EOC_Pos                (10UL)                    /*!< EOC (Bit 10)                                          */
#define SCI1_SCR11_EOC_Msk                (0x400UL)                 /*!< EOC (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR11_CKP_Pos                (12UL)                    /*!< CKP (Bit 12)                                          */
#define SCI1_SCR11_CKP_Msk                (0x1000UL)                /*!< CKP (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR11_DAP_Pos                (13UL)                    /*!< DAP (Bit 13)                                          */
#define SCI1_SCR11_DAP_Msk                (0x2000UL)                /*!< DAP (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR11_RXE_Pos                (14UL)                    /*!< RXE (Bit 14)                                          */
#define SCI1_SCR11_RXE_Msk                (0x4000UL)                /*!< RXE (Bitfield-Mask: 0x01)                             */
#define SCI1_SCR11_TXE_Pos                (15UL)                    /*!< TXE (Bit 15)                                          */
#define SCI1_SCR11_TXE_Msk                (0x8000UL)                /*!< TXE (Bitfield-Mask: 0x01)                             */
/* ==========================================================  SE1  ========================================================== */
#define SCI1_SE1_SE10_Pos                 (0UL)                     /*!< SE10 (Bit 0)                                          */
#define SCI1_SE1_SE10_Msk                 (0x1UL)                   /*!< SE10 (Bitfield-Mask: 0x01)                            */
#define SCI1_SE1_SE11_Pos                 (1UL)                     /*!< SE11 (Bit 1)                                          */
#define SCI1_SE1_SE11_Msk                 (0x2UL)                   /*!< SE11 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  SS1  ========================================================== */
#define SCI1_SS1_SS10_Pos                 (0UL)                     /*!< SS10 (Bit 0)                                          */
#define SCI1_SS1_SS10_Msk                 (0x1UL)                   /*!< SS10 (Bitfield-Mask: 0x01)                            */
#define SCI1_SS1_SS11_Pos                 (1UL)                     /*!< SS11 (Bit 1)                                          */
#define SCI1_SS1_SS11_Msk                 (0x2UL)                   /*!< SS11 (Bitfield-Mask: 0x01)                            */
/* ==========================================================  ST1  ========================================================== */
#define SCI1_ST1_ST10_Pos                 (0UL)                     /*!< ST10 (Bit 0)                                          */
#define SCI1_ST1_ST10_Msk                 (0x1UL)                   /*!< ST10 (Bitfield-Mask: 0x01)                            */
#define SCI1_ST1_ST11_Pos                 (1UL)                     /*!< ST11 (Bit 1)                                          */
#define SCI1_ST1_ST11_Msk                 (0x2UL)                   /*!< ST11 (Bitfield-Mask: 0x01)                            */
/* =========================================================  SPS1  ========================================================== */
#define SCI1_SPS1_PRS10_Pos               (0UL)                     /*!< PRS10 (Bit 0)                                         */
#define SCI1_SPS1_PRS10_Msk               (0xfUL)                   /*!< PRS10 (Bitfield-Mask: 0x0f)                           */
#define SCI1_SPS1_PRS11_Pos               (4UL)                     /*!< PRS11 (Bit 4)                                         */
#define SCI1_SPS1_PRS11_Msk               (0xf0UL)                  /*!< PRS11 (Bitfield-Mask: 0x0f)                           */
/* ==========================================================  SO1  ========================================================== */
#define SCI1_SO1_SO10_Pos                 (0UL)                     /*!< SO10 (Bit 0)                                          */
#define SCI1_SO1_SO10_Msk                 (0x1UL)                   /*!< SO10 (Bitfield-Mask: 0x01)                            */
#define SCI1_SO1_SO11_Pos                 (1UL)                     /*!< SO11 (Bit 1)                                          */
#define SCI1_SO1_SO11_Msk                 (0x2UL)                   /*!< SO11 (Bitfield-Mask: 0x01)                            */
#define SCI1_SO1_CKO10_Pos                (8UL)                     /*!< CKO10 (Bit 8)                                         */
#define SCI1_SO1_CKO10_Msk                (0x100UL)                 /*!< CKO10 (Bitfield-Mask: 0x01)                           */
#define SCI1_SO1_CKO11_Pos                (9UL)                     /*!< CKO11 (Bit 9)                                         */
#define SCI1_SO1_CKO11_Msk                (0x200UL)                 /*!< CKO11 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOE1  ========================================================== */
#define SCI1_SOE1_SOE10_Pos               (0UL)                     /*!< SOE10 (Bit 0)                                         */
#define SCI1_SOE1_SOE10_Msk               (0x1UL)                   /*!< SOE10 (Bitfield-Mask: 0x01)                           */
#define SCI1_SOE1_SOE11_Pos               (1UL)                     /*!< SOE11 (Bit 1)                                         */
#define SCI1_SOE1_SOE11_Msk               (0x2UL)                   /*!< SOE11 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SOL1  ========================================================== */
#define SCI1_SOL1_SOL10_Pos               (0UL)                     /*!< SOL10 (Bit 0)                                         */
#define SCI1_SOL1_SOL10_Msk               (0x1UL)                   /*!< SOL10 (Bitfield-Mask: 0x01)                           */
/* =========================================================  SSC1  ========================================================== */
#define SCI1_SSC1_SWC_Pos                 (0UL)                     /*!< SWC (Bit 0)                                           */
#define SCI1_SSC1_SWC_Msk                 (0x1UL)                   /*!< SWC (Bitfield-Mask: 0x01)                             */
#define SCI1_SSC1_SSEC_Pos                (1UL)                     /*!< SSEC (Bit 1)                                          */
#define SCI1_SSC1_SSEC_Msk                (0x2UL)                   /*!< SSEC (Bitfield-Mask: 0x01)                            */
/* =========================================================  SDR10  ========================================================= */
/* =========================================================  SDR11  ========================================================= */
/* =========================================================  SIO20  ========================================================= */
/* =========================================================  SIO21  ========================================================= */
/* =========================================================  TXD2  ========================================================== */
/* =========================================================  RXD2  ========================================================== */


/* =========================================================================================================================== */
/* ================                                          SPIHS0                                           ================ */
/* =========================================================================================================================== */

/* =========================================================  SPIM  ========================================================== */
#define SPIHS0_SPIM_RECMD_Pos             (1UL)                     /*!< RECMD (Bit 1)                                         */
#define SPIHS0_SPIM_RECMD_Msk             (0x2UL)                   /*!< RECMD (Bitfield-Mask: 0x01)                           */
#define SPIHS0_SPIM_DLS_Pos               (2UL)                     /*!< DLS (Bit 2)                                           */
#define SPIHS0_SPIM_DLS_Msk               (0x4UL)                   /*!< DLS (Bitfield-Mask: 0x01)                             */
#define SPIHS0_SPIM_INTMD_Pos             (3UL)                     /*!< INTMD (Bit 3)                                         */
#define SPIHS0_SPIM_INTMD_Msk             (0x8UL)                   /*!< INTMD (Bitfield-Mask: 0x01)                           */
#define SPIHS0_SPIM_DIR_Pos               (4UL)                     /*!< DIR (Bit 4)                                           */
#define SPIHS0_SPIM_DIR_Msk               (0x10UL)                  /*!< DIR (Bitfield-Mask: 0x01)                             */
#define SPIHS0_SPIM_NSSE_Pos              (5UL)                     /*!< NSSE (Bit 5)                                          */
#define SPIHS0_SPIM_NSSE_Msk              (0x20UL)                  /*!< NSSE (Bitfield-Mask: 0x01)                            */
#define SPIHS0_SPIM_TRMD_Pos              (6UL)                     /*!< TRMD (Bit 6)                                          */
#define SPIHS0_SPIM_TRMD_Msk              (0x40UL)                  /*!< TRMD (Bitfield-Mask: 0x01)                            */
#define SPIHS0_SPIM_SPIE_Pos              (7UL)                     /*!< SPIE (Bit 7)                                          */
#define SPIHS0_SPIM_SPIE_Msk              (0x80UL)                  /*!< SPIE (Bitfield-Mask: 0x01)                            */
/* =========================================================  SPIC  ========================================================== */
#define SPIHS0_SPIC_CKS_Pos               (0UL)                     /*!< CKS (Bit 0)                                           */
#define SPIHS0_SPIC_CKS_Msk               (0x7UL)                   /*!< CKS (Bitfield-Mask: 0x07)                             */
#define SPIHS0_SPIC_CPHA_Pos              (3UL)                     /*!< CPHA (Bit 3)                                          */
#define SPIHS0_SPIC_CPHA_Msk              (0x8UL)                   /*!< CPHA (Bitfield-Mask: 0x01)                            */
#define SPIHS0_SPIC_CPOL_Pos              (4UL)                     /*!< CPOL (Bit 4)                                          */
#define SPIHS0_SPIC_CPOL_Msk              (0x10UL)                  /*!< CPOL (Bitfield-Mask: 0x01)                            */
/* =========================================================  SDRO  ========================================================== */
/* =========================================================  SDRI  ========================================================== */
/* =========================================================  SPIS  ========================================================== */
#define SPIHS0_SPIS_SPTF_Pos              (0UL)                     /*!< SPTF (Bit 0)                                          */
#define SPIHS0_SPIS_SPTF_Msk              (0x1UL)                   /*!< SPTF (Bitfield-Mask: 0x01)                            */
#define SPIHS0_SPIS_SDRIF_Pos             (1UL)                     /*!< SDRIF (Bit 1)                                         */
#define SPIHS0_SPIS_SDRIF_Msk             (0x2UL)                   /*!< SDRIF (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                           IICA                                            ================ */
/* =========================================================================================================================== */

/* =======================================================  IICCTL00  ======================================================== */
#define IICA_IICCTL00_SPT_Pos             (0UL)                     /*!< SPT (Bit 0)                                           */
#define IICA_IICCTL00_SPT_Msk             (0x1UL)                   /*!< SPT (Bitfield-Mask: 0x01)                             */
#define IICA_IICCTL00_STT_Pos             (1UL)                     /*!< STT (Bit 1)                                           */
#define IICA_IICCTL00_STT_Msk             (0x2UL)                   /*!< STT (Bitfield-Mask: 0x01)                             */
#define IICA_IICCTL00_ACKE_Pos            (2UL)                     /*!< ACKE (Bit 2)                                          */
#define IICA_IICCTL00_ACKE_Msk            (0x4UL)                   /*!< ACKE (Bitfield-Mask: 0x01)                            */
#define IICA_IICCTL00_WTIM_Pos            (3UL)                     /*!< WTIM (Bit 3)                                          */
#define IICA_IICCTL00_WTIM_Msk            (0x8UL)                   /*!< WTIM (Bitfield-Mask: 0x01)                            */
#define IICA_IICCTL00_SPIE_Pos            (4UL)                     /*!< SPIE (Bit 4)                                          */
#define IICA_IICCTL00_SPIE_Msk            (0x10UL)                  /*!< SPIE (Bitfield-Mask: 0x01)                            */
#define IICA_IICCTL00_WREL_Pos            (5UL)                     /*!< WREL (Bit 5)                                          */
#define IICA_IICCTL00_WREL_Msk            (0x20UL)                  /*!< WREL (Bitfield-Mask: 0x01)                            */
#define IICA_IICCTL00_LREL_Pos            (6UL)                     /*!< LREL (Bit 6)                                          */
#define IICA_IICCTL00_LREL_Msk            (0x40UL)                  /*!< LREL (Bitfield-Mask: 0x01)                            */
#define IICA_IICCTL00_IICE_Pos            (7UL)                     /*!< IICE (Bit 7)                                          */
#define IICA_IICCTL00_IICE_Msk            (0x80UL)                  /*!< IICE (Bitfield-Mask: 0x01)                            */
/* =======================================================  IICCTL01  ======================================================== */
#define IICA_IICCTL01_PRS_Pos             (0UL)                     /*!< PRS (Bit 0)                                           */
#define IICA_IICCTL01_PRS_Msk             (0x1UL)                   /*!< PRS (Bitfield-Mask: 0x01)                             */
#define IICA_IICCTL01_DFC_Pos             (2UL)                     /*!< DFC (Bit 2)                                           */
#define IICA_IICCTL01_DFC_Msk             (0x4UL)                   /*!< DFC (Bitfield-Mask: 0x01)                             */
#define IICA_IICCTL01_SMC_Pos             (3UL)                     /*!< SMC (Bit 3)                                           */
#define IICA_IICCTL01_SMC_Msk             (0x8UL)                   /*!< SMC (Bitfield-Mask: 0x01)                             */
#define IICA_IICCTL01_DAD_Pos             (4UL)                     /*!< DAD (Bit 4)                                           */
#define IICA_IICCTL01_DAD_Msk             (0x10UL)                  /*!< DAD (Bitfield-Mask: 0x01)                             */
#define IICA_IICCTL01_CLD_Pos             (5UL)                     /*!< CLD (Bit 5)                                           */
#define IICA_IICCTL01_CLD_Msk             (0x20UL)                  /*!< CLD (Bitfield-Mask: 0x01)                             */
#define IICA_IICCTL01_WUP_Pos             (7UL)                     /*!< WUP (Bit 7)                                           */
#define IICA_IICCTL01_WUP_Msk             (0x80UL)                  /*!< WUP (Bitfield-Mask: 0x01)                             */
/* ========================================================  IICWL0  ========================================================= */
/* ========================================================  IICWH0  ========================================================= */
/* =========================================================  SVA0  ========================================================== */
/* =========================================================  SVA1  ========================================================== */
/* ========================================================  IICSE0  ========================================================= */
/* =========================================================  IICA0  ========================================================= */
/* =========================================================  IICS0  ========================================================= */
#define IICA_IICS0_MSTS_Pos               (7UL)                     /*!< MSTS (Bit 7)                                          */
#define IICA_IICS0_MSTS_Msk               (0x80UL)                  /*!< MSTS (Bitfield-Mask: 0x01)                            */
#define IICA_IICS0_ALD_Pos                (6UL)                     /*!< ALD (Bit 6)                                           */
#define IICA_IICS0_ALD_Msk                (0x40UL)                  /*!< ALD (Bitfield-Mask: 0x01)                             */
#define IICA_IICS0_EXC_Pos                (5UL)                     /*!< EXC (Bit 5)                                           */
#define IICA_IICS0_EXC_Msk                (0x20UL)                  /*!< EXC (Bitfield-Mask: 0x01)                             */
#define IICA_IICS0_COI_Pos                (4UL)                     /*!< COI (Bit 4)                                           */
#define IICA_IICS0_COI_Msk                (0x10UL)                  /*!< COI (Bitfield-Mask: 0x01)                             */
#define IICA_IICS0_TRC_Pos                (3UL)                     /*!< TRC (Bit 3)                                           */
#define IICA_IICS0_TRC_Msk                (0x8UL)                   /*!< TRC (Bitfield-Mask: 0x01)                             */
#define IICA_IICS0_ACKD_Pos               (2UL)                     /*!< ACKD (Bit 2)                                          */
#define IICA_IICS0_ACKD_Msk               (0x4UL)                   /*!< ACKD (Bitfield-Mask: 0x01)                            */
#define IICA_IICS0_STD_Pos                (1UL)                     /*!< STD (Bit 1)                                           */
#define IICA_IICS0_STD_Msk                (0x2UL)                   /*!< STD (Bitfield-Mask: 0x01)                             */
#define IICA_IICS0_SPD_Pos                (0UL)                     /*!< SPD (Bit 0)                                           */
#define IICA_IICS0_SPD_Msk                (0x1UL)                   /*!< SPD (Bitfield-Mask: 0x01)                             */
/* =========================================================  IICF0  ========================================================= */
#define IICA_IICF0_STCF_Pos               (7UL)                     /*!< STCF (Bit 7)                                          */
#define IICA_IICF0_STCF_Msk               (0x80UL)                  /*!< STCF (Bitfield-Mask: 0x01)                            */
#define IICA_IICF0_IICBSY_Pos             (6UL)                     /*!< IICBSY (Bit 6)                                        */
#define IICA_IICF0_IICBSY_Msk             (0x40UL)                  /*!< IICBSY (Bitfield-Mask: 0x01)                          */
#define IICA_IICF0_STCEN_Pos              (1UL)                     /*!< STCEN (Bit 1)                                         */
#define IICA_IICF0_STCEN_Msk              (0x2UL)                   /*!< STCEN (Bitfield-Mask: 0x01)                           */
#define IICA_IICF0_IICRSV_Pos             (0UL)                     /*!< IICRSV (Bit 0)                                        */
#define IICA_IICF0_IICRSV_Msk             (0x1UL)                   /*!< IICRSV (Bitfield-Mask: 0x01)                          */


/* =========================================================================================================================== */
/* ================                                           IRDA                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  IRCR  ========================================================== */
#define IRDA_IRCR_IRRXINV_Pos             (2UL)                     /*!< IRRXINV (Bit 2)                                       */
#define IRDA_IRCR_IRRXINV_Msk             (0x4UL)                   /*!< IRRXINV (Bitfield-Mask: 0x01)                         */
#define IRDA_IRCR_IRTXINV_Pos             (3UL)                     /*!< IRTXINV (Bit 3)                                       */
#define IRDA_IRCR_IRTXINV_Msk             (0x8UL)                   /*!< IRTXINV (Bitfield-Mask: 0x01)                         */
#define IRDA_IRCR_IRCKS_Pos               (4UL)                     /*!< IRCKS (Bit 4)                                         */
#define IRDA_IRCR_IRCKS_Msk               (0x70UL)                  /*!< IRCKS (Bitfield-Mask: 0x07)                           */
#define IRDA_IRCR_IRE_Pos                 (7UL)                     /*!< IRE (Bit 7)                                           */
#define IRDA_IRCR_IRE_Msk                 (0x80UL)                  /*!< IRE (Bitfield-Mask: 0x01)                             */


/* =========================================================================================================================== */
/* ================                                            DMA                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  DMAEN0  ========================================================= */
/* ========================================================  DMAEN1  ========================================================= */
/* ========================================================  DMAEN2  ========================================================= */
/* ========================================================  DMAEN3  ========================================================= */
/* ========================================================  DMAEN4  ========================================================= */
/* ========================================================  DMABAR  ========================================================= */
/* ========================================================  IFPRCR  ========================================================= */
/* ========================================================  DMAIF0  ========================================================= */
/* ========================================================  DMAIF1  ========================================================= */
/* ========================================================  DMAIF2  ========================================================= */
/* ========================================================  DMAIF3  ========================================================= */
/* ========================================================  DMAIF4  ========================================================= */
/* ========================================================  DMASET0  ======================================================== */
/* ========================================================  DMASET1  ======================================================== */
/* ========================================================  DMASET2  ======================================================== */
/* ========================================================  DMASET3  ======================================================== */
/* ========================================================  DMASET4  ======================================================== */
/* ========================================================  DMACLR0  ======================================================== */
/* ========================================================  DMACLR1  ======================================================== */
/* ========================================================  DMACLR2  ======================================================== */
/* ========================================================  DMACLR3  ======================================================== */
/* ========================================================  DMACLR4  ======================================================== */


/* =========================================================================================================================== */
/* ================                                          DMAVEC                                           ================ */
/* =========================================================================================================================== */

/* ==========================================================  VEC  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            ELC                                            ================ */
/* =========================================================================================================================== */

/* =======================================================  ELSELR00  ======================================================== */
/* =======================================================  ELSELR01  ======================================================== */
/* =======================================================  ELSELR02  ======================================================== */
/* =======================================================  ELSELR03  ======================================================== */
/* =======================================================  ELSELR04  ======================================================== */
/* =======================================================  ELSELR05  ======================================================== */
/* =======================================================  ELSELR06  ======================================================== */
/* =======================================================  ELSELR07  ======================================================== */
/* =======================================================  ELSELR08  ======================================================== */
/* =======================================================  ELSELR09  ======================================================== */
/* =======================================================  ELSELR10  ======================================================== */
/* =======================================================  ELSELR11  ======================================================== */
/* =======================================================  ELSELR12  ======================================================== */
/* =======================================================  ELSELR13  ======================================================== */
/* =======================================================  ELSELR14  ======================================================== */
/* =======================================================  ELSELR15  ======================================================== */
/* =======================================================  ELSELR16  ======================================================== */
/* =======================================================  ELSELR17  ======================================================== */
/* =======================================================  ELSELR18  ======================================================== */
/* =======================================================  ELSELR19  ======================================================== */
/* =======================================================  ELSELR20  ======================================================== */
/* =======================================================  ELSELR21  ======================================================== */


/* =========================================================================================================================== */
/* ================                                            INT                                            ================ */
/* =========================================================================================================================== */



/* =========================================================================================================================== */
/* ================                                           INTM                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  EGP0  ========================================================== */
#define INTM_EGP0_EGP0_Pos                (0UL)                     /*!< EGP0 (Bit 0)                                          */
#define INTM_EGP0_EGP0_Msk                (0x1UL)                   /*!< EGP0 (Bitfield-Mask: 0x01)                            */
#define INTM_EGP0_EGP1_Pos                (1UL)                     /*!< EGP1 (Bit 1)                                          */
#define INTM_EGP0_EGP1_Msk                (0x2UL)                   /*!< EGP1 (Bitfield-Mask: 0x01)                            */
#define INTM_EGP0_EGP2_Pos                (2UL)                     /*!< EGP2 (Bit 2)                                          */
#define INTM_EGP0_EGP2_Msk                (0x4UL)                   /*!< EGP2 (Bitfield-Mask: 0x01)                            */
#define INTM_EGP0_EGP3_Pos                (3UL)                     /*!< EGP3 (Bit 3)                                          */
#define INTM_EGP0_EGP3_Msk                (0x8UL)                   /*!< EGP3 (Bitfield-Mask: 0x01)                            */
#define INTM_EGP0_EGP4_Pos                (4UL)                     /*!< EGP4 (Bit 4)                                          */
#define INTM_EGP0_EGP4_Msk                (0x10UL)                  /*!< EGP4 (Bitfield-Mask: 0x01)                            */
#define INTM_EGP0_EGP5_Pos                (5UL)                     /*!< EGP5 (Bit 5)                                          */
#define INTM_EGP0_EGP5_Msk                (0x20UL)                  /*!< EGP5 (Bitfield-Mask: 0x01)                            */
#define INTM_EGP0_EGP6_Pos                (6UL)                     /*!< EGP6 (Bit 6)                                          */
#define INTM_EGP0_EGP6_Msk                (0x40UL)                  /*!< EGP6 (Bitfield-Mask: 0x01)                            */
#define INTM_EGP0_EGP7_Pos                (7UL)                     /*!< EGP7 (Bit 7)                                          */
#define INTM_EGP0_EGP7_Msk                (0x80UL)                  /*!< EGP7 (Bitfield-Mask: 0x01)                            */
/* =========================================================  EGN0  ========================================================== */
#define INTM_EGN0_EGN0_Pos                (0UL)                     /*!< EGN0 (Bit 0)                                          */
#define INTM_EGN0_EGN0_Msk                (0x1UL)                   /*!< EGN0 (Bitfield-Mask: 0x01)                            */
#define INTM_EGN0_EGN1_Pos                (1UL)                     /*!< EGN1 (Bit 1)                                          */
#define INTM_EGN0_EGN1_Msk                (0x2UL)                   /*!< EGN1 (Bitfield-Mask: 0x01)                            */
#define INTM_EGN0_EGN2_Pos                (2UL)                     /*!< EGN2 (Bit 2)                                          */
#define INTM_EGN0_EGN2_Msk                (0x4UL)                   /*!< EGN2 (Bitfield-Mask: 0x01)                            */
#define INTM_EGN0_EGN3_Pos                (3UL)                     /*!< EGN3 (Bit 3)                                          */
#define INTM_EGN0_EGN3_Msk                (0x8UL)                   /*!< EGN3 (Bitfield-Mask: 0x01)                            */
#define INTM_EGN0_EGN4_Pos                (4UL)                     /*!< EGN4 (Bit 4)                                          */
#define INTM_EGN0_EGN4_Msk                (0x10UL)                  /*!< EGN4 (Bitfield-Mask: 0x01)                            */
#define INTM_EGN0_EGN5_Pos                (5UL)                     /*!< EGN5 (Bit 5)                                          */
#define INTM_EGN0_EGN5_Msk                (0x20UL)                  /*!< EGN5 (Bitfield-Mask: 0x01)                            */
#define INTM_EGN0_EGN6_Pos                (6UL)                     /*!< EGN6 (Bit 6)                                          */
#define INTM_EGN0_EGN6_Msk                (0x40UL)                  /*!< EGN6 (Bitfield-Mask: 0x01)                            */
#define INTM_EGN0_EGN7_Pos                (7UL)                     /*!< EGN7 (Bit 7)                                          */
#define INTM_EGN0_EGN7_Msk                (0x80UL)                  /*!< EGN7 (Bitfield-Mask: 0x01)                            */
/* =========================================================  EGP1  ========================================================== */
#define INTM_EGP1_EGP8_Pos                (0UL)                     /*!< EGP8 (Bit 0)                                          */
#define INTM_EGP1_EGP8_Msk                (0x1UL)                   /*!< EGP8 (Bitfield-Mask: 0x01)                            */
#define INTM_EGP1_EGP9_Pos                (1UL)                     /*!< EGP9 (Bit 1)                                          */
#define INTM_EGP1_EGP9_Msk                (0x2UL)                   /*!< EGP9 (Bitfield-Mask: 0x01)                            */
#define INTM_EGP1_EGP10_Pos               (2UL)                     /*!< EGP10 (Bit 2)                                         */
#define INTM_EGP1_EGP10_Msk               (0x4UL)                   /*!< EGP10 (Bitfield-Mask: 0x01)                           */
#define INTM_EGP1_EGP11_Pos               (3UL)                     /*!< EGP11 (Bit 3)                                         */
#define INTM_EGP1_EGP11_Msk               (0x8UL)                   /*!< EGP11 (Bitfield-Mask: 0x01)                           */
/* =========================================================  EGN1  ========================================================== */
#define INTM_EGN1_EGN8_Pos                (0UL)                     /*!< EGN8 (Bit 0)                                          */
#define INTM_EGN1_EGN8_Msk                (0x1UL)                   /*!< EGN8 (Bitfield-Mask: 0x01)                            */
#define INTM_EGN1_EGN9_Pos                (1UL)                     /*!< EGN9 (Bit 1)                                          */
#define INTM_EGN1_EGN9_Msk                (0x2UL)                   /*!< EGN9 (Bitfield-Mask: 0x01)                            */
#define INTM_EGN1_EGN10_Pos               (2UL)                     /*!< EGN10 (Bit 2)                                         */
#define INTM_EGN1_EGN10_Msk               (0x4UL)                   /*!< EGN10 (Bitfield-Mask: 0x01)                           */
#define INTM_EGN1_EGN11_Pos               (3UL)                     /*!< EGN11 (Bit 3)                                         */
#define INTM_EGN1_EGN11_Msk               (0x8UL)                   /*!< EGN11 (Bitfield-Mask: 0x01)                           */


/* =========================================================================================================================== */
/* ================                                           MISC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  NFEN0  ========================================================= */
#define MISC_NFEN0_SNFEN00_Pos            (0UL)                     /*!< SNFEN00 (Bit 0)                                       */
#define MISC_NFEN0_SNFEN00_Msk            (0x1UL)                   /*!< SNFEN00 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN0_SNFEN10_Pos            (2UL)                     /*!< SNFEN10 (Bit 2)                                       */
#define MISC_NFEN0_SNFEN10_Msk            (0x4UL)                   /*!< SNFEN10 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN0_SNFEN20_Pos            (4UL)                     /*!< SNFEN20 (Bit 4)                                       */
#define MISC_NFEN0_SNFEN20_Msk            (0x10UL)                  /*!< SNFEN20 (Bitfield-Mask: 0x01)                         */
/* =========================================================  NFEN1  ========================================================= */
#define MISC_NFEN1_TNFEN00_Pos            (0UL)                     /*!< TNFEN00 (Bit 0)                                       */
#define MISC_NFEN1_TNFEN00_Msk            (0x1UL)                   /*!< TNFEN00 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN1_TNFEN01_Pos            (1UL)                     /*!< TNFEN01 (Bit 1)                                       */
#define MISC_NFEN1_TNFEN01_Msk            (0x2UL)                   /*!< TNFEN01 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN1_TNFEN02_Pos            (2UL)                     /*!< TNFEN02 (Bit 2)                                       */
#define MISC_NFEN1_TNFEN02_Msk            (0x4UL)                   /*!< TNFEN02 (Bitfield-Mask: 0x01)                         */
#define MISC_NFEN1_TNFEN03_Pos            (3UL)                     /*!< TNFEN03 (Bit 3)                                       */
#define MISC_NFEN1_TNFEN03_Msk            (0x8UL)                   /*!< TNFEN03 (Bitfield-Mask: 0x01)                         */
/* ==========================================================  ISC  ========================================================== */
#define MISC_ISC_ISC0_Pos                 (0UL)                     /*!< ISC0 (Bit 0)                                          */
#define MISC_ISC_ISC0_Msk                 (0x1UL)                   /*!< ISC0 (Bitfield-Mask: 0x01)                            */
#define MISC_ISC_ISC1_Pos                 (1UL)                     /*!< ISC1 (Bit 1)                                          */
#define MISC_ISC_ISC1_Msk                 (0x2UL)                   /*!< ISC1 (Bitfield-Mask: 0x01)                            */
#define MISC_ISC_ISC2_Pos                 (2UL)                     /*!< ISC2 (Bit 2)                                          */
#define MISC_ISC_ISC2_Msk                 (0x4UL)                   /*!< ISC2 (Bitfield-Mask: 0x01)                            */
#define MISC_ISC_SSIE00_Pos               (7UL)                     /*!< SSIE00 (Bit 7)                                        */
#define MISC_ISC_SSIE00_Msk               (0x80UL)                  /*!< SSIE00 (Bitfield-Mask: 0x01)                          */
/* =========================================================  TIOS0  ========================================================= */
/* =========================================================  TIOS1  ========================================================= */
/* ========================================================  VREFCTL  ======================================================== */
#define MISC_VREFCTL_VREFEN_Pos           (0UL)                     /*!< VREFEN (Bit 0)                                        */
#define MISC_VREFCTL_VREFEN_Msk           (0x1UL)                   /*!< VREFEN (Bitfield-Mask: 0x01)                          */
#define MISC_VREFCTL_VREFSEL_Pos          (1UL)                     /*!< VREFSEL (Bit 1)                                       */
#define MISC_VREFCTL_VREFSEL_Msk          (0x2UL)                   /*!< VREFSEL (Bitfield-Mask: 0x01)                         */


/* =========================================================================================================================== */
/* ================                                            FMC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  FLSTS  ========================================================= */
#define FMC_FLSTS_OVF_Pos                 (0UL)                     /*!< OVF (Bit 0)                                           */
#define FMC_FLSTS_OVF_Msk                 (0x1UL)                   /*!< OVF (Bitfield-Mask: 0x01)                             */
#define FMC_FLSTS_EVF_Pos                 (2UL)                     /*!< EVF (Bit 2)                                           */
#define FMC_FLSTS_EVF_Msk                 (0x4UL)                   /*!< EVF (Bitfield-Mask: 0x01)                             */
/* ========================================================  FLOPMD1  ======================================================== */
/* ========================================================  FLOPMD2  ======================================================== */
/* ========================================================  FLERMD  ========================================================= */
/* =======================================================  FLCERCNT  ======================================================== */
/* =======================================================  FLSERCNT  ======================================================== */
/* =======================================================  FLPROCNT  ======================================================== */
/* ========================================================  FLPROT  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            SAF                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  CRC0CTL  ======================================================== */
#define SAF_CRC0CTL_CRC0EN_Pos            (7UL)                     /*!< CRC0EN (Bit 7)                                        */
#define SAF_CRC0CTL_CRC0EN_Msk            (0x80UL)                  /*!< CRC0EN (Bitfield-Mask: 0x01)                          */
#define SAF_CRC0CTL_FEA_Pos               (0UL)                     /*!< FEA (Bit 0)                                           */
#define SAF_CRC0CTL_FEA_Msk               (0x7fUL)                  /*!< FEA (Bitfield-Mask: 0x7f)                             */
/* ========================================================  PGCRCL  ========================================================= */
/* =========================================================  CRCIN  ========================================================= */
/* =========================================================  CRCD  ========================================================== */
/* ========================================================  RPECTL  ========================================================= */
#define SAF_RPECTL_RPEF_Pos               (0UL)                     /*!< RPEF (Bit 0)                                          */
#define SAF_RPECTL_RPEF_Msk               (0x1UL)                   /*!< RPEF (Bitfield-Mask: 0x01)                            */
#define SAF_RPECTL_RPERDIS_Pos            (7UL)                     /*!< RPERDIS (Bit 7)                                       */
#define SAF_RPECTL_RPERDIS_Msk            (0x80UL)                  /*!< RPERDIS (Bitfield-Mask: 0x01)                         */
/* =========================================================  SFRGD  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            CRC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  CRCD  ========================================================== */
/* =========================================================  CRCIN  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            DBG                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  DBGSTR  ========================================================= */
#define DBG_DBGSTR_CDBGPWRUPACK_Pos       (29UL)                    /*!< CDBGPWRUPACK (Bit 29)                                 */
#define DBG_DBGSTR_CDBGPWRUPACK_Msk       (0x20000000UL)            /*!< CDBGPWRUPACK (Bitfield-Mask: 0x01)                    */
#define DBG_DBGSTR_CDBGPWRUPREQ_Pos       (28UL)                    /*!< CDBGPWRUPREQ (Bit 28)                                 */
#define DBG_DBGSTR_CDBGPWRUPREQ_Msk       (0x10000000UL)            /*!< CDBGPWRUPREQ (Bitfield-Mask: 0x01)                    */
/* =======================================================  DBGSTOPCR  ======================================================= */
#define DBG_DBGSTOPCR_SWDIS_Pos           (24UL)                    /*!< SWDIS (Bit 24)                                        */
#define DBG_DBGSTOPCR_SWDIS_Msk           (0x1000000UL)             /*!< SWDIS (Bitfield-Mask: 0x01)                           */
#define DBG_DBGSTOPCR_RPERMSK_Pos         (16UL)                    /*!< RPERMSK (Bit 16)                                      */
#define DBG_DBGSTOPCR_RPERMSK_Msk         (0x10000UL)               /*!< RPERMSK (Bitfield-Mask: 0x01)                         */
#define DBG_DBGSTOPCR_RESMSK_Pos          (2UL)                     /*!< RESMSK (Bit 2)                                        */
#define DBG_DBGSTOPCR_RESMSK_Msk          (0x4UL)                   /*!< RESMSK (Bitfield-Mask: 0x01)                          */
#define DBG_DBGSTOPCR_FRZEN1_Pos          (1UL)                     /*!< FRZEN1 (Bit 1)                                        */
#define DBG_DBGSTOPCR_FRZEN1_Msk          (0x2UL)                   /*!< FRZEN1 (Bitfield-Mask: 0x01)                          */
#define DBG_DBGSTOPCR_FRZEN0_Pos          (0UL)                     /*!< FRZEN0 (Bit 0)                                        */
#define DBG_DBGSTOPCR_FRZEN0_Msk          (0x1UL)                   /*!< FRZEN0 (Bitfield-Mask: 0x01)                          */


/* =========================================================================================================================== */
/* ================                                            BGR                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  VBG85  ========================================================= */
/* =========================================================  VBG25  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            TSN                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  TSN85  ========================================================= */
/* =========================================================  TSN25  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            UID                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  UID0  ========================================================== */
/* =========================================================  UID1  ========================================================== */
/* =========================================================  UID2  ========================================================== */
/* =========================================================  UID3  ========================================================== */

/** @} */ /* End of group PosMask_peripherals */


#ifdef __cplusplus
}
#endif

#endif /* BAT32G113_H */


/** @} */ /* End of group BAT32G113 */

/** @} */ /* End of group CMS */
